/* Copyright 2000,2001 Hiroshi Watabe*/
/* $Id: callbacks.c,v 1.15 2001/11/13 23:39:19 watabe Exp $ */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "gpetview.h"

extern void draw_colorbar();
GtkWidget *filewindow;
GtkWidget *settingshell;
GtkWidget *hdr_info_window;
char *fname = NULL;
gushort originY=0,originY2 = 0;
gushort newY = 0, newY2 = 0;
guchar roi_draw_flag = 0;
guchar roi_flag = 0;
guchar pre_roi_flag = 0;
guchar overwrite_flag = 0;
guchar import_flag = 0;
guchar hdr_swap_flag = 0;
guchar roi_mask_flag = ROI_MASK_IN;
extern guchar window_ready_flag;

void
on_image_file_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show (filewindow);
}


void
on_image_no_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_clear_screen_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *clear_dialog;
  clear_dialog = create_clear_dialog ();
  gtk_widget_show (clear_dialog);
}


void
on_roi_activate                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(view_flag==0) return;
  if(roi_flag!=0) roi_draw_flag = 1;
  gtk_widget_show (roiwindow);
}


void
on_setting_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show(settingshell);
}


void
on_filter_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_view_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_roi_info_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show (roi_info_window);
}


void
on_header_info_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  hdr_info_window = create_hdr_info_window ();
  gtk_widget_show (hdr_info_window);
  hdr_info(hdr_info_window);
}


void
on_set_num_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    numbering_flag = 1;
  }
  else{
    numbering_flag = 0;
  }
}


void
on_help_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *aboutDialog;
  aboutDialog = create_aboutDialog ();
  gtk_widget_show (aboutDialog);

}


void
on_ok_about_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *wid;
  wid = user_data;
  gtk_widget_hide(wid);
}


void
on_select_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_show (fileselection);

}


void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(user_data);
}


void
yes_quit_button_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_exit(0);
}


void
on_no_button_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(user_data);
}


void
on_quit_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *yes_no_dialog;
  yes_no_dialog = create_yes_no_dialog ();
  gtk_widget_show (yes_no_dialog);

}


gboolean
on_colorbar_expose_event               (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  draw_colorbar();
  return FALSE;
}

void
on_set_done_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(user_data);
}


void
on_cancel_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(user_data);
  
}

void
on_set_rainbow_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    color_flag = RAINBOW_COLOR;
    if(window_ready_flag){
      draw_colorbar();
    }
  }
}

void
on_set_hot_button_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    color_flag = HOT_COLOR;
    if(window_ready_flag){
      draw_colorbar();
    }
  }
}


void
on_set_gray_button_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    color_flag = GRAY_COLOR;
    if(window_ready_flag){
      draw_colorbar();
    }
  }
}


void
on_set_comb_button_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    color_flag = COMB_COLOR;
    if(window_ready_flag){
      draw_colorbar();
    }
  }

}

void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkFileSelection *fs;
  char *filename, *raw_filename;
  GtkWidget *filesel;
  GtkWidget *file_entry;

  fs = GTK_FILE_SELECTION (user_data);
  filename = gtk_file_selection_get_filename (fs);
  raw_filename = gtk_entry_get_text (GTK_ENTRY(fs->selection_entry));
  if (strlen (raw_filename) == 0)
    return;
  filesel = gtk_widget_get_toplevel(GTK_WIDGET(button));
  gtk_widget_hide(filesel);
  if(import_flag==0){
    file_entry = lookup_widget(filewindow,"file_entry");
    gtk_entry_set_text(GTK_ENTRY(file_entry),filename);
  }
  else{
    file_entry = lookup_widget(import_window,"import_file_entry");
    gtk_entry_set_text(GTK_ENTRY(file_entry),filename);
  }
}

void
on_load_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *file_entry;
  char message[255];
  char *tmpc;

  file_entry = lookup_widget(user_data,"file_entry");
  tmpc = gtk_entry_get_text(GTK_ENTRY(file_entry));
  if (strlen (tmpc) == 0)
    return;
  if(fname==NULL){
    fname = (char *)malloc((1+strlen(tmpc)));
  }
  else{
    free(fname);
    fname = (char *)malloc((1+strlen(tmpc)));
  }
  strcpy(fname,tmpc);
  sprintf(message,"Selected File Name = %s",fname);
  put_string(message,0);
  gtk_widget_hide(GTK_WIDGET(user_data));
  set_filename();
}

void
on_view_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  view_proc();
}


void
on_set_each_image_button_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    imax_flag = EACH_IMAGE;
  }
}


void
on_set_all_image_button_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    imax_flag = ALL_IMAGE;
  }
}


void
on_set_trans_button_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    seq_flag = TRANS;
  }
}


void
on_set_coronal_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    seq_flag = CORO;
  }
}


void
on_set_sagital_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    seq_flag = SAGI;
  }
}

gboolean
on_canvas_expose_event                 (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
 gdk_window_copy_area(pet_canvas->window,canvasGC,0,0,canvas_pixmap,0,0,canvas_width,canvas_height);
  return FALSE;
}


void
on_yes_clear_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  gdk_window_clear(pet_canvas->window);
  gdk_draw_rectangle(canvas_pixmap,clearGC,TRUE,0,0,canvas_width,canvas_height);
  Curr_imgno = 0;
  now_seq = 1;
  view_flag = 0;
  roi_step = 0;/* roi procedure starts again */
  memset(pre_fname,0,sizeof(pre_fname));
  gtk_widget_hide(GTK_WIDGET(user_data));
}


void
on_no_clear_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(GTK_WIDGET(user_data));
}

gboolean
on_colorbar_button_press_event         (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  if(event->button == Button1){
    originY = event->y;
  }
  else{
    originY2 = event->y;
  }
  return FALSE;
}

gboolean
on_colorbar_button_release_event         (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  if(event->button == Button1){
    newY = event->y;
    upper_color += (originY - newY)*0.2;
    if(upper_color>=maxcolor) upper_color = maxcolor;
    if(upper_color<=1) upper_color = 1;
  }
  else{
    newY2 = event->y;
    lower_color += (originY2 - newY2)*0.2;
    if(lower_color>=maxcolor - 1) lower_color = maxcolor - 1;
    if(lower_color<=0) lower_color = 0;
  }
  draw_colorbar();
  return FALSE;
}

void
on_roi_done_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  roi_draw_flag = 0;
  roi_step = 0;
  gtk_widget_hide(GTK_WIDGET(user_data));
}


void
on_roi_circle_button_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = CIRCLE;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}


void
on_roi_ellipse_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = ELLIPSE;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}


void
on_roi_rectangle_button_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = RECTANGLE;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}


void
on_roi_polygon_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = POLYGON;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}


void
on_roi_distance_button_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = DISTANCE;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}


void
on_roi_point_button_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = PICKP;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}

void
on_roi_non_button_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  roi_draw_flag = 0;
}


gboolean
on_canvas_button_press_event           (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  roi_proc(widget,event);
  return FALSE;
}


gboolean
on_canvas_button_release_event         (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  return FALSE;
}


void
on_roi_info_done_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(GTK_WIDGET(user_data));
}


gboolean
on_canvas_motion_notify_event          (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{

  drag(widget,event);
  return FALSE;
}


void
on_roi_calc_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  roi_set_proc();
}


void
on_roi_next_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  roi_next_proc();
}

void
on_roi_hist_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_show(hist_window);
  hist_set_proc();
}


void
on_hist_done_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(GTK_WIDGET(user_data));
}


gboolean
on_histgram_area_expose_event          (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  hist_set_proc();
  return FALSE;
}


void
on_hist_save_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *hist_entry;
  char *str;
  FILE *fp;
  GtkWidget *overwrite_dialog;

  hist_entry = lookup_widget(hist_window,"hist_entry");
  str = gtk_entry_get_text(GTK_ENTRY(hist_entry));
  if(strlen(str)==0){
    return;
  }
  fp = fopen(str,"r");
  if(fp!=NULL){
    overwrite_flag = OW_HIST;
    overwrite_dialog = create_overwrite_dialog ();
    gtk_widget_show(overwrite_dialog);
    fclose(fp);
  }
  else{
    save_hist();
  }
}


void
on_roi_copy_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  cproi_proc();
}


void
on_roi_save_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  char *str;
  char st2[100];
  gushort n_from,n_to,i;
  FILE *fp;
  GtkWidget *roi_file_entry;
  GtkWidget *roi_no_from_entry;
  GtkWidget *roi_no_to_entry;
  guchar exist_flag;
  GtkWidget *overwrite_dialog;

  roi_file_entry = lookup_widget(roiwindow,"roi_file_entry");
  str =  gtk_entry_get_text(GTK_ENTRY(roi_file_entry));
  if(strlen(str)==0){return;}
  roi_no_from_entry = lookup_widget(roiwindow,"roi_no_from_entry");
  n_from = atoi(gtk_entry_get_text(GTK_ENTRY(roi_no_from_entry)));
  roi_no_to_entry = lookup_widget(roiwindow,"roi_no_to_entry");
  n_to = atoi(gtk_entry_get_text(GTK_ENTRY(roi_no_to_entry)));

  if(n_from==0) n_from = 1;
  if(n_to==0) n_to = roi_num;
  exist_flag = 0;
  for(i=n_from;i<=n_to;i++){
    if(i>roi_num) break;
    sprintf(st2,"%s.roi%d",str,i);
    fp = fopen(st2,"r");
    if (fp!=NULL){
      exist_flag = 1;
      fclose(fp);
    }
  }
  if (exist_flag){
    overwrite_flag = OW_ROI;
    overwrite_dialog = create_overwrite_dialog ();
    gtk_widget_show(overwrite_dialog);
  }
  else{
    save_roi_proc();
  }
}


void
on_roi_load_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  load_roi_proc();
}


void
on_hdr_info_done_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(GTK_WIDGET(user_data));
}


void
on_hdr_info_save_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *overwrite_dialog;
  GtkWidget *entry;
  char *fname;
  FILE *fp;

  entry = lookup_widget(hdr_info_window,"hdr_info_entry");
  fname = gtk_entry_get_text(GTK_ENTRY(entry));
  if(strlen(fname)==0){
    return;
  }
  fp = fopen(header_name(fname),"r");
  if(fp!=NULL){
    overwrite_flag = OW_HDR;
    overwrite_dialog = create_overwrite_dialog ();
    gtk_widget_show(overwrite_dialog);
    fclose(fp);
  }
  else{
    hdr_save();
  }
}


void
on_save_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *overwrite_dialog;
  GtkWidget *entry;
  char *fname;
  FILE *fp,*fp2;

  entry = lookup_widget(filewindow,"file_entry");
  fname = gtk_entry_get_text(GTK_ENTRY(entry));
  if(strlen(fname)==0) return;
  fp = fopen(header_name(fname),"r");
  fp2 = fopen(image_name(fname),"r");
  if(fp!=NULL||fp2!=NULL){
    overwrite_flag = OW_FILE;
    overwrite_dialog = create_overwrite_dialog ();
    gtk_widget_show(overwrite_dialog);
    fclose(fp);
  }
  else{
    save_file_proc();
  }
}


void
on_document_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *doc_dialog;
  doc_dialog = create_doc_dialog();
  doc(doc_dialog);
  gtk_widget_show(doc_dialog);
}


void
on_doc_done_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(user_data);
}


void
on_profile_done_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(user_data);
}


void
on_profile_save_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *profile_entry;
  char *str;
  FILE *fp;

  profile_entry = lookup_widget(profile_window,"profile_entry");
  str = gtk_entry_get_text(GTK_ENTRY(profile_entry));
  if(strlen(str)==0){
    return;
  }
  fp = fopen(str,"w");
  save_profile(fp);
  fclose(fp);
}


void
on_import_raw_file1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show(import_window);
}


void
on_import_load_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  import_flag = 1;
  import_img((GtkWidget *)user_data);
  import_flag = 0;
  gtk_widget_hide(user_data);
}


void
on_import_cancel_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  import_flag = 0;
  gtk_widget_hide(user_data);
}


void
on_import_char_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    import_file_type_flag = SPM_UNSIGNED_CHAR;
  }
}


void
on_import_short_button_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    import_file_type_flag = SPM_SIGNED_SHORT;
  }
}


void
on_import_int_button_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    import_file_type_flag = SPM_SIGNED_INT;
  }
}


void
on_import_float_button_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    import_file_type_flag = SPM_FLOAT;
  }
}


void
on_import_double_button_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    import_file_type_flag = SPM_DOUBLE;
  }
}


void
on_import_file_select_button_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
  import_flag = 1;
  gtk_widget_show (fileselection);
}


void
on_import_swap_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    need_swap_flag = 1;
  }
  else{
    need_swap_flag = 0;
  }
}


void
on_roi_profile_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  roi_profile();
}


gboolean
on_profilex_curve_motion_notify_event  (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{
  on_profilex(event);
  return TRUE;
}


gboolean
on_profiley_curve_motion_notify_event  (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{

  on_profiley(event);
  return TRUE;
}


void
on_set_interpolate_button_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    interpolate_flag = 1;
  }
  else{
    interpolate_flag = 0;
  }

}


void
on_set_lkup_button_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    color_flag = LKUP_COLOR;
    if(window_ready_flag){
      draw_colorbar();
    }
  }

}


gboolean
on_gpetview_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  GtkWidget *yes_no_dialog;

  yes_no_dialog = create_yes_no_dialog ();
  gtk_widget_show (yes_no_dialog);
  gtk_widget_show (gpetview);
  return TRUE;
}


gboolean
on_filewindow_delete_event             (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  
  return TRUE;
}


gboolean
on_roiwindow_delete_event              (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return TRUE;
}


gboolean
on_settingshell_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return TRUE;
}


void
on_roi_mask_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  roi_mask();
}


void
on_roi_delete_button_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  if(roi_draw_flag==0){return;}
  if(roi_num<1) return;
  roi_num--;

}

void
on_roi_mask_in_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    roi_mask_flag = ROI_MASK_IN;
  }
}


void
on_roi_mask_out_button_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    roi_mask_flag = ROI_MASK_OUT;
  }
}


void
on_find_edge_button_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = FINDEDGE;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;

}


void
on_roi_back_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  roi_backword_proc();
}


void
on_revy_button_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    revy_flag = 1;
  }
  else{
    revy_flag = 0;
  }
}

void
on_reset_roi_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  clear_rec();
  roi_draw(6,0,0);
  redraw_canvas();
}


void
on_roi_info_save_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *entry;
  char *str;
  FILE *fp;
  GtkWidget *overwrite_dialog;

  entry = lookup_widget(roi_info_window,"roi_info_entry");
  str = gtk_entry_get_text(GTK_ENTRY(entry));
  if(strlen(str)==0){
    return;
  }
  fp = fopen(str,"r");
  if(fp!=NULL){ /* file exists */
    overwrite_flag = OW_ROI_INFO;
    overwrite_dialog = create_overwrite_dialog ();
    gtk_widget_show(overwrite_dialog);
    fclose(fp);
  }
  else{
    save_roi_info();
  }
}


void
on_overwrite_yes_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(user_data);
  if(overwrite_flag==OW_ROI_INFO){
    save_roi_info();
  }
  if(overwrite_flag==OW_HIST){
    save_hist();
  }
  if(overwrite_flag==OW_ROI){
    save_roi_proc();
  }
  if(overwrite_flag==OW_HDR){
    hdr_save();
  }
  if(overwrite_flag==OW_FILE){
    save_file_proc();
  }
}


void
on_overwrite_no_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(user_data);
}

void
on_roi_no_entry_activate               (GtkEditable     *editable,
                                        gpointer         user_data)
{
  GtkWidget *entry;
  int roi_no;

  entry = lookup_widget(roiwindow,"roi_no_entry");
  roi_no = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
  roi_no_spec_proc(roi_no);
}


void
on_set_input_user_abs_button_toggled   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    imax_flag = INPUT_USER_ABS;
  }
}


void
on_set_input_user_rel_button_toggled   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    imax_flag = INPUT_USER_REL;
  }
}


void
on_swap_hdr_togglebutton_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    hdr_swap_flag = 1;
  }
  else{
    hdr_swap_flag = 0;
  }

}


void
on_set_invgray_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    color_flag = INVGRAY_COLOR;
    if(window_ready_flag){
      draw_colorbar();
    }
  }
}


void
clear_view_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gdk_window_clear(pet_canvas->window);
  gdk_draw_rectangle(canvas_pixmap,clearGC,TRUE,0,0,canvas_width,canvas_height);
  Curr_imgno = 0;
  now_seq = 1;
  view_flag = 0;
  roi_step = 0;/* roi procedure starts again */
  memset(pre_fname,0,sizeof(pre_fname));
  view_proc();
}

