/* Copyright 2000,2001 Hiroshi Watabe*/
/* $Id: draw_image.c,v 1.5 2001/11/02 06:04:29 watabe Exp $ */
/* Draw image */
#include "gpetview.h"
#include "support.h"

extern u_char seq_flag;
extern float zoom_factor;
extern unsigned int z_xdim, z_ydim, z_zdim; /* after zooming */
extern char *Image;
extern ImageRectPointer *image_cell;
extern unsigned long pixels[MAX_COLOR2];
extern u_char imax_flag;
extern int depth;
extern unsigned short maxcolor;
extern guchar ismax;

unsigned char numbering_flag = 1;
unsigned char interpolate_flag = 1;
guchar revy_flag = 1; /* reverse Y axis */

unsigned char *zooming(buf, cur_x, cur_y,r_x)
unsigned char *buf;
u_short cur_x,cur_y,r_x;
{
  unsigned char *zbuf=NULL;
  unsigned int i,ii,j,jj;
  int xcoord, ycoord;
  int xcoord2, ycoord2;
  short k222,k122,k212,k112;
  float dx1,dy1,dx2,dy2;
  unsigned char dat;
  float	ftmp1,ftmp2;

  if(zoom_factor==1.0){
    return(buf);
  }
  zbuf = (unsigned char *)realloc(zbuf,cur_x*cur_y);

  if(interpolate_flag==1){
    for(i=0,ii=0;i<cur_y;i++,ii++){
      for(j=0,jj=0;j<cur_x;j++,jj++){
	ftmp2 = (i - 0.5)/zoom_factor + 0.5;
	ftmp1 = (j - 0.5)/zoom_factor + 0.5;
	xcoord2 = xcoord = ftmp1;
	ycoord2 = ycoord = ftmp2;
	dx1=ftmp1 - xcoord;
	dx2=1.0-dx1;
	dy1=ftmp2 - ycoord;
	dy2=1.0-dy1;
	xcoord--;
	ycoord--;
	/*Calculate the interpolation weighting factors*/
	/*Calculate the interpolated reslice value of pixel t*/
	if(ycoord<0||ycoord2>=ydim||xcoord<0||xcoord2>=xdim) dat = 0;
	else{
	  k222 = buf[xcoord  + r_x*ycoord];
	  k122 = buf[xcoord2 + r_x*ycoord];
	  k212 = buf[xcoord  + r_x*ycoord2];
	  k112 = buf[xcoord2 + r_x*ycoord2];
	  dat = k222*dx2*dy2 + k122*dx1*dy2 + k212*dx2*dy1 + k112*dx1*dy1;
	}
	zbuf[jj + cur_x*ii] = dat;
      }
    }
  }
  /* nearest neighbor */
  else{
    for(i=0,ii=0;i<cur_y;i++,ii++){
      for(j=0,jj=0;j<cur_x;j++,jj++){
	ftmp2 = (i - 0.5)/zoom_factor + 0.5;
	ftmp1 = (j - 0.5)/zoom_factor + 0.5;
	xcoord = rint(ftmp1) - 1;
	ycoord = rint(ftmp2) - 1;
	k222 = buf[xcoord  + r_x*ycoord];
	if(ycoord<0) dat = 0;
	else{
	  dat = k222;
	}
	zbuf[jj + cur_x*ii] = dat;
      }
    }
  }
  return(zbuf);
}

void draw_image(buf,xdim, ydim, zdim, inum)
unsigned char *buf;
unsigned int xdim, ydim, zdim, inum;
{
  int i,j;
  u_char dat;
  gushort cur_x=0,cur_y=0, r_x=0;
  char string[256];

  if(seq_flag==TRANS){
    r_x = xdim;
    cur_x = z_xdim;
    cur_y = z_ydim;
  }
  if(seq_flag==CORO){
    r_x = xdim;
    cur_x = z_xdim;
    cur_y = z_zdim;
  }
  if(seq_flag==SAGI){
    r_x = ydim;
    cur_x = z_ydim;
    cur_y = z_zdim;
  }
  buf = zooming(buf,cur_x,cur_y,r_x);
  for(i=0;i<cur_y;i++){
    for(j=0;j<cur_x;j++){
      if(revy_flag) dat = buf[j + cur_x*(cur_y -1 - i)];
      else  dat = buf[j + cur_x*i];
      if(imax_flag == INPUT_USER_ABS||imax_flag == INPUT_USER_REL){
	if(dat>user_max) dat = user_max;
	if(dat<user_min) dat = user_min;
	dat = (dat - user_min)*((float)maxcolor/(user_max - user_min));
      }
      else{
	if(revy_flag) dat = buf[j + cur_x*(cur_y -1 - i)]*((float)maxcolor/(float)ismax);/* can deal with imax_flag = ALL_IMAGE or EACH_IMAGE */
	else dat = buf[j + cur_x*i]*((float)maxcolor/(float)ismax);/* can deal with imax_flag = ALL_IMAGE or EACH_IMAGE */
      }
      Image[j + cur_x*(i)] = dat;
    }
  }
  gdk_draw_indexed_image(canvas_pixmap,canvasGC,image_cell[inum]->r_left,image_cell[inum]->r_top,image_cell[inum]->r_width,image_cell[inum]->r_height,GDK_RGB_DITHER_NONE,Image,cur_x,pet_cmap);
/* 22/5/96 watabe add for presentation delete numbering */
  if(numbering_flag==1){
    sprintf(string,"%5d",image_cell[inum]->img_no);
    gdk_draw_text(canvas_pixmap,gfont,canvasGC,image_cell[inum]->r_left + 1,image_cell[inum]->r_top + 12,string,strlen(string));
  }
  gdk_window_copy_area(pet_canvas->window,canvasGC,0,0,canvas_pixmap,0,0,canvas_width,canvas_height);
}
