/* Copyright 2000,2001 Hiroshi Watabe*/
/* $Id: exchanges.c,v 1.2 2001/08/04 13:52:19 watabe Exp $ */
/* exchange float, int etc */
#include "gpetview.h"
#define SPM_UNSIGNED_CHAR     2
#define SPM_SIGNED_SHORT      4
#define SPM_SIGNED_INT        8
#define SPM_FLOAT             16
#define SPM_DOUBLE            64

short swap_short(short a){
  union {
    short i;
    char c[2];
  } ri, ri2;
  short res;

  ri.i = res = a;
  ri2.c[0] = ri.c[1];
  ri2.c[1] = ri.c[0];
  res = ri2.i;
  return(res);
}

float swap_float(float a)
{
  union {
    float i;
    char c[4];
  } ri, ri2;
  float res;

  ri.i = res = a;
  ri2.c[3] = ri.c[0];
  ri2.c[2] = ri.c[1];
  ri2.c[1] = ri.c[2];
  ri2.c[0] = ri.c[3];
  res = ri2.i;
  return(res);
}

double swap_double(double a)
{
  union {
    double i;
    char c[8];
  } ri, ri2;
  double res;

  ri.i = res = a;
  ri2.c[7] = ri.c[0];
  ri2.c[6] = ri.c[1];
  ri2.c[5] = ri.c[2];
  ri2.c[4] = ri.c[3];
  ri2.c[3] = ri.c[4];
  ri2.c[2] = ri.c[5];
  ri2.c[1] = ri.c[6];
  ri2.c[0] = ri.c[7];
  res = ri2.i;
  return(res);
}

int swap_int(a)
int a;
{
  union {
    int i;
    char c[4];
  } ri, ri2;
  int res;

  ri.i = res = a;
  ri2.c[3] = ri.c[0];
  ri2.c[2] = ri.c[1];
  ri2.c[1] = ri.c[2];
  ri2.c[0] = ri.c[3];
  res = ri2.i;
  return(res);
}

/* swapping data */
int exchange_img(char *filename,short type,unsigned long bufsiz)
{
  FILE *fp;
  short *sbuf;
  int *ibuf;
  float *fbuf;
  double *dbuf;
  unsigned long i;

  fp = fopen(filename,"rb");
  if(fp==NULL){
    return(-1);
  }
  if(type==SPM_UNSIGNED_CHAR){
    fclose(fp);/* do nothing */
    return(1);
  }
  if(type==SPM_SIGNED_SHORT){
    sbuf = (short *)malloc(bufsiz*sizeof(short));
    fread(sbuf,bufsiz,sizeof(short),fp);
    fclose(fp);
    for(i=0;i<bufsiz;i++){
      sbuf[i] = read_short(sbuf[i]);
    }
    fp = fopen(filename,"wb");
    fwrite(sbuf,bufsiz,sizeof(short),fp);
    fclose(fp);
    free(sbuf);
    return(1);
  }
  if(type==SPM_SIGNED_INT){
    ibuf = (int *)malloc(bufsiz*sizeof(int));
    fread(ibuf,bufsiz,sizeof(int),fp);
    fclose(fp);
    for(i=0;i<bufsiz;i++){
      ibuf[i] = read_int(ibuf[i]);
    }
    fp = fopen(filename,"wb");
    fwrite(ibuf,bufsiz,sizeof(int),fp);
    fclose(fp);
    free(ibuf);
    return(1);
  }
  if(type==SPM_FLOAT){
    fbuf = (float *)malloc(bufsiz*sizeof(float));
    fread(fbuf,bufsiz,sizeof(float),fp);
    fclose(fp);
    for(i=0;i<bufsiz;i++){
      fbuf[i] = read_float(fbuf[i]);
    }
    fp = fopen(filename,"wb");
    fwrite(fbuf,bufsiz,sizeof(float),fp);
    fclose(fp);
    free(fbuf);
    return(1);
  }
  if(type==SPM_DOUBLE){
    dbuf = (double *)malloc(bufsiz*sizeof(double));
    fread(dbuf,bufsiz,sizeof(double),fp);
    fclose(fp);
    for(i=0;i<bufsiz;i++){
      dbuf[i] = read_double(dbuf[i]);
    }
    fp = fopen(filename,"wb");
    fwrite(dbuf,bufsiz,sizeof(double),fp);
    fclose(fp);
    free(dbuf);
    return(1);
  }
  return 1;
}

int exchange_hdr(hdr)
struct dsr *hdr;
{
  struct dsr tmphdr;
  int i;
  memcpy(&tmphdr, hdr, sizeof(struct dsr));

  hdr->hk.sizeof_hdr = read_int(tmphdr.hk.sizeof_hdr);
  hdr->hk.extents = read_int(tmphdr.hk.extents);
  hdr->hk.session_error = read_short(tmphdr.hk.session_error);
  for(i=0;i<8;i++){
    hdr->dime.dim[i] = read_short(tmphdr.dime.dim[i]);
    hdr->dime.pixdim[i] = read_float(tmphdr.dime.pixdim[i]);
  }
  hdr->dime.unused1 = read_short(tmphdr.dime.unused1);
  hdr->dime.datatype = read_short(tmphdr.dime.datatype);
  hdr->dime.bitpix = read_short(tmphdr.dime.bitpix);
  hdr->dime.dim_un0 = read_short(tmphdr.dime.dim_un0);
  hdr->dime.vox_offset = read_float(tmphdr.dime.vox_offset);
  hdr->dime.funused1 = read_float(tmphdr.dime.funused1);
  /*
  hdr->dime.funused2 = read_float(tmphdr.dime.funused2);
  hdr->dime.funused3 = read_float(tmphdr.dime.funused3);
  */
  hdr->dime.cal_max = read_float(tmphdr.dime.cal_max);
  hdr->dime.cal_min = read_float(tmphdr.dime.cal_min);
  hdr->dime.compressed = read_int(tmphdr.dime.compressed);
  hdr->dime.verified = read_int(tmphdr.dime.verified);
  hdr->dime.glmax = read_int(tmphdr.dime.glmax);
  hdr->dime.glmin = read_int(tmphdr.dime.glmin);
  hdr->hist.views = read_int(tmphdr.hist.views);
  hdr->hist.vols_added = read_int(tmphdr.hist.vols_added);
  hdr->hist.start_field = read_int(tmphdr.hist.start_field);
  hdr->hist.field_skip = read_int(tmphdr.hist.field_skip);
  hdr->hist.omax = read_int(tmphdr.hist.omax);
  hdr->hist.omin = read_int(tmphdr.hist.omin);
  hdr->hist.smax = read_int(tmphdr.hist.smax);
  hdr->hist.smin = read_int(tmphdr.hist.smin);
  return 1;
}

int read_int(a)
int a;
{
  int res;
  res = a;
  if(need_swap_flag==1){
    res = swap_int(a);
  }
  return(res);
}

float read_float(float a)
{
  float res;

  res = a;
  if(need_swap_flag==1){
    res = swap_float(a);
  }
  return(res);
}

double read_double(double a)
{
  double res;

  res = a;
  if(need_swap_flag==1){
    res = swap_double(a);
  }
  return(res);
}

short read_short(short a){
  short res;

  res = a;
  if(need_swap_flag==1){
    res = swap_short(a);
  }
  return(res);
}

