/* Copyright 2000,2001 Hiroshi Watabe */
/* This routine was originally written for Mirage by M Feldman */
/* $Id: find_edge_loop.c,v 1.2 2001/03/20 05:39:42 watabe Exp $ */
#include "gpetview.h"
#include "support.h"

guchar find_edge_loop(gushort *x1,gushort *y1,gushort *xd,gushort *yd){
  int thresh;
  short first_x,first_y,vec1;
  gushort x2,y2;
  short vec2;
  guchar seedv;
  int num_same;
  guchar reg_loop_edge = 0;

  seedv = pick_point(*x1,*y1);
  vec1 = 0;
  x2 = 0;
  y2 = 0;
  vec2 = 0;
  thresh = 10;
  num_same = 0;
  reg_follow_edge(seedv,x1,y1,xd,yd,&vec1,&x2,&y2,&vec2);
  first_x = x2;
  first_y = y2;
  figure.points[0].x = first_x;
  figure.points[0].y = first_y;
  figure.pnum = 1;
  polygon_draw(1);
  reg_loop_edge = 0;
  while(1){
    *x1 = x2;
    *y1 = y2;
    vec1 = vec2;
    reg_follow_edge(seedv,x1,y1,xd,yd,&vec1,&x2,&y2,&vec2);
    figure.points[figure.pnum].x = x2;
    figure.points[figure.pnum].y = y2;
    figure.pnum++;
    if(figure.pnum>=NUM_P_MAX){/* 1000 is maximum point */
      figure.pnum = 0;
      return(0);
    }
    if((x2==first_x)&&(y2==first_y)){
      num_same++;
      if(num_same==15){/* region is circular */
	figure.pnum = 0;
	return(0);
      }
    }
    if(x2==first_x&&y2==first_y){
      reg_loop_edge = 1;
      break;
    }
    else{
      if(*x1==x2&&*y1==y2){
	break;
      }
    }
  }
  if(reg_loop_edge==1&&figure.pnum<thresh){
    reg_loop_edge = 0;
  }
  if(reg_loop_edge){
    Close = 1;
    polygon_draw(1);
  }
  else{
    Close = 0;
  }
  return(reg_loop_edge);
}

void reg_follow_edge(guchar seedv,gushort *x1,gushort *y1,gushort *xd,gushort *yd,short *vec1,gushort *x2,gushort *y2,short *vec2){
  short f_vector[2][8];
  short v_save;
  guchar newv;
  gushort xwidth,ywidth;

  xwidth = *xd;
  ywidth = *yd;

  f_vector[0][0] = f_vector[0][1] = f_vector[0][7] = f_vector[1][1] = f_vector[1][2] = f_vector[1][3] = 1;
  f_vector[0][2] = f_vector[0][6] = f_vector[1][0] = f_vector[1][4] = 0;
  f_vector[0][3] = f_vector[0][4] = f_vector[0][5] = f_vector[1][5] = f_vector[1][6] = f_vector[1][7] = -1;
  v_save = (*vec1 + 4)&7;
  *vec2 = v_save;

  while(1){
    *vec2 = (*vec2 + 1)&7;
    *x2 = *x1 + f_vector[0][*vec2];
    *y2 = *y1 + f_vector[1][*vec2];
    /*Check if the new point is part of the edge (and within bounds)*/
    newv = pick_point(*x2,*y2);
    if(*x2>0&&*x2<xwidth&&*y2>0&&*y2<ywidth&&newv>seedv){
      break;
    }
    else{
      /*
	Not another edge point - continue only if we haven't wrapped on the
	Freeman vector pointer
      */
      if(*vec2==v_save){
	*x2 = *x1;
	*y2 = *y1;
	break;
      }
    }
  }
  return;
}
