/* Copyright 2000,2001 Hiroshi Watabe*/
/* obtain image parameters */
#include "gpetview.h"
#include "support.h"

unsigned char imax_flag = EACH_IMAGE;
unsigned char seq_flag = TRANS;

float user_max, user_min; /* image max and min determined by user */
float zoom_factor;

void get_parameters()
{
  char message[256];
  char *tmpstr;
  GtkWidget *entry;

  user_max = IMAGE_MAX*img->scalefactor;

  if(imax_flag==INPUT_USER_ABS){
    /* get max and min */
    entry = lookup_widget(settingshell,"set_maxv");
    tmpstr = gtk_entry_get_text(GTK_ENTRY(entry));
    user_max = (float)atof(tmpstr)/img->scalefactor;
    entry = lookup_widget(settingshell,"set_minv");
    tmpstr = gtk_entry_get_text(GTK_ENTRY(entry));
    user_min = (float)atof(tmpstr)/img->scalefactor;
    if(user_max<=0){
      user_max = IMAGE_MAX;
    }
    if(user_max <= user_min){
      user_min = 0;
    }
  }
  if(imax_flag==INPUT_USER_REL){
    /* get max and min */
    entry = lookup_widget(settingshell,"set_maxv");
    tmpstr = gtk_entry_get_text(GTK_ENTRY(entry));
    user_max = (float)atof(tmpstr)*0.01*IMAGE_MAX; /* % expression */
    entry = lookup_widget(settingshell,"set_minv");
    tmpstr = gtk_entry_get_text(GTK_ENTRY(entry));
    user_min = (float)atof(tmpstr)*0.01*IMAGE_MAX;
    if(user_max<=0){
      user_max = IMAGE_MAX;
    }
    if(user_max <= user_min){
      user_min = 0;
    }
  }
  entry = lookup_widget(settingshell,"set_zoom");
  tmpstr = gtk_entry_get_text(GTK_ENTRY(entry));
  zoom_factor = (float)atof(tmpstr);
  if(zoom_factor <=0.0){
    zoom_factor = 1.0;
  }
  sprintf(message,"max value %g in image zoom %g", IMAGE_MAX*img->scalefactor,zoom_factor);
  put_string(message,0);

}
