/* Copyright 2000,2001 Hiroshi Watabe*/
/* $Id: gpetview.h,v 1.18 2001/11/07 13:43:35 watabe Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
/* gtk+ */
#include <gtk/gtk.h>

#include "image_def.h"
extern GtkWidget *gcolorbar;
extern GtkWidget *filewindow;
extern GtkWidget *fileselection;
extern GtkWidget *settingshell;
extern GtkWidget *gpetview;
extern GtkWidget *roi_info_window;
extern GtkWidget *roiwindow;
extern GtkWidget *hist_window;
extern GtkWidget *import_window;
extern GtkWidget *profile_window;
extern GdkVisual *gvisual;
extern char *fname;
extern GdkPixmap *canvas_pixmap;
extern GdkPixmap *roi_pixmap;
extern GdkRgbCmap *pet_cmap;
extern guchar numbering_flag;
extern guchar interpolate_flag;
extern guchar revy_flag;
extern guchar roi_mask_flag;
extern guchar pipe_flag;
extern guchar new_img_flag;
extern gint pipe_fd;
extern gint last_img_no;/* Last image Number */

extern GdkGC *canvasGC;
extern GdkGC *clearGC;
extern GdkGC *roiGC;
extern GdkFont *gfont;
extern GdkColormap *gcolormap;
extern GdkColor *gpetcolors;
extern  GtkWidget *pet_canvas;
extern gint Curr_imgno;
extern gint Pre_imgno;
extern guchar view_flag;
extern guchar roi_draw_flag;
extern guchar roi_flag;
extern guchar import_file_type_flag;
extern guchar need_swap_flag;
extern guchar hdr_swap_flag;
extern guchar import_flag;
extern char pre_fname[1024];
extern gushort maxcolor;
extern gushort curr_img_roi;
extern guchar	Close;
extern gushort roi_step;
extern guint roi_num;
extern gushort xdim, ydim, zdim;
extern gushort pre_x;
extern unsigned long hist[256]; /* Histgram */
extern char *imgnostring;
extern guint now_seq;
extern guint img_seq[1000]; /* maximum image manuplation is 1000 */
extern guint num_seq;

/* defintion of function */
extern void view_proc(void);
extern void set_filename(void);
extern void put_string(char*,int);
extern void get_parameters(void);
void draw_image(guchar*,guint32,guint32,guint32,guint32);
void roi_proc(GtkWidget*, GdkEventButton*);
void roi_calc(void);
void roi_mask(void);
void drag(GtkWidget*, GdkEventMotion*);
guchar pick_point(short, short);
void roi_draw(guint guint,short,short);
void roi_set_proc(void);
void roi_next_proc(void);
void roi_backword_proc(void);
int calc_area(GdkImage*);
void get_points_rectan(gshort*,gshort*);
void rectangle_draw(gushort,gushort,gushort);
void circle_draw(gushort,gushort,gushort);
void ellipse_draw(gushort,gushort,gushort);
void	polygon_draw(gushort);
void	redraw_canvas(void);
void hist_set_proc(void);
void cproi_proc(void);
void roi_out(void);
void save_roi_proc(void);
void load_roi_proc(void);
char *header_name(char*);
char *lkup_name(char*);
char *image_name(char*);
struct dsr *mk_anahdr(short,short,short,short,float,float,float,long);
void draw_colorbar();
void mk_seq(guint);
void hdr_info(GtkWidget*);
int write_image(FRSTR*,int,int,char*);
int is_null_frame(FRSTR*,char*);
int dbedit(int,char**);
void save_file_proc(void);
void doc(GtkWidget*);
void get_imgno(guint);
void clear_rec(void);
void roi_ext(void);
void hist_calc_area(GdkImage*);
short read_short(short);
int read_int(int);
float read_float(float);
double read_double(double);
short swap_short(short);
int swap_int(int);
float swap_float(float);
double swap_double(double);

int checkarg(int,char**);
FRSTR *getpipe();
FRSTR *gethdr_import(char*,struct dsr*);
void delete_pre_roi(guchar); /* delete previous ROI */
void save_roi_info();

#define streq(a, b)        ( strcmp((a), (b)) == 0 )
#define HIST_WIDTH 300
#define HIST_HEIGHT 300
#define LUMP_WIDTH 30
#define Button1 1
#define Button2 2
#define Button3 3
#define Button4 4
#define Button5 5

#define MAX_COLOR 128
#define MAX_COLOR2 256
#define IMAGE_MAX 255

#define RAINBOW_COLOR 0
#define HOT_COLOR 1
#define GRAY_COLOR 2
#define INVGRAY_COLOR 3
#define COMB_COLOR 4
#define LKUP_COLOR 5

/* imax flag */
#define EACH_IMAGE 0
#define ALL_IMAGE 1
#define INPUT_USER_ABS 2
#define INPUT_USER_REL 3
/* seq flag */
#define TRANS 0
#define CORO 1
#define SAGI 2
/* roi flag */
#define CIRCLE 1
#define ELLIPSE 2
#define RECTANGLE 3
#define POLYGON 4
#define DISTANCE 5
#define PICKP 6
#define FINDEDGE 7
/* roi mask flag */
#define ROI_MASK_IN 0
#define ROI_MASK_OUT 1
/* filtering */
#define FILTER_GATE 0
#define NUM_P_MAX 1000 /* roi number of points*/

/* overwrite flag */
#define OW_ROI_INFO 1 /* roi information */
#define OW_HIST 2 /* histgram */
#define OW_ROI 3 /* ROI data */
#define OW_HDR 4 /* header save */
#define OW_FILE 5 /* image file save */

#define SPM_UNSIGNED_CHAR     2
#define SPM_SIGNED_SHORT      4
#define SPM_SIGNED_INT        8
#define SPM_FLOAT             16
#define SPM_DOUBLE            64

typedef struct imagerect
{
  unsigned short   img_no;
  unsigned short   r_left;
  unsigned short   r_top;
  unsigned short   r_width;
  unsigned short   r_height;
} ImageRect;	

typedef struct imagerect *ImageRectPointer;

#define END_IMAGE 32640

typedef struct  roifig
{
        int     type;
        GdkPoint   center;
        int     la;
        int     sa;
        float   degree;
        int     pnum;
	GdkPoint   points[NUM_P_MAX];
}       RoiFig;

typedef struct roi
{       float   average;
        int     area;
        short   pmax;
        short   pmin;
        float   factor;
        float   sd;
} ROIRES;

typedef struct roihead
{
        short   image_no;
        short   region_no;
        char    type;
        ROIRES     roires;
} ROIHEAD;

typedef struct roiinfo
{
  u_short   img_no;
  u_char   orient;
  float zoom;
  RoiFig    figure;
  guchar revy_flag; /* reverse Y flag*/
} ROIINFO;

extern GdkGC color_barGC;
extern unsigned char color_flag;
extern short upper_color;
extern short lower_color;
extern int depth;
extern GtkWidget *gcolorbar;
extern GtkWidget *filewindow;
extern GtkWidget *hdr_info_window;
extern guchar imax_flag;
extern guchar seq_flag;
extern float zoom_factor;
extern float user_max, user_min; /* image max and min determined by user */
extern ImageRectPointer *image_cell;
extern gint num_max_image; /* how many image will be displayed. */
extern RoiFig figure;
extern ROIHEAD	roi_head;
extern FRSTR *img;
extern short canvas_width,canvas_height;
extern short view_width,view_height;
extern short orig_bitpix,orig_datatype; /* original bitpix and datatype */
extern int orig_glmax,orig_glmin;

/* define functions */
void greycolor(u_char*,u_char*,u_char*,int);
void hotcolor(u_char*,u_char*,u_char*);
void combcolor(u_char*,u_char*,u_char*);
void rainbow(void);
void draw_color_bar(GtkWidget*);
gulong get_color (int red, int green, int blue);
void   store_color (gulong *pixel, int red, int green, int blue);
void   get_standard_colormaps (void);
void sc_format(unsigned int,unsigned int,unsigned int);
unsigned char* readplane(FRSTR*,short,short,short,short);
void writeplane(FRSTR*,unsigned char*,short,short,short,short);
void init_gpetview(void);
int exchange_hdr(struct dsr*);
void roi_profile(void);
void on_profilex(GdkEventMotion*);
void on_profiley(GdkEventMotion*);
int hdr_save();
void import_img(GtkWidget*);
void save_profile(FILE*);
guchar find_edge_loop(gushort*,gushort*,gushort*,gushort*);
void reg_follow_edge(guchar,gushort*,gushort*,gushort*,gushort*,short*,gushort*,gushort*,short*);
void save_hist();
void roi_no_spec_proc(int);
void swap_roi_info(ROIINFO*);
int get_img_no(gushort,gushort);
