/* Copyright 2000,2001 Hiroshi Watabe*/
/* histgram ROI */
/* $Id: hist_proc.c,v 1.3 2001/05/08 02:22:28 watabe Exp $ */
#include "gpetview.h"
#include "support.h"

unsigned long hist[256];
unsigned char hist_on_flag = 0;

void save_hist() /* save histgram */
{
  FILE *fp;
  GtkWidget *hist_entry;
  int i;

  hist_entry = lookup_widget(hist_window,"hist_entry");

  fp = fopen(gtk_entry_get_text(GTK_ENTRY(hist_entry)),"w");
  for(i=0;i<256;i++){
    fprintf(fp,"%g %ld\n",(float)i*(img->scalefactor),hist[i]);
  }
  fclose(fp);
}
void hist_out()
{
  GtkWidget *hist_area;
  int i,imax,x_p,y_p,x_w,y_w;
  unsigned long max;
  float xpitch,r_xpitch;
  float ypitch,r_ypitch;
  char string[255];
  GdkPoint points[255];
  int index = 1;

  hist_area = lookup_widget(hist_window,"histgram_area");
  memset(points,0,sizeof(points));
/* clear window */
  gdk_draw_rectangle(hist_area->window, canvasGC, TRUE, 0, 0, HIST_WIDTH, HIST_HEIGHT);
  x_p = 30;
  y_p = HIST_HEIGHT - 30;
  x_w = HIST_WIDTH - 30 - x_p;
  y_w = HIST_HEIGHT - 60;
  gdk_draw_rectangle(hist_area->window,clearGC,0,30,30,HIST_WIDTH - 60, HIST_HEIGHT - 60);

  for(i=255,imax=255;i>0;i--){
    if(hist[i]>0) break;
  }
  imax = i;
  for(i=0,max=0;i<imax;i++){
    if(max<hist[i]) max = hist[i];
  }

  gdk_draw_text(hist_area->window,gfont,clearGC,x_p,y_p+5,"0",1);
  xpitch = imax/10.0;
  r_xpitch = x_w/10.0;
  for(i=1;i<=10;i++){
    gdk_draw_line(hist_area->window,clearGC,x_p + (int)(r_xpitch*i),y_p+2,x_p + (int)(r_xpitch*i),y_p-2);
    sprintf(string,"%5.1f",xpitch*i);
    gdk_draw_text(hist_area->window,gfont,clearGC,x_p + (int)(r_xpitch*i) - 20,y_p+20,string,strlen(string)); 
 }

  ypitch = max/10.0;
  r_ypitch = y_w/10.0;
  for(i=1;i<=10;i++){
    gdk_draw_line(hist_area->window,clearGC,x_p - 2, y_p - (int)(r_ypitch*i),x_p + 2, y_p - (int)(r_ypitch*i));
    sprintf(string,"%ld",(long)(ypitch*i));
    gdk_draw_text(hist_area->window,gfont,clearGC,x_p - 10, y_p - (int)(r_ypitch*i),string,strlen(string));
  }  

  for(i=0;i<imax;i++){
    points[i].x = x_p + x_w*(float)i/imax;
    points[i].y = y_p - y_w*(float)hist[i]/(float)max;
  }
  index = imax;
  gdk_draw_lines(hist_area->window,clearGC,points,index);
}

void hist_calc_area(GdkImage *image)
{
  u_int i,j,k,ix,iy,iz;
  int	Max,Min;
  unsigned long ofset,ofset2;
  u_char *img_mat = NULL;
  u_short fukasa;
  unsigned char cdat;
  short bpl;
  guchar *buf = NULL;
  gshort *img_p16=NULL;
  guchar *img_p8=NULL;
  gint *img_p32=NULL;
  gushort width,height;

  width = image->width;
  height = image->height;
  buf = (guchar *)realloc(buf,width*height);
  bpl = image->bpl/(image->bpp/8);
  if(image->bpp==32){
    img_p32 = (gint *)image->mem;
  }
  if(image->bpp==16){
    img_p16 = (gshort *)image->mem;
  }
  if(image->bpp==8){
    img_p8 = (guchar *)image->mem;
  }
  for(i=0;i<height;i++){
    for(j=0;j<image->width;j++){
      if(image->bpp==32){
	buf[j + i*width] = img_p32[j + i*bpl];
      }
      if(image->bpp==16){
	buf[j + i*width] = img_p16[j + i*bpl];
      }
      if(image->bpp==8){
	buf[j + i*width] = img_p8[j + i*bpl];
      }
    }
  }

  memset(hist,0,sizeof(hist));
  Max = 0;
  Min = 255;

  if(seq_flag==TRANS){
    img_mat = (unsigned char *)realloc(img_mat,(unsigned)xdim*ydim);
    fukasa = ydim;
  }
  else{
    if(seq_flag==CORO){
      img_mat = (unsigned char *)realloc(img_mat,(unsigned)xdim*zdim);
      fukasa = zdim;
    }
    else{
      img_mat = (unsigned char *)realloc(img_mat,(unsigned)ydim*zdim);
      fukasa = zdim;
    }
  }

  img_mat = readplane(img,xdim,ydim,zdim,image_cell[curr_img_roi]->img_no);

  iz = (int)((float)width/zoom_factor);
  for(i=0,k=0;i<height;i++){
    for(j=0;j<width;j++){
      ofset = j + i*width;
      if(buf[ofset]==0) continue;
      ix = (int)((float)j/zoom_factor);
      iy = (int)((float)i/zoom_factor);
      if(revy_flag==1) ofset2 = ix + (fukasa - 1 - iy)*iz;
      else ofset2 = ix + iy*iz;
      cdat = img_mat[ofset2];
      if(cdat==0||cdat==255) continue;
      hist[cdat]++;
      k++;
    }
  }
  if(k==0) return;
}

void hist_calc()
{
  GdkImage *roi_image;

  roi_pixmap = gdk_pixmap_new(gpetview->window,image_cell[curr_img_roi]->r_width,image_cell[curr_img_roi]->r_height,-1);
  gdk_draw_rectangle(roi_pixmap,clearGC,TRUE,0,0,image_cell[curr_img_roi]->r_width,image_cell[curr_img_roi]->r_height);
  roi_draw(4,0,0);
  roi_image =  gdk_image_get(roi_pixmap,0,0,image_cell[curr_img_roi]->r_width,image_cell[curr_img_roi]->r_height);
  clear_rec();
  hist_calc_area(roi_image);
  gdk_pixmap_unref(roi_pixmap);
}

void hist_set_proc()
{
  hist_on_flag = 1;
  hist_calc();
  hist_out();
}
