/* Copyright 2000,2001 Hiroshi Watabe */
/* some routine for image manupulation */
/* Originally written by john Ashburner */
/* $Id: img_lib.c,v 1.5 2001/10/05 20:04:22 watabe Exp $ */
#include "gpetview.h"

char *header_name(char*), *image_name(char*);
char *lkup_name(char*);
FRSTR *getframe(char*,int);
FRSTR *getframe_import(char*,int,FRSTR*);
FRSTR *gethdr(char*),*toshort(FRSTR*),*byte2short(FRSTR*);
int read_hdr(char*,struct dsr*);
FRSTR *free_frame(FRSTR*);
void mfree(char*);
char *mcalloc(unsigned int,unsigned int);
int frame_size(struct dsr*);
int is_null_frame(FRSTR*,char*);
int writeframe(FRSTR*,int,char*);
FRSTR *normalise(FRSTR*),*tobyte(FRSTR*),*short2byte(FRSTR*);
FRSTR *setmaxmin(FRSTR*);
FRSTR *gethdr_import(char*,struct dsr*);
guchar need_swap_flag = 0;
short orig_bitpix,orig_datatype; /* original bitpix and datatype */
int orig_glmax,orig_glmin;

FRSTR *setmaxmin(frame)
FRSTR *frame;
{
  if (is_null_frame(frame, "setmaxmin"))
    return(frame);

  if (frame->hdr->dime.bitpix == 8){
    int i;
    int max = 0, min = 255;
    for(i=0; i<frame->hdr->dime.dim[1]*frame->hdr->dime.dim[2]*frame->hdr->dime.dim[3]; i++)
      if (frame->dat[i] > max)
	max = frame->dat[i];
      else if (frame->dat[i] < min)
	min = frame->dat[i];
    frame->hdr->dime.glmax = max;
    frame->hdr->dime.glmin = min;
    frame->hdr->dime.cal_max = 0;
    frame->hdr->dime.cal_min = 0;
  }
  else if (frame->hdr->dime.bitpix == 16){
    int i;
    int max = -32768, min = 32767;
    short *dat2;
    short dat1;

    dat2 = (short *)frame->dat;
    for(i=0; i<frame->hdr->dime.dim[1]*frame->hdr->dime.dim[2]*frame->hdr->dime.dim[3]; i++){
      if(need_swap_flag){
	dat1 = read_short(dat2[i]);
      }
      else{
	dat1 = dat2[i];
      }
      if (dat1 > max)
	max = dat1;
      else if (dat1 < min)
	min = dat1;
    }
    frame->hdr->dime.glmax = max;
    frame->hdr->dime.glmin = min;
    frame->hdr->dime.cal_max = 0;
    frame->hdr->dime.cal_min = 0;
  }
  else if (frame->hdr->dime.datatype == SPM_SIGNED_INT){
    int i;
    int max,min;
    int *dat2;
    int dat1;
    dat2 = (int *)frame->dat;
    if(need_swap_flag){
      max = min = read_int(dat2[0]);
    }
    else{
      max = min = dat2[0];
    }
    for(i=0; i<frame->hdr->dime.dim[1]*frame->hdr->dime.dim[2]*frame->hdr->dime.dim[3]; i++){
      if(need_swap_flag){
	dat1 = read_int(dat2[i]);
      }
      else{
	dat1 = dat2[i];
      }
      if (dat1 > max)
	max = dat1;
      else if (dat1 < min)
	min = dat1;
    }
    frame->hdr->dime.glmax = max;
    frame->hdr->dime.glmin = min;
    frame->hdr->dime.cal_max = 0;
    frame->hdr->dime.cal_min = 0;
  }
  else if (frame->hdr->dime.datatype == SPM_FLOAT){
    int i;
    float max,min;
    float *dat2;
    float dat1;

    dat2 = (float *)frame->dat;
    if(need_swap_flag){
      max = min = read_float(dat2[0]);
    }
    else{
      max = min = dat2[0];
    }
    for(i=0; i<frame->hdr->dime.dim[1]*frame->hdr->dime.dim[2]*frame->hdr->dime.dim[3]; i++){
      if(need_swap_flag){
	dat1 = read_float(dat2[i]);
      }
      else{
	dat1 = dat2[i];
      }
      if (dat1 > max)
	max = dat1;
      else if (dat1 < min)
	min = dat1;
    }
    frame->hdr->dime.glmax = 1;
    frame->hdr->dime.glmin = 0;
    frame->hdr->dime.cal_max = max;
    frame->hdr->dime.cal_min = min;
  }
  else if (frame->hdr->dime.datatype == SPM_DOUBLE){
    int i;
    double max,min;
    double *dat2;
    double dat1;

    dat2 = (double *)frame->dat;
    if(need_swap_flag){
      max = min = read_double(dat2[0]);
    }
    else{
      max = min = dat2[0];
    }
    for(i=0; i<frame->hdr->dime.dim[1]*frame->hdr->dime.dim[2]*frame->hdr->dime.dim[3]; i++){
      if(need_swap_flag){
	dat1 = read_double(dat2[i]);
      }
      else{
	dat1 = dat2[i];
      }
      if (dat1 > max)
	max = dat1;
      else if (dat1 < min)
	min = dat1;
    }
    frame->hdr->dime.glmax = 1;
    frame->hdr->dime.glmin = 0;
    frame->hdr->dime.cal_max = (float)max;
    frame->hdr->dime.cal_min = (float)min;
  }
  else if (frame->hdr->dime.bitpix == 1){
    frame->hdr->dime.glmax = 1;
    frame->hdr->dime.glmin = 0;
    frame->hdr->dime.cal_max = 0;
    frame->hdr->dime.cal_min = 0;
  }
  else 
    (void)fprintf(stderr, "setmaxmin: unknown dime.bitpix (%d)\n",
		  frame->hdr->dime.bitpix);
  if (frame->hdr->dime.glmax == frame->hdr->dime.glmin)
    (void)fprintf(stderr,
		  "warning: setmaxmin: glmax == glmin (%d)\n",
		  frame->hdr->dime.glmax);
  return(frame);
}

FRSTR *short2byte(frame)
FRSTR *frame;
{
  int i, frsize, trunc_upper = 0, trunc_lower = 0;
  unsigned char *dat;
  short *dat2;
  float scale = 1.0;

  frame->hdr->dime.bitpix=8;
  frame->hdr->dime.datatype=SPM_UNSIGNED_CHAR;
  frsize = frame_size(frame->hdr);

  dat2 = (short *)frame->dat;
  dat = (unsigned char *)mcalloc((unsigned)frsize, 1);

  if (frame->hdr->dime.glmax == 0){
    frame->hdr->dime.glmax = 1;
  }
  scale = 255.0/frame->hdr->dime.glmax;
  if (scale > 1.0)
    scale = 1.0;

  if (scale != 1){
    for(i=0; i<frsize; i++){
      int t;
      short dat1;
      if(need_swap_flag){
	dat1 = read_short(dat2[i]);
      }
      else{
	dat1 = dat2[i];
      }
      t = (int)rint(dat1*scale);
      if (t>255){
	t = 255;
	trunc_upper++;
      }
      else if (t<0){
	t = 0;
	trunc_lower++;
      }
      dat[i] = t;
    }
    if ((trunc_upper || trunc_lower)){
      //      (void)fprintf(stderr,"short2byte: %d upper values truncated, %d lower values truncated\n",trunc_upper, trunc_lower);
    }
  }
  else
    for(i=0; i<frsize; i++){
      short dat1;
      if(need_swap_flag){
	dat1 = read_short(dat2[i]);
      }
      else{
	dat1 = dat2[i];
      }
      if(dat1<0){
	dat[i] = 0;
      }
      else{
	dat[i] = dat1;
      }
    }
  mfree((char *)dat2);
  dat2 = 0;
  frame->dat = (unsigned char *)dat;
  frame->scalefactor /= scale;
  frame->hdr->dime.glmin = rint(scale*frame->hdr->dime.glmin);
  if (frame->hdr->dime.glmin < 0)
    frame->hdr->dime.glmin=0;
  frame->hdr->dime.glmax = rint(scale*frame->hdr->dime.glmax);
  return(frame);
}

FRSTR *int2byte(frame)
FRSTR *frame;
{
  int i, frsize, trunc_upper = 0, trunc_lower = 0;
  unsigned char *dat;
  int *dat2;
  float scale = 1.0;

  frame->hdr->dime.bitpix=8;
  frame->hdr->dime.datatype=SPM_UNSIGNED_CHAR;
  frsize = frame_size(frame->hdr);

  dat2 = (int *)frame->dat;
  dat = (unsigned char *)mcalloc((unsigned)frsize, 1);

  if (frame->hdr->dime.glmax == 0){
    frame->hdr->dime.glmax = 1;
  }
  scale = 255.0/frame->hdr->dime.glmax;
  if (scale > 1.0)
    scale = 1.0;

  if (scale != 1){
    for(i=0; i<frsize; i++){
      int t;
      int dat1;
      if(need_swap_flag){
	dat1 = read_int(dat2[i]);
      }
      else{
	dat1 = dat2[i];
      }
      t = (int)rint(dat1*scale);
      if (t>255){
	t = 255;
	trunc_upper++;
      }
      else if (t<0){
	t = 0;
	trunc_lower++;
      }
      dat[i] = t;
    }
    if ((trunc_upper || trunc_lower)){
      //      (void)fprintf(stderr,"short2byte: %d upper values truncated, %d lower values truncated\n",trunc_upper, trunc_lower);
    }
  }
  else
    for(i=0; i<frsize; i++){
      int dat1;
      if(need_swap_flag){
	dat1 = read_int(dat2[i]);
      }
      else{
	dat1 = dat2[i];
      }
      dat[i] = dat1;
    }
  mfree((char *)dat2);
  dat2 = 0;
  frame->dat = (unsigned char *)dat;
  frame->scalefactor /= scale;
  frame->hdr->dime.glmin = rint(scale*frame->hdr->dime.glmin);
  if (frame->hdr->dime.glmin < 0)
    frame->hdr->dime.glmin=0;
  frame->hdr->dime.glmax = rint(scale*frame->hdr->dime.glmax);
  return(frame);
}

FRSTR *float2byte(frame)
FRSTR *frame;
{
  int i, frsize, trunc_upper = 0, trunc_lower = 0;
  unsigned char *dat;
  float *dat2;
  float scale = 1.0;

  frame->hdr->dime.bitpix=8;
  frame->hdr->dime.datatype=SPM_UNSIGNED_CHAR;
  frsize = frame_size(frame->hdr);

  dat2 = (float *)frame->dat;
  dat = (unsigned char *)mcalloc((unsigned)frsize, 1);

  if (frame->hdr->dime.glmax == 0){
    frame->hdr->dime.glmax = 1;
  }
  if (frame->hdr->dime.cal_max == 0){
    frame->hdr->dime.cal_max = 1;
  }
  scale = 255.0/frame->hdr->dime.cal_max;
  for(i=0; i<frsize; i++){
    int t;
    float dat1;
    if(need_swap_flag){
      dat1 = read_float(dat2[i]);
    }
    else{
      dat1 = dat2[i];
    }
    t = (int)rint(dat1*scale);
    if (t>255){
      t = 255;
      trunc_upper++;
    }
    else if (t<0){
      t = 0;
      trunc_lower++;
    }
    dat[i] = t;
  }
  if ((trunc_upper || trunc_lower)){
    //    (void)fprintf(stderr,"short2byte: %d upper values truncated, %d lower values truncated\n",trunc_upper, trunc_lower);
  }
  mfree((char *)dat2);
  dat2 = 0;
  frame->dat = (unsigned char *)dat;
  frame->scalefactor /= scale;
  frame->hdr->dime.glmin = rint(scale*frame->hdr->dime.cal_min);
  if (frame->hdr->dime.glmin < 0)
    frame->hdr->dime.glmin=0;
  frame->hdr->dime.glmax = 255;
  return(frame);
}

FRSTR *double2byte(frame)
FRSTR *frame;
{
  int i, frsize, trunc_upper = 0, trunc_lower = 0;
  unsigned char *dat;
  double *dat2;
  float scale = 1.0;

  frame->hdr->dime.bitpix=8;
  frame->hdr->dime.datatype=SPM_UNSIGNED_CHAR;
  frsize = frame_size(frame->hdr);

  dat2 = (double *)frame->dat;
  dat = (unsigned char *)mcalloc((unsigned)frsize, 1);

  if (frame->hdr->dime.glmax == 0){
    frame->hdr->dime.glmax = 1;
  }
  if (frame->hdr->dime.cal_max == 0){
    frame->hdr->dime.cal_max = 1;
  }
  scale = 255.0/frame->hdr->dime.cal_max;
  for(i=0; i<frsize; i++){
    int t;
    double dat1;
    if(need_swap_flag){
      dat1 = read_double(dat2[i]);
    }
    else{
      dat1 = dat2[i];
    }
    t = (int)rint(dat1*scale);
    if (t>255){
      t = 255;
      trunc_upper++;
    }
    else if (t<0){
      t = 0;
      trunc_lower++;
    }
    dat[i] = t;
  }
  if ((trunc_upper || trunc_lower)){
    //    (void)fprintf(stderr,"short2byte: %d upper values truncated, %d lower values truncated\n",trunc_upper, trunc_lower);
  }
  mfree((char *)dat2);
  dat2 = 0;
  frame->dat = (unsigned char *)dat;
  frame->scalefactor /= scale;
  frame->hdr->dime.glmin = rint(scale*frame->hdr->dime.cal_min);
  if (frame->hdr->dime.glmin < 0)
    frame->hdr->dime.glmin=0;
  frame->hdr->dime.glmax = 255;
  return(frame);
}

FRSTR *tobyte(frame)
FRSTR *frame;
{
	int bitpix,type;
	if (is_null_frame(frame, "tobyte"))
		return(frame);
	bitpix = frame->hdr->dime.bitpix;
	type = frame->hdr->dime.datatype;
	frame->hdr->dime.datatype=SPM_UNSIGNED_CHAR;
	if (bitpix == 8)
		return(frame);
	else if (bitpix == 16)
		return(short2byte(frame));
	else if (type == SPM_SIGNED_INT)
		return(int2byte(frame));
	else if (type == SPM_FLOAT)
		return(float2byte(frame));
	else if (type == SPM_DOUBLE)
		return(double2byte(frame));
	else
	{
		(void)fprintf(stderr,
			"tobyte: data size (%d) unrecognised\n", bitpix);
		return(free_frame(frame));
	}
}

FRSTR *normalise(frame)
FRSTR *frame;
{
	if (is_null_frame(frame, "writeframe"))
		return(frame);

	if (frame->scalefactor != 1.0)
	{
		int trunc_upper = 0, trunc_lower = 0;
		if (frame->hdr->dime.bitpix == 16)
		{
			short *dat2;
			int i, t;
			dat2 = (short *)frame->dat;
			for(i=0; i<frame->hdr->dime.dim[1]*frame->hdr->dime.dim[2]
				* frame->hdr->dime.dim[3]; i++)
			{
				t = dat2[i]*frame->scalefactor;
				if (t>32767)
				{
					t=32767;
					trunc_upper++;
				}
				else if (t<-32768)
				{
					t=-32768;
					trunc_lower++;
				}
				dat2[i] = t;
			}
			frame->scalefactor = 1.0;
		}
		else if (frame->hdr->dime.bitpix == 8)
		{
			int i, t;
			unsigned char *dat;
			dat = frame->dat;
			for(i=0; i<frame->hdr->dime.dim[1]*frame->hdr->dime.dim[2]
				* frame->hdr->dime.dim[3]; i++)
			{
				t = dat[i]*frame->scalefactor;
				if (t>255)
				{
					t=255;
					trunc_upper++;
				}
				else if (t<0)
				{
					t=0;
					trunc_lower++;
				}
				dat[i] = t;
			}
			frame->hdr->dime.glmax*=frame->scalefactor;
			frame->hdr->dime.glmin*=frame->scalefactor;
			frame->scalefactor = 1.0;

		}
		if ((trunc_upper || trunc_lower))
		{
		  //			(void)fprintf(stderr,"short2byte: %d upper values truncated, %d lower values truncated\n",trunc_upper, trunc_lower);
		}
	}
	if (frame->hdr->dime.bitpix == 16)
	{
		if (frame->hdr->dime.glmax > 32767)
			frame->hdr->dime.glmax = 32767;
		if (frame->hdr->dime.glmin < -32768)
			frame->hdr->dime.glmin = -32768;
	}
	else if (frame->hdr->dime.bitpix == 8)
	{
		if (frame->hdr->dime.glmax > 255)
			frame->hdr->dime.glmax = 255;
		if (frame->hdr->dime.glmin < 0)
			frame->hdr->dime.glmin = 0;
	}

	return(frame);
}

int writeframe(frame, frameno, filename)
FRSTR *frame;
int frameno;
char *filename;
{
  struct dsr hdr;
  int i, frsize;
  FILE *fp;

  if (is_null_frame(frame, "writeframe"))
    return(-1);

/* Hiroshi */
  bcopy((char *)frame->hdr, (char *)(&hdr), sizeof(hdr));
  hdr.dime.dim[4] = 1;

  if (frameno > hdr.dime.dim[4])
    hdr.dime.dim[4] = frameno;

  for(i=1; i<4; i++){
    if (hdr.dime.dim[i] != frame->hdr->dime.dim[i]){
      (void)fprintf(stderr,
		    "writeframe: %s frame %d: dim%d not compatible (%d != %d)\n",
		    filename, frameno, i,hdr.dime.dim[i],frame->hdr->dime.dim[i]);
      return(-1);
    }
  }
  for(i=1; i<4; i++){
    if (hdr.dime.pixdim[i] != frame->hdr->dime.pixdim[i]){
      (void)fprintf(stderr,
		    "writeframe: %s frame %d: pixdimdim%d not compatible (%f != %f)\n",
		    filename, frameno, i,hdr.dime.pixdim[i],
		    frame->hdr->dime.pixdim[i]);
      return(-1);
    }
  }

  if (hdr.dime.bitpix != frame->hdr->dime.bitpix){
    if (hdr.dime.bitpix == 16)
      (void)toshort(frame);
    else if (hdr.dime.bitpix == 8)
      (void)tobyte(normalise(frame));
  }
  if (hdr.dime.glmax < frame->hdr->dime.glmax*frame->scalefactor)
    hdr.dime.glmax = frame->hdr->dime.glmax*frame->scalefactor;
  if (hdr.dime.glmin > frame->hdr->dime.glmin*frame->scalefactor)
    hdr.dime.glmin = frame->hdr->dime.glmin*frame->scalefactor;
/* Hiroshi */
  fp = fopen(image_name(filename),"wb");
  frsize = frame_size(frame->hdr);
  fseek(fp,frsize*(frameno - 1),0);
  fwrite(frame->dat,frsize,1,fp);
  fclose(fp);
  if(need_swap_flag){
	exchange_hdr(&hdr);
  }
  fp = fopen(header_name(filename),"wb");
  fwrite(frame->hdr,sizeof(struct dsr),1,fp);
  fclose(fp);
  return(0);
}

int is_null_frame(frame, str)
FRSTR *frame;
char *str;
{
	if (frame == (FRSTR *)0)
	{
		return(1);
	}
	return(0);
}

int frame_size(hdr)
struct dsr *hdr;
{
	if (hdr == (struct dsr *)0)
	{
		(void)fprintf(stderr, "FATAL: frame_size(NULL)\n");
		exit(1);
	}
	return((hdr->dime.dim[1]*hdr->dime.dim[2]*hdr->dime.bitpix + 7)
		/8 * hdr->dime.dim[3]);
}

char *mcalloc(a,b)
unsigned int a,b;
{
	char *mem;
	mem =(char *)calloc(a,b);
	while(mem == (char *)0)
	{
		static char str[16];
		(void)fprintf(stderr, "mcalloc: cant get %dk of memory (%u*%u)\n", a*b/1024, a,b);
		if (!(isatty(fileno(stdin))))
			exit(1);
		(void)fprintf(stderr, "try again [y/n]? ");
		(void)fflush(stderr);
		if (fgets(str, 16, stdin) != str)
		{
			perror("mcalloc");
			exit(1);
		}
		if ((str[0] != 'y') && (str[0] != 'Y'))
		{
			(void)fprintf(stderr, "bye...\n");
			(void)exit(1);
		}
		mem = (char *)calloc(a,b);
	}
	return(mem);
}

void mfree(mem)
char *mem;
{
	if (mem)
		free(mem);
	else
		(void)fprintf(stderr,
			"mfree: attempt at freeing null pointer\n");
}

FRSTR *free_frame(frame)
FRSTR *frame;
{
	if ((frame != (FRSTR *)0) && (frame->hdr != (struct dsr *)0))
	{
		if (frame->dat != (unsigned char *)0)
		{
			mfree((char *)frame->dat);
			frame->dat = 0;
		}
		/*
		if (frame->vol != (unsigned char ***)0)
			free_vol(frame->vol,frame->hdr->dime.dim[3]);
		*/
		mfree((char *)frame->hdr);
		frame->hdr = 0;
		mfree((char *)frame);
		frame = 0;
		return((FRSTR *)0);
	}
	(void)fprintf(stderr, "free_frame: null frame\n");
	return((FRSTR *)0);
}

FRSTR *byte2short(frame)
FRSTR *frame;
{
	int i, frsize;
	unsigned char *dat;
	short *dat2;

	frsize = frame_size(frame->hdr);

	dat2 = (short *)mcalloc((unsigned)frsize, sizeof(short));
	dat = (unsigned char *)frame->dat;

	for(i=0; i<frsize; i++)
		dat2[i] = dat[i];

	frame->hdr->dime.bitpix=16;
	frame->hdr->dime.datatype=SPM_SIGNED_SHORT;
	mfree((char *)dat);
	dat= 0;
	frame->dat = (unsigned char *)dat2;
	/*
	  free_vol(frame->vol,frame->hdr->dime.dim[3]);
	*/
	/* we don't use convert2vol *
	frame->vol = convert2vol(dat,
		frame->hdr->dime.dim[1], frame->hdr->dime.dim[2],
		frame->hdr->dime.dim[3], frame->hdr->dime.bitpix);
	*/
	return(frame);
}

FRSTR *toshort(frame)
FRSTR *frame;
{
	int bitpix;
	if (is_null_frame(frame, "toshort"))
		return(frame);
	bitpix = frame->hdr->dime.bitpix;
	frame->hdr->dime.datatype=SPM_SIGNED_SHORT;
	if (bitpix == 8)
		return(byte2short(frame));
	else if (bitpix == 16)
		return(frame);
	else
	{
		(void)fprintf(stderr,
			"tobyte: data size (%d) unrecognised\n", bitpix);
		return(free_frame(frame));
	}
}

int read_hdr(file_name, hdr)
char *file_name;
struct dsr *hdr;
{
  FILE *fp;
  if ((fp = fopen(file_name, "r")) == (FILE *)0){
    perror(file_name);
    return(-1);
  }
  if (fread((char *)hdr, sizeof(struct dsr), 1, fp) != 1){
    perror(file_name);
    (void)fclose(fp);
    return(-1);
  }
  (void)fclose(fp);

  if(hdr->hk.sizeof_hdr!=sizeof(struct dsr)){
    need_swap_flag = 1;
  }
  else need_swap_flag = 0;

  if(need_swap_flag){
	exchange_hdr(hdr);
  }
  if (hdr->dime.bitpix != 1 && hdr->dime.bitpix != 8 && hdr->dime.bitpix != 16 && hdr->dime.bitpix != 32&& hdr->dime.bitpix != 64){
    (void)fprintf(stderr,"read_hdr: %s: dime.bitpix == %d\n", file_name, hdr->dime.bitpix);
    return(-1);
  }
  orig_bitpix = hdr->dime.bitpix;
  orig_datatype = hdr->dime.datatype;
  orig_glmax = hdr->dime.glmax;
  orig_glmin = hdr->dime.glmin;
  return(0);
}

FRSTR *gethdr(name)
char *name;
{
	struct dsr *hdr;
	FRSTR *frame;
	int frsize = 0;
	
	unsigned char *dat;
	hdr = (struct dsr *)mcalloc(1,sizeof(struct dsr));
	if (read_hdr(header_name(name), hdr) != 0)
	{
		mfree((char *)hdr);
		hdr = 0;
		return((FRSTR *)0);
	}
	frsize = frame_size(hdr);
	dat = (unsigned char *)mcalloc((unsigned)frsize, 1);
	frame = (FRSTR *)mcalloc(sizeof(FRSTR), 1);
	frame->hdr = hdr;
	frame->dat = dat;
	frame->frameno = 1;
	frame->scalefactor = 1.0;
	/* now I don't use convert2vol 
	frame->vol = convert2vol(dat, hdr->dime.dim[1],hdr->dime.dim[2],
		hdr->dime.dim[3], frame->hdr->dime.bitpix);
	*/
	return(frame);
}
FRSTR *gethdr_import(name,hdr)
char *name;
struct dsr *hdr;
{
  FRSTR *frame;
  int frsize = 0;
	
  unsigned char *dat;
  frsize = frame_size(hdr);
  dat = (unsigned char *)mcalloc((unsigned)frsize, 1);
  frame = (FRSTR *)mcalloc(sizeof(FRSTR), 1);
  frame->hdr = hdr;
  frame->dat = dat;
  frame->frameno = 1;
  frame->scalefactor = 1.0;
  return(frame);
}

/* read raw data with proper header */
FRSTR *getframe_import(name, frameno,frame)
char *name;
int frameno;
FRSTR *frame;
{
  FILE *fp;
  int frsize;

  if ((fp = fopen(name, "r")) == (FILE *)0){
    perror(image_name(name));
    return((FRSTR *)0);
  }

  frsize = frame_size(frame->hdr);
  (void)fseek(fp, (long)(frsize*(frameno-1)+frame->hdr->dime.vox_offset), 0);
  if (fread((char *)frame->dat, 1, frsize, fp) != frsize){
    (void)fprintf(stderr, "%s: cant read frame %d\n", image_name(name), frameno);
    (void)fclose(fp);
    return(free_frame(frame));
  }
  (void)fclose(fp);
  frame->frameno = frameno;
  /* scalefactor is now in funused1 */
  frame->scalefactor = frame->hdr->dime.funused1;
  return(frame);
}

FRSTR *getframe(name, frameno)
char *name;
int frameno;
{
  FILE *fp;
  int frsize;
  FRSTR *frame;

  if ((frame = gethdr(name)) == (FRSTR *)0)
    return(frame);

  if ((fp = fopen(image_name(name), "r")) == (FILE *)0){
    perror(image_name(name));
    return((FRSTR *)0);
  }

  frsize = frame_size(frame->hdr);
  (void)fseek(fp, (long)(frsize*(frameno-1)+frame->hdr->dime.vox_offset), 0);
  if (fread((char *)frame->dat, 1, frsize, fp) != frsize){
    (void)fprintf(stderr, "%s: cant read frame %d\n", image_name(name), frameno);
    (void)fclose(fp);
    return(free_frame(frame));
  }
  (void)fclose(fp);
  frame->frameno = frameno;
  /* scalefactor is now in funused1 */
  if(frame->hdr->dime.funused1==0){
    frame->scalefactor = 1.0;
  }
  else{
    frame->scalefactor = frame->hdr->dime.funused1;
  }
  return(frame);
}

char *header_name(filename)
char *filename;
{
  static char hdrname[1024];
  int itemp;
  if ((itemp = strlen(filename)) > 1000)
    {
      (void)fprintf(stderr, "%s: filename too long\n",filename);
      (void)sprintf(hdrname, "bloody_long_file_name.hdr");
    }
  (void)strcpy(hdrname, filename);
  if (itemp < 4) itemp=4;
  if (!strcmp(hdrname+itemp-4,".img") || !strcmp(hdrname+itemp-4,".hdr"))
    hdrname[itemp-4] = '\0';
  (void)strcat(hdrname, ".hdr");
  return(hdrname);
}

char *lkup_name(filename)
char *filename;
{
  static char hdrname[1024];
  int itemp;
  if ((itemp = strlen(filename)) > 1000)
    {
      (void)fprintf(stderr, "%s: filename too long\n",filename);
      (void)sprintf(hdrname, "bloody_long_file_name.hdr");
    }
  (void)strcpy(hdrname, filename);
  if (itemp < 4) itemp=4;
  if (!strcmp(hdrname+itemp-4,".img") || !strcmp(hdrname+itemp-4,".hdr"))
    hdrname[itemp-4] = '\0';
  (void)strcat(hdrname, ".lkup");
  return(hdrname);
}

char *image_name(filename)
char *filename;
{
  static char imgname[1024];
  int itemp;
  if ((itemp = strlen(filename)) > 1000){
    (void)fprintf(stderr, "%s: filename too long\n",filename);
    (void)sprintf(imgname, "bloody_long_file_name.img");
  }
  (void)strcpy(imgname, filename);
  if (itemp < 4) itemp=4; 
  if (!strcmp(imgname+itemp-4,".img") || !strcmp(imgname+itemp-4,".hdr"))
    imgname[itemp-4] = '\0';
  (void)strcat(imgname, ".img");
  return(imgname);
}
