/* Copyright 2000,2001 Hiroshi Watabe*/
/* Initialize gpetview */
/* $Id: init_gpetview.c,v 1.6 2001/11/07 13:43:35 watabe Exp $ */
#include "gpetview.h"
#include "support.h"

void init_gpetview()
{
  char *env_home_dir;
  char rcname[255];
  FILE *fp;
  char sbuf[255],char1[10],char2[10],char3[10];
  GtkWidget *button;

  gcolorbar = lookup_widget(gpetview,"colorbar");
  env_home_dir = getenv("HOME");
  sprintf(rcname,"%s/.gpetviewrc",env_home_dir);
  fp = fopen(rcname,"rt");
  if(fp==NULL){
    /* initialize all params */
    color_flag = RAINBOW_COLOR;
    numbering_flag = 1;
    interpolate_flag = 1;
    seq_flag = TRANS;
    zoom_factor = 1.0;
    imax_flag = ALL_IMAGE;
    revy_flag = 1;
  }
  else{
    /* find color */
    while(1){
      fgets(sbuf,255,fp);
      if(strncasecmp(sbuf,"color",5)==0){
	sscanf(sbuf,"%s %s\n",char1,char2);
	if(strncasecmp(char2,"rainbow",7)==0){
	  color_flag = RAINBOW_COLOR;
	  button = lookup_widget(settingshell,"set_rainbow_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	}
	else{
	  if(strncasecmp(char2,"hot",3)==0){
	    color_flag = HOT_COLOR;
	    button = lookup_widget(settingshell,"set_hot_button");
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	  }
	  else{
	    if(strncasecmp(char2,"gray",4)==0){
	      color_flag = GRAY_COLOR;
	      button = lookup_widget(settingshell,"set_gray_button");
	      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	    }
	    else{
	      if(strncasecmp(char2,"lkup",4)==0){
		color_flag = LKUP_COLOR;
		button = lookup_widget(settingshell,"set_lkup_button");
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	      }
	      else{
		if(strncasecmp(char2,"invgray",7)==0){
		  color_flag = INVGRAY_COLOR;
		  button = lookup_widget(settingshell,"set_invgray_button");
		  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
		}
		else{
		  color_flag = RAINBOW_COLOR;
		}
	      }
	    }
	  }
	}
	break;
      }
      if(feof(fp)){
	color_flag = RAINBOW_COLOR;
	break;
      }
    }
  /* Numbering */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
      if(strncasecmp(sbuf,"number",6)==0){
	sscanf(sbuf,"%s %s\n",char1,char2);
	if(strncasecmp(char2,"on",2)==0){
	  numbering_flag = 1;
	  button = lookup_widget(settingshell,"set_num_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	}
	else{
	  if(strncasecmp(char2,"off",3)==0){
	    numbering_flag = 0;
	    button = lookup_widget(settingshell,"set_num_button");
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), FALSE);
	  }
	  else{
	    numbering_flag = 1;
	  }
	}
	break;
      }
      if(feof(fp)){
	numbering_flag = 1;
	break;
      }
    }
  /* interpolate */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
      if(strncasecmp(sbuf,"interpolate",11)==0){
	sscanf(sbuf,"%s %s\n",char1,char2);
	if(strncasecmp(char2,"on",2)==0){
	  interpolate_flag = 1;
	  button = lookup_widget(settingshell,"set_interpolate_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	}
	else{
	  if(strncasecmp(char2,"off",3)==0){
	    interpolate_flag = 0;
	    button = lookup_widget(settingshell,"set_interpolate_button");
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), FALSE);
	  }
	  else{
	    interpolate_flag = 1;
	  }
	}
	break;
      }
      if(feof(fp)){
	interpolate_flag = 1;
	break;
      }
    }
    /* set section*/
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
      if(strncasecmp(sbuf,"slice",5)==0){
	sscanf(sbuf,"%s %s\n",char1,char2);
	if(strncasecmp(char2,"trans",5)==0){
	  seq_flag = TRANS;
	  button = lookup_widget(settingshell,"set_trans_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	}
	else{
	  if(strncasecmp(char2,"coro",4)==0){
	    seq_flag = CORO;
	    button = lookup_widget(settingshell,"set_coronal_button");
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	  }
	  else{
	    if(strncasecmp(char2,"sagi",4)==0){
	      seq_flag = SAGI;
	      button = lookup_widget(settingshell,"set_sagital_button");
	      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	    }
	    else{
	      seq_flag = TRANS;
	    }
	  }
	}
	break;
      }
      if(feof(fp)){
	seq_flag = TRANS;
	break;
      }
    }
  /* Zooming */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
      if(strncasecmp(sbuf,"zoom",4)==0){
	sscanf(sbuf,"%s %s\n",char1,char2);
	zoom_factor = (float)atof(char2);
	if(zoom_factor<=0){
	  zoom_factor = 1.0;
	  break;
	}
	else{
	  button = lookup_widget(settingshell,"set_zoom");
	  gtk_entry_set_text (GTK_ENTRY (button), char2);
	  break;
	}
      }
      if(feof(fp)){
	zoom_factor = 1.0;
	break;
      }
    }
  /* imax */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
      if(strncasecmp(sbuf,"max",3)==0){
	sscanf(sbuf,"%s %s\n",char1,char2);
	if(strncasecmp(char2,"all",3)==0){
	  imax_flag = ALL_IMAGE;
	  button = lookup_widget(settingshell,"set_all_image_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	}
	else{
	  if(strncasecmp(char2,"each",4)==0){
	    imax_flag = EACH_IMAGE;
	    button = lookup_widget(settingshell,"set_each_image_button");
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	  }
	  else{
	    imax_flag = ALL_IMAGE;
	  }
	}
	break;
      }
      if(feof(fp)){
	imax_flag = ALL_IMAGE;
	break;
      }
    }
  /* ReverseY */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
      if(strncasecmp(sbuf,"revy",4)==0){
	sscanf(sbuf,"%s %s\n",char1,char2);
	if(strncasecmp(char2,"on",2)==0){
	  revy_flag = 1;
	  button = lookup_widget(settingshell,"revy_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	}
	else{
	  revy_flag = 0;
	  button = lookup_widget(settingshell,"revy_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), FALSE);
	}
	break;
      }
      if(feof(fp)){
	revy_flag = 1;
	break;
      }
    }
  /* Window size */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
      if(strncasecmp(sbuf,"window",6)==0){
	sscanf(sbuf,"%s %s %s\n",char1,char2,char3);
	view_width = atoi(char2);
	view_height = atoi(char3);
	break;
      }
      if(feof(fp)){
	break;
      }
    }
  /* Canvas size */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
      if(strncasecmp(sbuf,"canvas",6)==0){
	sscanf(sbuf,"%s %s %s\n",char1,char2,char3);
	canvas_width = atoi(char2);
	canvas_height = atoi(char3);
	break;
      }
      if(feof(fp)){
	break;
      }
    }
  /* Pickp */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
      if(strncasecmp(sbuf,"pickp",5)==0){
	sscanf(sbuf,"%s %s\n",char1,char2);
	if(strncasecmp(char2,"on",2)==0){
	  roi_flag = figure.type = PICKP;
	  roi_draw_flag = 1;
	}
	break;
      }
      if(feof(fp)){
	break;
      }
    }
    fclose(fp);
  }
}
