/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

GtkWidget*
create_gpetview (void)
{
  GtkWidget *gpetview;
  GtkWidget *vbox1;
  GtkWidget *menubar1;
  GtkWidget *file;
  GtkWidget *file_menu;
  GtkAccelGroup *file_menu_accels;
  GtkWidget *image_file;
  GtkWidget *import_raw_file1;
  GtkWidget *quit;
  GtkWidget *edit;
  GtkWidget *edit_menu;
  GtkAccelGroup *edit_menu_accels;
  GtkWidget *clear_screen;
  GtkWidget *roi;
  GtkWidget *setting;
  GtkWidget *filter;
  GtkWidget *misc;
  GtkWidget *misc_menu;
  GtkAccelGroup *misc_menu_accels;
  GtkWidget *roi_info;
  GtkWidget *header_info;
  GtkWidget *clear_view;
  GtkWidget *help;
  GtkWidget *help_menu;
  GtkAccelGroup *help_menu_accels;
  GtkWidget *about;
  GtkWidget *hbox12;
  GtkWidget *view_button;
  GtkWidget *message_entry;
  GtkWidget *hbox1;
  GtkWidget *colorbar;
  GtkWidget *scrolledwindow1;
  GtkWidget *viewport1;
  GtkWidget *canvas;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  gpetview = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (gpetview), "gpetview", gpetview);
  gtk_window_set_title (GTK_WINDOW (gpetview), "gpetview");
  gtk_window_set_position (GTK_WINDOW (gpetview), GTK_WIN_POS_CENTER);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (gpetview), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_ref (menubar1);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "menubar1", menubar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, FALSE, 0);

  file = gtk_menu_item_new_with_label ("File");
  gtk_widget_ref (file);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "file", file,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file);
  gtk_container_add (GTK_CONTAINER (menubar1), file);

  file_menu = gtk_menu_new ();
  gtk_widget_ref (file_menu);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "file_menu", file_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (file), file_menu);
  file_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (file_menu));

  image_file = gtk_menu_item_new_with_label ("Image File...");
  gtk_widget_ref (image_file);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "image_file", image_file,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_file);
  gtk_container_add (GTK_CONTAINER (file_menu), image_file);
  gtk_widget_add_accelerator (image_file, "activate", accel_group,
                              GDK_o, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  import_raw_file1 = gtk_menu_item_new_with_label ("Import Raw File...");
  gtk_widget_ref (import_raw_file1);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "import_raw_file1", import_raw_file1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_raw_file1);
  gtk_container_add (GTK_CONTAINER (file_menu), import_raw_file1);

  quit = gtk_menu_item_new_with_label ("Quit...");
  gtk_widget_ref (quit);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "quit", quit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (quit);
  gtk_container_add (GTK_CONTAINER (file_menu), quit);
  gtk_widget_add_accelerator (quit, "activate", accel_group,
                              GDK_q, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  edit = gtk_menu_item_new_with_label ("Edit");
  gtk_widget_ref (edit);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "edit", edit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit);
  gtk_container_add (GTK_CONTAINER (menubar1), edit);

  edit_menu = gtk_menu_new ();
  gtk_widget_ref (edit_menu);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "edit_menu", edit_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (edit), edit_menu);
  edit_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (edit_menu));

  clear_screen = gtk_menu_item_new_with_label ("Clear Screen");
  gtk_widget_ref (clear_screen);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "clear_screen", clear_screen,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clear_screen);
  gtk_container_add (GTK_CONTAINER (edit_menu), clear_screen);
  gtk_widget_add_accelerator (clear_screen, "activate", accel_group,
                              GDK_c, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  roi = gtk_menu_item_new_with_label ("ROI...");
  gtk_widget_ref (roi);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "roi", roi,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi);
  gtk_container_add (GTK_CONTAINER (edit_menu), roi);
  gtk_widget_add_accelerator (roi, "activate", accel_group,
                              GDK_r, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  setting = gtk_menu_item_new_with_label ("Setting..");
  gtk_widget_ref (setting);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "setting", setting,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (setting);
  gtk_container_add (GTK_CONTAINER (edit_menu), setting);
  gtk_widget_add_accelerator (setting, "activate", accel_group,
                              GDK_s, 0,
                              GTK_ACCEL_VISIBLE);

  filter = gtk_menu_item_new_with_label ("Filter...");
  gtk_widget_ref (filter);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "filter", filter,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (filter);
  gtk_container_add (GTK_CONTAINER (edit_menu), filter);

  misc = gtk_menu_item_new_with_label ("Misc");
  gtk_widget_ref (misc);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "misc", misc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (misc);
  gtk_container_add (GTK_CONTAINER (menubar1), misc);

  misc_menu = gtk_menu_new ();
  gtk_widget_ref (misc_menu);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "misc_menu", misc_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (misc), misc_menu);
  misc_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (misc_menu));

  roi_info = gtk_menu_item_new_with_label ("ROI Info...");
  gtk_widget_ref (roi_info);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "roi_info", roi_info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_info);
  gtk_container_add (GTK_CONTAINER (misc_menu), roi_info);

  header_info = gtk_menu_item_new_with_label ("Header Info...");
  gtk_widget_ref (header_info);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "header_info", header_info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (header_info);
  gtk_container_add (GTK_CONTAINER (misc_menu), header_info);
  gtk_widget_add_accelerator (header_info, "activate", accel_group,
                              GDK_i, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  clear_view = gtk_menu_item_new_with_label ("Clear & View");
  gtk_widget_ref (clear_view);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "clear_view", clear_view,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clear_view);
  gtk_container_add (GTK_CONTAINER (misc_menu), clear_view);
  gtk_tooltips_set_tip (tooltips, clear_view, "Clear Screen and View image", NULL);
  gtk_widget_add_accelerator (clear_view, "activate", accel_group,
                              GDK_v, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  help = gtk_menu_item_new_with_label ("Help...");
  gtk_widget_ref (help);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "help", help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (help);
  gtk_container_add (GTK_CONTAINER (menubar1), help);

  help_menu = gtk_menu_new ();
  gtk_widget_ref (help_menu);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "help_menu", help_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (help), help_menu);
  help_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (help_menu));

  about = gtk_menu_item_new_with_label ("About");
  gtk_widget_ref (about);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "about", about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about);
  gtk_container_add (GTK_CONTAINER (help_menu), about);

  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox12);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "hbox12", hbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox12);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox12, FALSE, FALSE, 0);

  view_button = gtk_button_new_with_label ("VIEW");
  gtk_widget_ref (view_button);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "view_button", view_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (view_button);
  gtk_box_pack_start (GTK_BOX (hbox12), view_button, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, view_button, "View Image (short cut V)", NULL);
  gtk_widget_add_accelerator (view_button, "clicked", accel_group,
                              GDK_V, 0,
                              GTK_ACCEL_VISIBLE);

  message_entry = gtk_entry_new ();
  gtk_widget_ref (message_entry);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "message_entry", message_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_entry);
  gtk_box_pack_start (GTK_BOX (hbox12), message_entry, TRUE, TRUE, 0);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  colorbar = gtk_drawing_area_new ();
  gtk_widget_ref (colorbar);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "colorbar", colorbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (colorbar);
  gtk_box_pack_start (GTK_BOX (hbox1), colorbar, FALSE, FALSE, 3);
  gtk_widget_set_usize (colorbar, 30, 300);
  gtk_widget_set_events (colorbar, GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (hbox1), scrolledwindow1, TRUE, TRUE, 0);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "viewport1", viewport1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport1);

  canvas = gtk_drawing_area_new ();
  gtk_widget_ref (canvas);
  gtk_object_set_data_full (GTK_OBJECT (gpetview), "canvas", canvas,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (canvas);
  gtk_container_add (GTK_CONTAINER (viewport1), canvas);
  gtk_widget_set_events (canvas, GDK_BUTTON_MOTION_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK);

  gtk_signal_connect (GTK_OBJECT (gpetview), "delete_event",
                      GTK_SIGNAL_FUNC (on_gpetview_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (image_file), "activate",
                      GTK_SIGNAL_FUNC (on_image_file_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (import_raw_file1), "activate",
                      GTK_SIGNAL_FUNC (on_import_raw_file1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (quit), "activate",
                      GTK_SIGNAL_FUNC (on_quit_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (clear_screen), "activate",
                      GTK_SIGNAL_FUNC (on_clear_screen_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi), "activate",
                      GTK_SIGNAL_FUNC (on_roi_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (setting), "activate",
                      GTK_SIGNAL_FUNC (on_setting_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (filter), "activate",
                      GTK_SIGNAL_FUNC (on_filter_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_info), "activate",
                      GTK_SIGNAL_FUNC (on_roi_info_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (header_info), "activate",
                      GTK_SIGNAL_FUNC (on_header_info_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (clear_view), "activate",
                      GTK_SIGNAL_FUNC (clear_view_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (help), "activate",
                      GTK_SIGNAL_FUNC (on_help_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (about), "activate",
                      GTK_SIGNAL_FUNC (on_about_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (view_button), "clicked",
                      GTK_SIGNAL_FUNC (on_view_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (colorbar), "button_press_event",
                      GTK_SIGNAL_FUNC (on_colorbar_button_press_event),
                      colorbar);
  gtk_signal_connect (GTK_OBJECT (colorbar), "button_release_event",
                      GTK_SIGNAL_FUNC (on_colorbar_button_release_event),
                      colorbar);
  gtk_signal_connect (GTK_OBJECT (colorbar), "expose_event",
                      GTK_SIGNAL_FUNC (on_colorbar_expose_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (canvas), "expose_event",
                      GTK_SIGNAL_FUNC (on_canvas_expose_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (canvas), "button_press_event",
                      GTK_SIGNAL_FUNC (on_canvas_button_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (canvas), "button_release_event",
                      GTK_SIGNAL_FUNC (on_canvas_button_release_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (canvas), "motion_notify_event",
                      GTK_SIGNAL_FUNC (on_canvas_motion_notify_event),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (gpetview), "tooltips", tooltips);

  gtk_window_add_accel_group (GTK_WINDOW (gpetview), accel_group);

  return gpetview;
}

GtkWidget*
create_aboutDialog (void)
{
  GtkWidget *aboutDialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *label1;
  GtkWidget *dialog_action_area1;
  GtkWidget *ok_about;

  aboutDialog = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (aboutDialog), "aboutDialog", aboutDialog);
  gtk_window_set_title (GTK_WINDOW (aboutDialog), "About gpetview");
  GTK_WINDOW (aboutDialog)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (aboutDialog), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (aboutDialog), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (aboutDialog)->vbox;
  gtk_object_set_data (GTK_OBJECT (aboutDialog), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  label1 = gtk_label_new ("gpetview\nImage Viewer developed by H. Watabe\nVersion 1.10beta");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (aboutDialog), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), label1, FALSE, FALSE, 0);

  dialog_action_area1 = GTK_DIALOG (aboutDialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (aboutDialog), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  ok_about = gtk_button_new_with_label ("OK");
  gtk_widget_ref (ok_about);
  gtk_object_set_data_full (GTK_OBJECT (aboutDialog), "ok_about", ok_about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_about);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), ok_about, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (ok_about), "clicked",
                      GTK_SIGNAL_FUNC (on_ok_about_clicked),
                      aboutDialog);

  return aboutDialog;
}

GtkWidget*
create_filewindow (void)
{
  GtkWidget *filewindow;
  GtkWidget *vbox2;
  GtkWidget *vbox3;
  GtkWidget *hbox2;
  GtkWidget *flabel;
  GtkWidget *file_entry;
  GtkWidget *select_button;
  GtkWidget *hbox4;
  GtkWidget *label3;
  GtkWidget *hbox22;
  GtkWidget *file_from_entry;
  GtkWidget *label20;
  GtkWidget *file_to_entry;
  GtkWidget *hbuttonbox1;
  GtkWidget *load_button;
  GtkWidget *save_button;
  GtkWidget *cancel_button;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  filewindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (filewindow), "filewindow", filewindow);
  gtk_window_set_title (GTK_WINDOW (filewindow), "file window");
  gtk_window_set_position (GTK_WINDOW (filewindow), GTK_WIN_POS_MOUSE);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (filewindow), vbox2);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (vbox2), vbox3, FALSE, TRUE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox2, TRUE, TRUE, 0);

  flabel = gtk_label_new ("File name: ");
  gtk_widget_ref (flabel);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "flabel", flabel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (flabel);
  gtk_box_pack_start (GTK_BOX (hbox2), flabel, FALSE, FALSE, 0);

  file_entry = gtk_entry_new ();
  gtk_widget_ref (file_entry);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "file_entry", file_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file_entry);
  gtk_box_pack_start (GTK_BOX (hbox2), file_entry, TRUE, TRUE, 0);

  select_button = gtk_button_new_with_label ("...");
  gtk_widget_ref (select_button);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "select_button", select_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (select_button);
  gtk_box_pack_start (GTK_BOX (hbox2), select_button, FALSE, FALSE, 0);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox4, TRUE, TRUE, 0);

  label3 = gtk_label_new ("From:");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (hbox4), label3, FALSE, FALSE, 0);

  hbox22 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox22);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "hbox22", hbox22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox22);
  gtk_box_pack_start (GTK_BOX (hbox4), hbox22, TRUE, TRUE, 0);

  file_from_entry = gtk_entry_new_with_max_length (3);
  gtk_widget_ref (file_from_entry);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "file_from_entry", file_from_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file_from_entry);
  gtk_box_pack_start (GTK_BOX (hbox22), file_from_entry, TRUE, FALSE, 0);

  label20 = gtk_label_new ("To:");
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label20);
  gtk_box_pack_start (GTK_BOX (hbox22), label20, FALSE, FALSE, 0);

  file_to_entry = gtk_entry_new_with_max_length (3);
  gtk_widget_ref (file_to_entry);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "file_to_entry", file_to_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file_to_entry);
  gtk_box_pack_start (GTK_BOX (hbox22), file_to_entry, TRUE, FALSE, 0);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox2), hbuttonbox1, FALSE, TRUE, 0);

  load_button = gtk_button_new_with_label ("Load");
  gtk_widget_ref (load_button);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "load_button", load_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (load_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), load_button);
  GTK_WIDGET_SET_FLAGS (load_button, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips, load_button, "Load Images", NULL);

  save_button = gtk_button_new_with_label ("Save");
  gtk_widget_ref (save_button);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "save_button", save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), save_button);
  GTK_WIDGET_SET_FLAGS (save_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (filewindow), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), cancel_button);
  GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (filewindow), "delete_event",
                      GTK_SIGNAL_FUNC (on_filewindow_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (select_button), "clicked",
                      GTK_SIGNAL_FUNC (on_select_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (load_button), "clicked",
                      GTK_SIGNAL_FUNC (on_load_button_clicked),
                      filewindow);
  gtk_signal_connect (GTK_OBJECT (save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_save_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
                      GTK_SIGNAL_FUNC (on_cancel_button_clicked),
                      filewindow);

  gtk_object_set_data (GTK_OBJECT (filewindow), "tooltips", tooltips);

  return filewindow;
}

GtkWidget*
create_fileselection (void)
{
  GtkWidget *fileselection;
  GtkWidget *ok_button1;
  GtkWidget *cancel_button1;

  fileselection = gtk_file_selection_new ("ե");
  gtk_object_set_data (GTK_OBJECT (fileselection), "fileselection", fileselection);
  gtk_container_set_border_width (GTK_CONTAINER (fileselection), 10);
  gtk_window_set_position (GTK_WINDOW (fileselection), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (fileselection), TRUE);
  gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION (fileselection));

  ok_button1 = GTK_FILE_SELECTION (fileselection)->ok_button;
  gtk_object_set_data (GTK_OBJECT (fileselection), "ok_button1", ok_button1);
  gtk_widget_show (ok_button1);
  GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);

  cancel_button1 = GTK_FILE_SELECTION (fileselection)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (fileselection), "cancel_button1", cancel_button1);
  gtk_widget_show (cancel_button1);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (ok_button1), "clicked",
                      GTK_SIGNAL_FUNC (on_ok_button1_clicked),
                      fileselection);
  gtk_signal_connect (GTK_OBJECT (cancel_button1), "clicked",
                      GTK_SIGNAL_FUNC (on_cancel_button1_clicked),
                      fileselection);

  return fileselection;
}

GtkWidget*
create_yes_no_dialog (void)
{
  GtkWidget *yes_no_dialog;
  GtkWidget *dialog_vbox2;
  GtkWidget *label5;
  GtkWidget *dialog_action_area2;
  GtkWidget *hbox6;
  GtkWidget *yes_button;
  GtkWidget *no_button;

  yes_no_dialog = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (yes_no_dialog), "yes_no_dialog", yes_no_dialog);
  gtk_window_set_title (GTK_WINDOW (yes_no_dialog), "Yes or No");
  GTK_WINDOW (yes_no_dialog)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (yes_no_dialog), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (yes_no_dialog), TRUE);
  gtk_window_set_policy (GTK_WINDOW (yes_no_dialog), TRUE, TRUE, FALSE);

  dialog_vbox2 = GTK_DIALOG (yes_no_dialog)->vbox;
  gtk_object_set_data (GTK_OBJECT (yes_no_dialog), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  label5 = gtk_label_new ("Are you sure to quit?");
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (yes_no_dialog), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), label5, FALSE, FALSE, 0);

  dialog_action_area2 = GTK_DIALOG (yes_no_dialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (yes_no_dialog), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox6);
  gtk_object_set_data_full (GTK_OBJECT (yes_no_dialog), "hbox6", hbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), hbox6, FALSE, FALSE, 0);

  yes_button = gtk_button_new_with_label ("Yes");
  gtk_widget_ref (yes_button);
  gtk_object_set_data_full (GTK_OBJECT (yes_no_dialog), "yes_button", yes_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (yes_button);
  gtk_box_pack_start (GTK_BOX (hbox6), yes_button, FALSE, FALSE, 0);

  no_button = gtk_button_new_with_label ("No");
  gtk_widget_ref (no_button);
  gtk_object_set_data_full (GTK_OBJECT (yes_no_dialog), "no_button", no_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (no_button);
  gtk_box_pack_start (GTK_BOX (hbox6), no_button, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (yes_button), "clicked",
                      GTK_SIGNAL_FUNC (yes_quit_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (no_button), "clicked",
                      GTK_SIGNAL_FUNC (on_no_button_clicked),
                      yes_no_dialog);

  return yes_no_dialog;
}

GtkWidget*
create_settingshell (void)
{
  GtkWidget *settingshell;
  GtkWidget *table1;
  GtkWidget *label_colorbar;
  GtkWidget *label_maximum;
  GtkWidget *label_maxv;
  GtkWidget *label_zoom;
  GtkWidget *label_slice;
  GtkWidget *set_done_button;
  GtkWidget *hbox7;
  GSList *colortype_group = NULL;
  GtkWidget *set_rainbow_button;
  GtkWidget *set_hot_button;
  GtkWidget *set_gray_button;
  GtkWidget *set_invgray_button;
  GtkWidget *set_comb_button;
  GtkWidget *set_lkup_button;
  GtkWidget *hbox8;
  GSList *maxmodel_group = NULL;
  GtkWidget *set_each_image_button;
  GtkWidget *set_all_image_button;
  GtkWidget *set_input_user_abs_button;
  GtkWidget *set_input_user_rel_button;
  GtkWidget *hbox9;
  GSList *slicemodel_group = NULL;
  GtkWidget *set_trans_button;
  GtkWidget *set_coronal_button;
  GtkWidget *set_sagital_button;
  GtkWidget *hbox23;
  GtkWidget *set_maxv;
  GtkWidget *label_minv;
  GtkWidget *set_minv;
  GtkWidget *label_num;
  GtkWidget *hbox43;
  GtkWidget *set_zoom;
  GtkWidget *label_img_no;
  GtkWidget *img_no_entry;
  GtkWidget *hbox42;
  GtkWidget *set_num_button;
  GtkWidget *label35;
  GtkWidget *set_interpolate_button;
  GtkWidget *label36;
  GtkWidget *revy_button;

  settingshell = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (settingshell), "settingshell", settingshell);
  gtk_window_set_title (GTK_WINDOW (settingshell), "Setting");
  gtk_window_set_position (GTK_WINDOW (settingshell), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (settingshell), TRUE);

  table1 = gtk_table_new (7, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (settingshell), table1);

  label_colorbar = gtk_label_new ("ColorType");
  gtk_widget_ref (label_colorbar);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "label_colorbar", label_colorbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_colorbar);
  gtk_table_attach (GTK_TABLE (table1), label_colorbar, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label_maximum = gtk_label_new ("Image Max");
  gtk_widget_ref (label_maximum);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "label_maximum", label_maximum,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_maximum);
  gtk_table_attach (GTK_TABLE (table1), label_maximum, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label_maxv = gtk_label_new ("Maximum Value:");
  gtk_widget_ref (label_maxv);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "label_maxv", label_maxv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_maxv);
  gtk_table_attach (GTK_TABLE (table1), label_maxv, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label_zoom = gtk_label_new ("Zoom Factor:");
  gtk_widget_ref (label_zoom);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "label_zoom", label_zoom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_zoom);
  gtk_table_attach (GTK_TABLE (table1), label_zoom, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label_slice = gtk_label_new ("Slice");
  gtk_widget_ref (label_slice);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "label_slice", label_slice,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_slice);
  gtk_table_attach (GTK_TABLE (table1), label_slice, 0, 1, 4, 5,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  set_done_button = gtk_button_new_with_label ("Done");
  gtk_widget_ref (set_done_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_done_button", set_done_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_done_button);
  gtk_table_attach (GTK_TABLE (table1), set_done_button, 1, 2, 6, 7,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox7);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "hbox7", hbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox7);
  gtk_table_attach (GTK_TABLE (table1), hbox7, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  set_rainbow_button = gtk_radio_button_new_with_label (colortype_group, "Rainbow");
  colortype_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_rainbow_button));
  gtk_widget_ref (set_rainbow_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_rainbow_button", set_rainbow_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_rainbow_button);
  gtk_box_pack_start (GTK_BOX (hbox7), set_rainbow_button, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (set_rainbow_button), TRUE);

  set_hot_button = gtk_radio_button_new_with_label (colortype_group, "Hot");
  colortype_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_hot_button));
  gtk_widget_ref (set_hot_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_hot_button", set_hot_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_hot_button);
  gtk_box_pack_start (GTK_BOX (hbox7), set_hot_button, FALSE, FALSE, 0);

  set_gray_button = gtk_radio_button_new_with_label (colortype_group, "Gray");
  colortype_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_gray_button));
  gtk_widget_ref (set_gray_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_gray_button", set_gray_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_gray_button);
  gtk_box_pack_start (GTK_BOX (hbox7), set_gray_button, FALSE, FALSE, 0);

  set_invgray_button = gtk_radio_button_new_with_label (colortype_group, "Inv Gray");
  colortype_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_invgray_button));
  gtk_widget_ref (set_invgray_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_invgray_button", set_invgray_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_invgray_button);
  gtk_box_pack_start (GTK_BOX (hbox7), set_invgray_button, FALSE, FALSE, 0);

  set_comb_button = gtk_radio_button_new_with_label (colortype_group, "Comb");
  colortype_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_comb_button));
  gtk_widget_ref (set_comb_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_comb_button", set_comb_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_comb_button);
  gtk_box_pack_start (GTK_BOX (hbox7), set_comb_button, FALSE, FALSE, 0);

  set_lkup_button = gtk_radio_button_new_with_label (colortype_group, "Lkup");
  colortype_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_lkup_button));
  gtk_widget_ref (set_lkup_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_lkup_button", set_lkup_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_lkup_button);
  gtk_box_pack_start (GTK_BOX (hbox7), set_lkup_button, FALSE, FALSE, 0);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox8);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "hbox8", hbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox8);
  gtk_table_attach (GTK_TABLE (table1), hbox8, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  set_each_image_button = gtk_radio_button_new_with_label (maxmodel_group, "Each Image");
  maxmodel_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_each_image_button));
  gtk_widget_ref (set_each_image_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_each_image_button", set_each_image_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_each_image_button);
  gtk_box_pack_start (GTK_BOX (hbox8), set_each_image_button, FALSE, FALSE, 0);

  set_all_image_button = gtk_radio_button_new_with_label (maxmodel_group, "All Image");
  maxmodel_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_all_image_button));
  gtk_widget_ref (set_all_image_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_all_image_button", set_all_image_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_all_image_button);
  gtk_box_pack_start (GTK_BOX (hbox8), set_all_image_button, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (set_all_image_button), TRUE);

  set_input_user_abs_button = gtk_radio_button_new_with_label (maxmodel_group, "Input by User (Abs)");
  maxmodel_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_input_user_abs_button));
  gtk_widget_ref (set_input_user_abs_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_input_user_abs_button", set_input_user_abs_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_input_user_abs_button);
  gtk_box_pack_start (GTK_BOX (hbox8), set_input_user_abs_button, FALSE, FALSE, 0);

  set_input_user_rel_button = gtk_radio_button_new_with_label (maxmodel_group, "Input by User (Rel)");
  maxmodel_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_input_user_rel_button));
  gtk_widget_ref (set_input_user_rel_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_input_user_rel_button", set_input_user_rel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_input_user_rel_button);
  gtk_box_pack_start (GTK_BOX (hbox8), set_input_user_rel_button, FALSE, FALSE, 0);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox9);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "hbox9", hbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox9);
  gtk_table_attach (GTK_TABLE (table1), hbox9, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  set_trans_button = gtk_radio_button_new_with_label (slicemodel_group, "Transverse");
  slicemodel_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_trans_button));
  gtk_widget_ref (set_trans_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_trans_button", set_trans_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_trans_button);
  gtk_box_pack_start (GTK_BOX (hbox9), set_trans_button, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (set_trans_button), TRUE);

  set_coronal_button = gtk_radio_button_new_with_label (slicemodel_group, "Coronal");
  slicemodel_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_coronal_button));
  gtk_widget_ref (set_coronal_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_coronal_button", set_coronal_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_coronal_button);
  gtk_box_pack_start (GTK_BOX (hbox9), set_coronal_button, FALSE, FALSE, 0);

  set_sagital_button = gtk_radio_button_new_with_label (slicemodel_group, "Sagittal");
  slicemodel_group = gtk_radio_button_group (GTK_RADIO_BUTTON (set_sagital_button));
  gtk_widget_ref (set_sagital_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_sagital_button", set_sagital_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_sagital_button);
  gtk_box_pack_start (GTK_BOX (hbox9), set_sagital_button, FALSE, FALSE, 0);

  hbox23 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox23);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "hbox23", hbox23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox23);
  gtk_table_attach (GTK_TABLE (table1), hbox23, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  set_maxv = gtk_entry_new ();
  gtk_widget_ref (set_maxv);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_maxv", set_maxv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_maxv);
  gtk_box_pack_start (GTK_BOX (hbox23), set_maxv, TRUE, TRUE, 0);

  label_minv = gtk_label_new ("Minimum Value:");
  gtk_widget_ref (label_minv);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "label_minv", label_minv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_minv);
  gtk_box_pack_start (GTK_BOX (hbox23), label_minv, FALSE, FALSE, 0);

  set_minv = gtk_entry_new ();
  gtk_widget_ref (set_minv);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_minv", set_minv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_minv);
  gtk_box_pack_start (GTK_BOX (hbox23), set_minv, TRUE, TRUE, 0);

  label_num = gtk_label_new ("Numbering:");
  gtk_widget_ref (label_num);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "label_num", label_num,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_num);
  gtk_table_attach (GTK_TABLE (table1), label_num, 0, 1, 5, 6,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  hbox43 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox43);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "hbox43", hbox43,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox43);
  gtk_table_attach (GTK_TABLE (table1), hbox43, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  set_zoom = gtk_entry_new ();
  gtk_widget_ref (set_zoom);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_zoom", set_zoom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_zoom);
  gtk_box_pack_start (GTK_BOX (hbox43), set_zoom, TRUE, TRUE, 0);
  gtk_entry_set_text (GTK_ENTRY (set_zoom), "1");

  label_img_no = gtk_label_new ("Image No");
  gtk_widget_ref (label_img_no);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "label_img_no", label_img_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_img_no);
  gtk_box_pack_start (GTK_BOX (hbox43), label_img_no, FALSE, FALSE, 0);

  img_no_entry = gtk_entry_new ();
  gtk_widget_ref (img_no_entry);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "img_no_entry", img_no_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (img_no_entry);
  gtk_box_pack_start (GTK_BOX (hbox43), img_no_entry, TRUE, TRUE, 0);

  hbox42 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox42);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "hbox42", hbox42,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox42);
  gtk_table_attach (GTK_TABLE (table1), hbox42, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  set_num_button = gtk_toggle_button_new_with_label ("On/Off");
  gtk_widget_ref (set_num_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_num_button", set_num_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_num_button);
  gtk_box_pack_start (GTK_BOX (hbox42), set_num_button, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (set_num_button), TRUE);

  label35 = gtk_label_new ("Interpolation");
  gtk_widget_ref (label35);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "label35", label35,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label35);
  gtk_box_pack_start (GTK_BOX (hbox42), label35, FALSE, FALSE, 0);

  set_interpolate_button = gtk_toggle_button_new_with_label ("On/Off");
  gtk_widget_ref (set_interpolate_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "set_interpolate_button", set_interpolate_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_interpolate_button);
  gtk_box_pack_start (GTK_BOX (hbox42), set_interpolate_button, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (set_interpolate_button), TRUE);

  label36 = gtk_label_new ("ReverseY");
  gtk_widget_ref (label36);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "label36", label36,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label36);
  gtk_box_pack_start (GTK_BOX (hbox42), label36, FALSE, FALSE, 0);

  revy_button = gtk_toggle_button_new_with_label ("On/Off");
  gtk_widget_ref (revy_button);
  gtk_object_set_data_full (GTK_OBJECT (settingshell), "revy_button", revy_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (revy_button);
  gtk_box_pack_start (GTK_BOX (hbox42), revy_button, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (revy_button), TRUE);

  gtk_signal_connect (GTK_OBJECT (settingshell), "delete_event",
                      GTK_SIGNAL_FUNC (on_settingshell_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_done_button), "clicked",
                      GTK_SIGNAL_FUNC (on_set_done_button_clicked),
                      settingshell);
  gtk_signal_connect (GTK_OBJECT (set_rainbow_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_rainbow_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_hot_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_hot_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_gray_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_gray_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_invgray_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_invgray_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_comb_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_comb_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_lkup_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_lkup_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_each_image_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_each_image_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_all_image_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_all_image_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_input_user_abs_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_input_user_abs_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_input_user_rel_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_input_user_rel_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_trans_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_trans_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_coronal_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_coronal_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_sagital_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_sagital_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_num_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_num_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set_interpolate_button), "toggled",
                      GTK_SIGNAL_FUNC (on_set_interpolate_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (revy_button), "toggled",
                      GTK_SIGNAL_FUNC (on_revy_button_toggled),
                      NULL);

  return settingshell;
}

GtkWidget*
create_clear_dialog (void)
{
  GtkWidget *clear_dialog;
  GtkWidget *dialog_vbox3;
  GtkWidget *label7;
  GtkWidget *dialog_action_area3;
  GtkWidget *hbox13;
  GtkWidget *yes_clear_button;
  GtkWidget *no_clear_button;

  clear_dialog = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (clear_dialog), "clear_dialog", clear_dialog);
  gtk_window_set_title (GTK_WINDOW (clear_dialog), "Clear Screen?");
  GTK_WINDOW (clear_dialog)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (clear_dialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (clear_dialog), TRUE);
  gtk_window_set_policy (GTK_WINDOW (clear_dialog), TRUE, TRUE, FALSE);

  dialog_vbox3 = GTK_DIALOG (clear_dialog)->vbox;
  gtk_object_set_data (GTK_OBJECT (clear_dialog), "dialog_vbox3", dialog_vbox3);
  gtk_widget_show (dialog_vbox3);

  label7 = gtk_label_new ("Do you want to clear screen?");
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (clear_dialog), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), label7, FALSE, FALSE, 0);

  dialog_action_area3 = GTK_DIALOG (clear_dialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (clear_dialog), "dialog_action_area3", dialog_action_area3);
  gtk_widget_show (dialog_action_area3);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area3), 10);

  hbox13 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox13);
  gtk_object_set_data_full (GTK_OBJECT (clear_dialog), "hbox13", hbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox13);
  gtk_box_pack_start (GTK_BOX (dialog_action_area3), hbox13, TRUE, TRUE, 0);

  yes_clear_button = gtk_button_new_with_label ("YES");
  gtk_widget_ref (yes_clear_button);
  gtk_object_set_data_full (GTK_OBJECT (clear_dialog), "yes_clear_button", yes_clear_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (yes_clear_button);
  gtk_box_pack_start (GTK_BOX (hbox13), yes_clear_button, FALSE, FALSE, 0);

  no_clear_button = gtk_button_new_with_label ("NO");
  gtk_widget_ref (no_clear_button);
  gtk_object_set_data_full (GTK_OBJECT (clear_dialog), "no_clear_button", no_clear_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (no_clear_button);
  gtk_box_pack_start (GTK_BOX (hbox13), no_clear_button, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (yes_clear_button), "clicked",
                      GTK_SIGNAL_FUNC (on_yes_clear_button_clicked),
                      clear_dialog);
  gtk_signal_connect (GTK_OBJECT (no_clear_button), "clicked",
                      GTK_SIGNAL_FUNC (on_no_clear_button_clicked),
                      clear_dialog);

  return clear_dialog;
}

GtkWidget*
create_roi_info_window (void)
{
  GtkWidget *roi_info_window;
  GtkWidget *vbox5;
  GtkWidget *hbox46;
  GtkWidget *roi_info_entry;
  GtkWidget *roi_info_save_button;
  GtkWidget *scrolledwindow2;
  GtkWidget *roi_info_text;
  GtkWidget *roi_info_done_button;

  roi_info_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (roi_info_window), "roi_info_window", roi_info_window);
  gtk_window_set_title (GTK_WINDOW (roi_info_window), "ROI Information");
  gtk_window_set_position (GTK_WINDOW (roi_info_window), GTK_WIN_POS_MOUSE);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (roi_info_window), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (roi_info_window), vbox5);

  hbox46 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox46);
  gtk_object_set_data_full (GTK_OBJECT (roi_info_window), "hbox46", hbox46,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox46);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox46, FALSE, TRUE, 0);

  roi_info_entry = gtk_entry_new ();
  gtk_widget_ref (roi_info_entry);
  gtk_object_set_data_full (GTK_OBJECT (roi_info_window), "roi_info_entry", roi_info_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_info_entry);
  gtk_box_pack_start (GTK_BOX (hbox46), roi_info_entry, TRUE, TRUE, 0);

  roi_info_save_button = gtk_button_new_with_label ("Save");
  gtk_widget_ref (roi_info_save_button);
  gtk_object_set_data_full (GTK_OBJECT (roi_info_window), "roi_info_save_button", roi_info_save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_info_save_button);
  gtk_box_pack_start (GTK_BOX (hbox46), roi_info_save_button, FALSE, FALSE, 0);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (roi_info_window), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (vbox5), scrolledwindow2, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow2, 400, -2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  roi_info_text = gtk_text_new (NULL, NULL);
  gtk_widget_ref (roi_info_text);
  gtk_object_set_data_full (GTK_OBJECT (roi_info_window), "roi_info_text", roi_info_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_info_text);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), roi_info_text);

  roi_info_done_button = gtk_button_new_with_label ("Done");
  gtk_widget_ref (roi_info_done_button);
  gtk_object_set_data_full (GTK_OBJECT (roi_info_window), "roi_info_done_button", roi_info_done_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_info_done_button);
  gtk_box_pack_start (GTK_BOX (vbox5), roi_info_done_button, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (roi_info_save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_info_save_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_info_done_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_info_done_button_clicked),
                      roi_info_window);

  return roi_info_window;
}

GtkWidget*
create_hist_window (void)
{
  GtkWidget *hist_window;
  GtkWidget *vbox6;
  GtkWidget *hbox18;
  GtkWidget *hist_done_button;
  GtkWidget *hist_save_button;
  GtkWidget *hist_entry;
  GtkWidget *histgram_area;

  hist_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (hist_window), "hist_window", hist_window);
  gtk_window_set_title (GTK_WINDOW (hist_window), "ROI Histgram");
  gtk_window_set_position (GTK_WINDOW (hist_window), GTK_WIN_POS_MOUSE);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (hist_window), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_container_add (GTK_CONTAINER (hist_window), vbox6);

  hbox18 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox18);
  gtk_object_set_data_full (GTK_OBJECT (hist_window), "hbox18", hbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox18);
  gtk_box_pack_start (GTK_BOX (vbox6), hbox18, FALSE, FALSE, 0);

  hist_done_button = gtk_button_new_with_label ("Done");
  gtk_widget_ref (hist_done_button);
  gtk_object_set_data_full (GTK_OBJECT (hist_window), "hist_done_button", hist_done_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hist_done_button);
  gtk_box_pack_start (GTK_BOX (hbox18), hist_done_button, FALSE, TRUE, 0);

  hist_save_button = gtk_button_new_with_label ("Save");
  gtk_widget_ref (hist_save_button);
  gtk_object_set_data_full (GTK_OBJECT (hist_window), "hist_save_button", hist_save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hist_save_button);
  gtk_box_pack_start (GTK_BOX (hbox18), hist_save_button, FALSE, FALSE, 0);

  hist_entry = gtk_entry_new ();
  gtk_widget_ref (hist_entry);
  gtk_object_set_data_full (GTK_OBJECT (hist_window), "hist_entry", hist_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hist_entry);
  gtk_box_pack_start (GTK_BOX (hbox18), hist_entry, TRUE, TRUE, 0);

  histgram_area = gtk_drawing_area_new ();
  gtk_widget_ref (histgram_area);
  gtk_object_set_data_full (GTK_OBJECT (hist_window), "histgram_area", histgram_area,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (histgram_area);
  gtk_box_pack_start (GTK_BOX (vbox6), histgram_area, TRUE, TRUE, 0);
  gtk_widget_set_usize (histgram_area, 300, 300);

  gtk_signal_connect (GTK_OBJECT (hist_done_button), "clicked",
                      GTK_SIGNAL_FUNC (on_hist_done_button_clicked),
                      hist_window);
  gtk_signal_connect (GTK_OBJECT (hist_save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_hist_save_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (histgram_area), "expose_event",
                      GTK_SIGNAL_FUNC (on_histgram_area_expose_event),
                      NULL);

  return hist_window;
}

GtkWidget*
create_hdr_info_window (void)
{
  GtkWidget *hdr_info_window;
  GtkWidget *vbox7;
  GtkWidget *vbox11;
  GtkWidget *hbox21;
  GtkWidget *hdr_info_done_button;
  GtkWidget *hdr_info_save_button;
  GtkWidget *hbox48;
  GtkWidget *label38;
  GtkWidget *swap_hdr_togglebutton;
  GtkWidget *hdr_info_entry;
  GtkWidget *scrolledwindow3;
  GtkWidget *hdr_info_text;

  hdr_info_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (hdr_info_window), "hdr_info_window", hdr_info_window);
  gtk_window_set_title (GTK_WINDOW (hdr_info_window), "Header Info");
  gtk_window_set_position (GTK_WINDOW (hdr_info_window), GTK_WIN_POS_MOUSE);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox7);
  gtk_object_set_data_full (GTK_OBJECT (hdr_info_window), "vbox7", vbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox7);
  gtk_container_add (GTK_CONTAINER (hdr_info_window), vbox7);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox11);
  gtk_object_set_data_full (GTK_OBJECT (hdr_info_window), "vbox11", vbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox11);
  gtk_box_pack_start (GTK_BOX (vbox7), vbox11, FALSE, TRUE, 0);

  hbox21 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox21);
  gtk_object_set_data_full (GTK_OBJECT (hdr_info_window), "hbox21", hbox21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox21);
  gtk_box_pack_start (GTK_BOX (vbox11), hbox21, FALSE, TRUE, 0);

  hdr_info_done_button = gtk_button_new_with_label ("Done");
  gtk_widget_ref (hdr_info_done_button);
  gtk_object_set_data_full (GTK_OBJECT (hdr_info_window), "hdr_info_done_button", hdr_info_done_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hdr_info_done_button);
  gtk_box_pack_start (GTK_BOX (hbox21), hdr_info_done_button, FALSE, FALSE, 0);

  hdr_info_save_button = gtk_button_new_with_label ("Save");
  gtk_widget_ref (hdr_info_save_button);
  gtk_object_set_data_full (GTK_OBJECT (hdr_info_window), "hdr_info_save_button", hdr_info_save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hdr_info_save_button);
  gtk_box_pack_start (GTK_BOX (hbox21), hdr_info_save_button, FALSE, FALSE, 0);

  hbox48 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox48);
  gtk_object_set_data_full (GTK_OBJECT (hdr_info_window), "hbox48", hbox48,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox48);
  gtk_box_pack_start (GTK_BOX (hbox21), hbox48, FALSE, FALSE, 0);

  label38 = gtk_label_new ("Swap");
  gtk_widget_ref (label38);
  gtk_object_set_data_full (GTK_OBJECT (hdr_info_window), "label38", label38,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label38);
  gtk_box_pack_start (GTK_BOX (hbox48), label38, FALSE, FALSE, 0);

  swap_hdr_togglebutton = gtk_toggle_button_new_with_label ("No/Yes");
  gtk_widget_ref (swap_hdr_togglebutton);
  gtk_object_set_data_full (GTK_OBJECT (hdr_info_window), "swap_hdr_togglebutton", swap_hdr_togglebutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (swap_hdr_togglebutton);
  gtk_box_pack_start (GTK_BOX (hbox48), swap_hdr_togglebutton, FALSE, FALSE, 0);

  hdr_info_entry = gtk_entry_new ();
  gtk_widget_ref (hdr_info_entry);
  gtk_object_set_data_full (GTK_OBJECT (hdr_info_window), "hdr_info_entry", hdr_info_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hdr_info_entry);
  gtk_box_pack_start (GTK_BOX (vbox11), hdr_info_entry, FALSE, FALSE, 0);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (hdr_info_window), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_box_pack_start (GTK_BOX (vbox7), scrolledwindow3, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  hdr_info_text = gtk_text_new (NULL, NULL);
  gtk_widget_ref (hdr_info_text);
  gtk_object_set_data_full (GTK_OBJECT (hdr_info_window), "hdr_info_text", hdr_info_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hdr_info_text);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), hdr_info_text);
  gtk_widget_set_usize (hdr_info_text, -2, 300);
  gtk_text_set_editable (GTK_TEXT (hdr_info_text), TRUE);

  gtk_signal_connect (GTK_OBJECT (hdr_info_done_button), "clicked",
                      GTK_SIGNAL_FUNC (on_hdr_info_done_button_clicked),
                      hdr_info_window);
  gtk_signal_connect (GTK_OBJECT (hdr_info_save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_hdr_info_save_button_clicked),
                      hdr_info_window);
  gtk_signal_connect (GTK_OBJECT (swap_hdr_togglebutton), "toggled",
                      GTK_SIGNAL_FUNC (on_swap_hdr_togglebutton_toggled),
                      NULL);

  return hdr_info_window;
}

GtkWidget*
create_doc_dialog (void)
{
  GtkWidget *doc_dialog;
  GtkWidget *dialog_vbox4;
  GtkWidget *scrolledwindow4;
  GtkWidget *doc_text;
  GtkWidget *dialog_action_area4;
  GtkWidget *doc_done_button;

  doc_dialog = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (doc_dialog), "doc_dialog", doc_dialog);
  gtk_window_set_title (GTK_WINDOW (doc_dialog), "Document");
  GTK_WINDOW (doc_dialog)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (doc_dialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_policy (GTK_WINDOW (doc_dialog), TRUE, TRUE, FALSE);

  dialog_vbox4 = GTK_DIALOG (doc_dialog)->vbox;
  gtk_object_set_data (GTK_OBJECT (doc_dialog), "dialog_vbox4", dialog_vbox4);
  gtk_widget_show (dialog_vbox4);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (doc_dialog), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (dialog_vbox4), scrolledwindow4, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  doc_text = gtk_text_new (NULL, NULL);
  gtk_widget_ref (doc_text);
  gtk_object_set_data_full (GTK_OBJECT (doc_dialog), "doc_text", doc_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (doc_text);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), doc_text);

  dialog_action_area4 = GTK_DIALOG (doc_dialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (doc_dialog), "dialog_action_area4", dialog_action_area4);
  gtk_widget_show (dialog_action_area4);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area4), 10);

  doc_done_button = gtk_button_new_with_label ("Done");
  gtk_widget_ref (doc_done_button);
  gtk_object_set_data_full (GTK_OBJECT (doc_dialog), "doc_done_button", doc_done_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (doc_done_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area4), doc_done_button, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (doc_done_button), "clicked",
                      GTK_SIGNAL_FUNC (on_doc_done_button_clicked),
                      doc_dialog);

  return doc_dialog;
}

GtkWidget*
create_profile_window (void)
{
  GtkWidget *profile_window;
  GtkWidget *vbox8;
  GtkWidget *hbox24;
  GtkWidget *profile_done_button;
  GtkWidget *button3;
  GtkWidget *profile_entry;
  GtkWidget *table3;
  GtkWidget *profilex_curve;
  GtkWidget *profiley_curve;

  profile_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (profile_window), "profile_window", profile_window);
  gtk_window_set_title (GTK_WINDOW (profile_window), "ROI Profile");
  gtk_window_set_position (GTK_WINDOW (profile_window), GTK_WIN_POS_MOUSE);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox8);
  gtk_object_set_data_full (GTK_OBJECT (profile_window), "vbox8", vbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox8);
  gtk_container_add (GTK_CONTAINER (profile_window), vbox8);

  hbox24 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox24);
  gtk_object_set_data_full (GTK_OBJECT (profile_window), "hbox24", hbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox24);
  gtk_box_pack_start (GTK_BOX (vbox8), hbox24, FALSE, FALSE, 0);

  profile_done_button = gtk_button_new_with_label ("Done");
  gtk_widget_ref (profile_done_button);
  gtk_object_set_data_full (GTK_OBJECT (profile_window), "profile_done_button", profile_done_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (profile_done_button);
  gtk_box_pack_start (GTK_BOX (hbox24), profile_done_button, FALSE, TRUE, 0);

  button3 = gtk_button_new_with_label ("Save");
  gtk_widget_ref (button3);
  gtk_object_set_data_full (GTK_OBJECT (profile_window), "button3", button3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button3);
  gtk_box_pack_start (GTK_BOX (hbox24), button3, FALSE, FALSE, 0);

  profile_entry = gtk_entry_new ();
  gtk_widget_ref (profile_entry);
  gtk_object_set_data_full (GTK_OBJECT (profile_window), "profile_entry", profile_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (profile_entry);
  gtk_box_pack_start (GTK_BOX (hbox24), profile_entry, TRUE, TRUE, 0);

  table3 = gtk_table_new (2, 1, FALSE);
  gtk_widget_ref (table3);
  gtk_object_set_data_full (GTK_OBJECT (profile_window), "table3", table3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table3);
  gtk_box_pack_start (GTK_BOX (vbox8), table3, TRUE, TRUE, 0);

  profilex_curve = gtk_curve_new ();
  gtk_widget_ref (profilex_curve);
  gtk_object_set_data_full (GTK_OBJECT (profile_window), "profilex_curve", profilex_curve,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (profilex_curve);
  gtk_table_attach (GTK_TABLE (table3), profilex_curve, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_set_usize (profilex_curve, 200, 200);
  gtk_curve_set_range (GTK_CURVE (profilex_curve), 0, 1, 0, 1);

  profiley_curve = gtk_curve_new ();
  gtk_widget_ref (profiley_curve);
  gtk_object_set_data_full (GTK_OBJECT (profile_window), "profiley_curve", profiley_curve,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (profiley_curve);
  gtk_table_attach (GTK_TABLE (table3), profiley_curve, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_set_usize (profiley_curve, 200, 200);
  gtk_curve_set_range (GTK_CURVE (profiley_curve), 0, 1, 0, 1);

  gtk_signal_connect (GTK_OBJECT (profile_done_button), "clicked",
                      GTK_SIGNAL_FUNC (on_profile_done_button_clicked),
                      profile_window);
  gtk_signal_connect (GTK_OBJECT (button3), "clicked",
                      GTK_SIGNAL_FUNC (on_profile_save_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (profilex_curve), "motion_notify_event",
                      GTK_SIGNAL_FUNC (on_profilex_curve_motion_notify_event),
                      profile_window);
  gtk_signal_connect (GTK_OBJECT (profiley_curve), "motion_notify_event",
                      GTK_SIGNAL_FUNC (on_profiley_curve_motion_notify_event),
                      profile_window);

  return profile_window;
}

GtkWidget*
create_import_window (void)
{
  GtkWidget *import_window;
  GtkWidget *vbox9;
  GtkWidget *vbox10;
  GtkWidget *hbox26;
  GtkWidget *label21;
  GtkWidget *import_file_entry;
  GtkWidget *import_file_select_button;
  GtkWidget *hbox30;
  GtkWidget *hbox31;
  GtkWidget *hbox32;
  GtkWidget *label29;
  GSList *import_file_type_group = NULL;
  GtkWidget *radiobutton6;
  GtkWidget *radiobutton7;
  GtkWidget *radiobutton8;
  GtkWidget *radiobutton9;
  GtkWidget *radiobutton10;
  GtkWidget *label30;
  GtkWidget *import_swap_button;
  GtkWidget *hbox28;
  GtkWidget *label23;
  GtkWidget *import_xdim_entry;
  GtkWidget *label24;
  GtkWidget *import_ydim_entry;
  GtkWidget *label25;
  GtkWidget *import_zdim_entry;
  GtkWidget *hbox33;
  GtkWidget *hbox29;
  GtkWidget *label26;
  GtkWidget *import_xsize_entry;
  GtkWidget *label27;
  GtkWidget *import_ysize_entry;
  GtkWidget *label28;
  GtkWidget *import_zsize_entry;
  GtkWidget *label31;
  GtkWidget *import_offset_entry;
  GtkWidget *hbox25;
  GtkWidget *import_load_button;
  GtkWidget *import_cancel_button;

  import_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (import_window), "import_window", import_window);
  gtk_window_set_title (GTK_WINDOW (import_window), "Import raw data");
  gtk_window_set_position (GTK_WINDOW (import_window), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (import_window), TRUE);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox9);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "vbox9", vbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox9);
  gtk_container_add (GTK_CONTAINER (import_window), vbox9);

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox10);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "vbox10", vbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox10);
  gtk_box_pack_start (GTK_BOX (vbox9), vbox10, TRUE, TRUE, 0);

  hbox26 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox26);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "hbox26", hbox26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox26);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox26, FALSE, TRUE, 0);

  label21 = gtk_label_new ("File");
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_box_pack_start (GTK_BOX (hbox26), label21, FALSE, FALSE, 0);

  import_file_entry = gtk_entry_new ();
  gtk_widget_ref (import_file_entry);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "import_file_entry", import_file_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_file_entry);
  gtk_box_pack_start (GTK_BOX (hbox26), import_file_entry, TRUE, TRUE, 0);

  import_file_select_button = gtk_button_new_with_label ("...");
  gtk_widget_ref (import_file_select_button);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "import_file_select_button", import_file_select_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_file_select_button);
  gtk_box_pack_start (GTK_BOX (hbox26), import_file_select_button, FALSE, FALSE, 0);

  hbox30 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox30);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "hbox30", hbox30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox30);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox30, FALSE, TRUE, 0);

  hbox31 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox31);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "hbox31", hbox31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox31);
  gtk_box_pack_start (GTK_BOX (hbox30), hbox31, TRUE, TRUE, 0);

  hbox32 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox32);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "hbox32", hbox32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox32);
  gtk_box_pack_start (GTK_BOX (hbox31), hbox32, TRUE, TRUE, 0);

  label29 = gtk_label_new ("File Type ");
  gtk_widget_ref (label29);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "label29", label29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label29);
  gtk_box_pack_start (GTK_BOX (hbox32), label29, FALSE, FALSE, 0);

  radiobutton6 = gtk_radio_button_new_with_label (import_file_type_group, "8bit");
  import_file_type_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton6));
  gtk_widget_ref (radiobutton6);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "radiobutton6", radiobutton6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton6);
  gtk_box_pack_start (GTK_BOX (hbox32), radiobutton6, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton6), TRUE);

  radiobutton7 = gtk_radio_button_new_with_label (import_file_type_group, "Short");
  import_file_type_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton7));
  gtk_widget_ref (radiobutton7);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "radiobutton7", radiobutton7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton7);
  gtk_box_pack_start (GTK_BOX (hbox32), radiobutton7, FALSE, FALSE, 0);

  radiobutton8 = gtk_radio_button_new_with_label (import_file_type_group, "Int");
  import_file_type_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton8));
  gtk_widget_ref (radiobutton8);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "radiobutton8", radiobutton8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton8);
  gtk_box_pack_start (GTK_BOX (hbox32), radiobutton8, FALSE, FALSE, 0);

  radiobutton9 = gtk_radio_button_new_with_label (import_file_type_group, "Float");
  import_file_type_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton9));
  gtk_widget_ref (radiobutton9);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "radiobutton9", radiobutton9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton9);
  gtk_box_pack_start (GTK_BOX (hbox32), radiobutton9, FALSE, FALSE, 0);

  radiobutton10 = gtk_radio_button_new_with_label (import_file_type_group, "Double");
  import_file_type_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton10));
  gtk_widget_ref (radiobutton10);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "radiobutton10", radiobutton10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton10);
  gtk_box_pack_start (GTK_BOX (hbox32), radiobutton10, FALSE, FALSE, 0);

  label30 = gtk_label_new ("Swap  ");
  gtk_widget_ref (label30);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "label30", label30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label30);
  gtk_box_pack_start (GTK_BOX (hbox31), label30, FALSE, FALSE, 0);

  import_swap_button = gtk_toggle_button_new_with_label ("On/Off");
  gtk_widget_ref (import_swap_button);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "import_swap_button", import_swap_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_swap_button);
  gtk_box_pack_start (GTK_BOX (hbox31), import_swap_button, FALSE, FALSE, 0);

  hbox28 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox28);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "hbox28", hbox28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox28);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox28, TRUE, TRUE, 0);

  label23 = gtk_label_new ("Xdim");
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_box_pack_start (GTK_BOX (hbox28), label23, FALSE, FALSE, 0);

  import_xdim_entry = gtk_entry_new ();
  gtk_widget_ref (import_xdim_entry);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "import_xdim_entry", import_xdim_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_xdim_entry);
  gtk_box_pack_start (GTK_BOX (hbox28), import_xdim_entry, TRUE, TRUE, 0);

  label24 = gtk_label_new ("Ydim");
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_box_pack_start (GTK_BOX (hbox28), label24, FALSE, FALSE, 0);

  import_ydim_entry = gtk_entry_new ();
  gtk_widget_ref (import_ydim_entry);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "import_ydim_entry", import_ydim_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_ydim_entry);
  gtk_box_pack_start (GTK_BOX (hbox28), import_ydim_entry, TRUE, TRUE, 0);

  label25 = gtk_label_new ("Zdim");
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_box_pack_start (GTK_BOX (hbox28), label25, FALSE, FALSE, 0);

  import_zdim_entry = gtk_entry_new ();
  gtk_widget_ref (import_zdim_entry);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "import_zdim_entry", import_zdim_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_zdim_entry);
  gtk_box_pack_start (GTK_BOX (hbox28), import_zdim_entry, TRUE, TRUE, 0);

  hbox33 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox33);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "hbox33", hbox33,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox33);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox33, TRUE, TRUE, 0);

  hbox29 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox29);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "hbox29", hbox29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox29);
  gtk_box_pack_start (GTK_BOX (hbox33), hbox29, TRUE, TRUE, 0);

  label26 = gtk_label_new ("Xsize");
  gtk_widget_ref (label26);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "label26", label26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label26);
  gtk_box_pack_start (GTK_BOX (hbox29), label26, FALSE, FALSE, 0);

  import_xsize_entry = gtk_entry_new ();
  gtk_widget_ref (import_xsize_entry);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "import_xsize_entry", import_xsize_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_xsize_entry);
  gtk_box_pack_start (GTK_BOX (hbox29), import_xsize_entry, TRUE, TRUE, 0);
  gtk_entry_set_text (GTK_ENTRY (import_xsize_entry), "1");

  label27 = gtk_label_new ("Ysize");
  gtk_widget_ref (label27);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "label27", label27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label27);
  gtk_box_pack_start (GTK_BOX (hbox29), label27, FALSE, FALSE, 0);

  import_ysize_entry = gtk_entry_new ();
  gtk_widget_ref (import_ysize_entry);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "import_ysize_entry", import_ysize_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_ysize_entry);
  gtk_box_pack_start (GTK_BOX (hbox29), import_ysize_entry, TRUE, TRUE, 0);
  gtk_entry_set_text (GTK_ENTRY (import_ysize_entry), "1");

  label28 = gtk_label_new ("Zsize");
  gtk_widget_ref (label28);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "label28", label28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label28);
  gtk_box_pack_start (GTK_BOX (hbox29), label28, FALSE, FALSE, 0);

  import_zsize_entry = gtk_entry_new ();
  gtk_widget_ref (import_zsize_entry);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "import_zsize_entry", import_zsize_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_zsize_entry);
  gtk_box_pack_start (GTK_BOX (hbox29), import_zsize_entry, TRUE, TRUE, 0);
  gtk_entry_set_text (GTK_ENTRY (import_zsize_entry), "1");

  label31 = gtk_label_new ("Offset");
  gtk_widget_ref (label31);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "label31", label31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label31);
  gtk_box_pack_start (GTK_BOX (hbox33), label31, FALSE, FALSE, 0);

  import_offset_entry = gtk_entry_new_with_max_length (8);
  gtk_widget_ref (import_offset_entry);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "import_offset_entry", import_offset_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_offset_entry);
  gtk_box_pack_start (GTK_BOX (hbox33), import_offset_entry, TRUE, TRUE, 0);
  gtk_entry_set_text (GTK_ENTRY (import_offset_entry), "0");

  hbox25 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox25);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "hbox25", hbox25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox25);
  gtk_box_pack_start (GTK_BOX (vbox9), hbox25, FALSE, TRUE, 0);

  import_load_button = gtk_button_new_with_label ("Load");
  gtk_widget_ref (import_load_button);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "import_load_button", import_load_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_load_button);
  gtk_box_pack_start (GTK_BOX (hbox25), import_load_button, FALSE, FALSE, 0);

  import_cancel_button = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (import_cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (import_window), "import_cancel_button", import_cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_cancel_button);
  gtk_box_pack_start (GTK_BOX (hbox25), import_cancel_button, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (import_file_select_button), "clicked",
                      GTK_SIGNAL_FUNC (on_import_file_select_button_clicked),
                      import_window);
  gtk_signal_connect (GTK_OBJECT (radiobutton6), "toggled",
                      GTK_SIGNAL_FUNC (on_import_char_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton7), "toggled",
                      GTK_SIGNAL_FUNC (on_import_short_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton8), "toggled",
                      GTK_SIGNAL_FUNC (on_import_int_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton9), "toggled",
                      GTK_SIGNAL_FUNC (on_import_float_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton10), "toggled",
                      GTK_SIGNAL_FUNC (on_import_double_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (import_swap_button), "toggled",
                      GTK_SIGNAL_FUNC (on_import_swap_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (import_load_button), "clicked",
                      GTK_SIGNAL_FUNC (on_import_load_button_clicked),
                      import_window);
  gtk_signal_connect (GTK_OBJECT (import_cancel_button), "clicked",
                      GTK_SIGNAL_FUNC (on_import_cancel_button_clicked),
                      import_window);

  return import_window;
}

GtkWidget*
create_roiwindow (void)
{
  GtkWidget *roiwindow;
  GtkWidget *table4;
  GtkWidget *label8;
  GtkWidget *hbox36;
  GSList *roi_type_group_group = NULL;
  GtkWidget *roi_circle_button;
  GtkWidget *roi_ellipse_button;
  GtkWidget *roi_rectangle_button;
  GtkWidget *roi_polygon_button;
  GtkWidget *find_edge_button;
  GtkWidget *roi_distance_button;
  GtkWidget *roi_point_button;
  GtkWidget *roi_non_button;
  GtkWidget *hbox37;
  GtkWidget *roi_calc_button;
  GtkWidget *roi_hist_button;
  GtkWidget *roi_profile_button;
  GtkWidget *roi_copy_button;
  GtkWidget *roi_delete_button;
  GtkWidget *roi_mask_button;
  GtkWidget *hbox44;
  GSList *roi_mask_group_group = NULL;
  GtkWidget *roi_mask_in_button;
  GtkWidget *roi_mask_out_button;
  GtkWidget *hbox38;
  GtkWidget *label11;
  GtkWidget *roi_source_entry;
  GtkWidget *label17;
  GtkWidget *roi_dest_img_from_entry;
  GtkWidget *label18;
  GtkWidget *roi_dest_img_to_entry;
  GtkWidget *label13;
  GtkWidget *hbox39;
  GtkWidget *roi_file_entry;
  GtkWidget *roi_save_button;
  GtkWidget *roi_load_button;
  GtkWidget *label14;
  GtkWidget *roi_no_from_entry;
  GtkWidget *label19;
  GtkWidget *roi_no_to_entry;
  GtkWidget *label32;
  GtkWidget *hbox41;
  GtkWidget *roi_radius_entry;
  GtkWidget *label33;
  GtkWidget *roi_radius2_entry;
  GtkWidget *label34;
  GtkWidget *roi_deg_entry;
  GtkWidget *reset_roi_button;
  GtkWidget *roi_done_button;
  GtkWidget *hbox45;
  GtkWidget *roi_next_button;
  GtkWidget *roi_back_button;
  GtkWidget *roi_no_entry;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  roiwindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (roiwindow), "roiwindow", roiwindow);
  gtk_window_set_title (GTK_WINDOW (roiwindow), "ROI Window");
  gtk_window_set_position (GTK_WINDOW (roiwindow), GTK_WIN_POS_MOUSE);

  table4 = gtk_table_new (9, 2, FALSE);
  gtk_widget_ref (table4);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "table4", table4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table4);
  gtk_container_add (GTK_CONTAINER (roiwindow), table4);

  label8 = gtk_label_new ("ROI Type");
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_table_attach (GTK_TABLE (table4), label8, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  hbox36 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox36);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "hbox36", hbox36,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox36);
  gtk_table_attach (GTK_TABLE (table4), hbox36, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  roi_circle_button = gtk_radio_button_new_with_label (roi_type_group_group, "Circle");
  roi_type_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (roi_circle_button));
  gtk_widget_ref (roi_circle_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_circle_button", roi_circle_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_circle_button);
  gtk_box_pack_start (GTK_BOX (hbox36), roi_circle_button, FALSE, FALSE, 0);

  roi_ellipse_button = gtk_radio_button_new_with_label (roi_type_group_group, "Ellipse");
  roi_type_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (roi_ellipse_button));
  gtk_widget_ref (roi_ellipse_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_ellipse_button", roi_ellipse_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_ellipse_button);
  gtk_box_pack_start (GTK_BOX (hbox36), roi_ellipse_button, FALSE, FALSE, 0);

  roi_rectangle_button = gtk_radio_button_new_with_label (roi_type_group_group, "Rectangle");
  roi_type_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (roi_rectangle_button));
  gtk_widget_ref (roi_rectangle_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_rectangle_button", roi_rectangle_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_rectangle_button);
  gtk_box_pack_start (GTK_BOX (hbox36), roi_rectangle_button, FALSE, FALSE, 0);

  roi_polygon_button = gtk_radio_button_new_with_label (roi_type_group_group, "Polygon");
  roi_type_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (roi_polygon_button));
  gtk_widget_ref (roi_polygon_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_polygon_button", roi_polygon_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_polygon_button);
  gtk_box_pack_start (GTK_BOX (hbox36), roi_polygon_button, FALSE, FALSE, 0);

  find_edge_button = gtk_radio_button_new_with_label (roi_type_group_group, "Find Edge");
  roi_type_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (find_edge_button));
  gtk_widget_ref (find_edge_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "find_edge_button", find_edge_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (find_edge_button);
  gtk_box_pack_start (GTK_BOX (hbox36), find_edge_button, FALSE, FALSE, 0);

  roi_distance_button = gtk_radio_button_new_with_label (roi_type_group_group, "Distance");
  roi_type_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (roi_distance_button));
  gtk_widget_ref (roi_distance_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_distance_button", roi_distance_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_distance_button);
  gtk_box_pack_start (GTK_BOX (hbox36), roi_distance_button, FALSE, FALSE, 0);

  roi_point_button = gtk_radio_button_new_with_label (roi_type_group_group, "Pick Point");
  roi_type_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (roi_point_button));
  gtk_widget_ref (roi_point_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_point_button", roi_point_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_point_button);
  gtk_box_pack_start (GTK_BOX (hbox36), roi_point_button, FALSE, FALSE, 0);

  roi_non_button = gtk_radio_button_new_with_label (roi_type_group_group, "NONE");
  roi_type_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (roi_non_button));
  gtk_widget_ref (roi_non_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_non_button", roi_non_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_non_button);
  gtk_box_pack_start (GTK_BOX (hbox36), roi_non_button, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (roi_non_button), TRUE);

  hbox37 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox37);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "hbox37", hbox37,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox37);
  gtk_table_attach (GTK_TABLE (table4), hbox37, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  roi_calc_button = gtk_button_new_with_label ("ROI Calc");
  gtk_widget_ref (roi_calc_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_calc_button", roi_calc_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_calc_button);
  gtk_box_pack_start (GTK_BOX (hbox37), roi_calc_button, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (roi_calc_button), 4);
  gtk_widget_add_accelerator (roi_calc_button, "clicked", accel_group,
                              GDK_R, 0,
                              GTK_ACCEL_VISIBLE);

  roi_hist_button = gtk_button_new_with_label ("Make Hist");
  gtk_widget_ref (roi_hist_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_hist_button", roi_hist_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_hist_button);
  gtk_box_pack_start (GTK_BOX (hbox37), roi_hist_button, FALSE, FALSE, 0);

  roi_profile_button = gtk_button_new_with_label ("Make Profile");
  gtk_widget_ref (roi_profile_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_profile_button", roi_profile_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_profile_button);
  gtk_box_pack_start (GTK_BOX (hbox37), roi_profile_button, FALSE, FALSE, 0);

  roi_copy_button = gtk_button_new_with_label ("Copy ROI");
  gtk_widget_ref (roi_copy_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_copy_button", roi_copy_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_copy_button);
  gtk_box_pack_start (GTK_BOX (hbox37), roi_copy_button, FALSE, FALSE, 0);

  roi_delete_button = gtk_button_new_with_label ("Delete ROI");
  gtk_widget_ref (roi_delete_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_delete_button", roi_delete_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_delete_button);
  gtk_box_pack_start (GTK_BOX (hbox37), roi_delete_button, FALSE, FALSE, 0);

  roi_mask_button = gtk_button_new_with_label ("Mask ROI");
  gtk_widget_ref (roi_mask_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_mask_button", roi_mask_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_mask_button);
  gtk_box_pack_start (GTK_BOX (hbox37), roi_mask_button, FALSE, FALSE, 0);

  hbox44 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox44);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "hbox44", hbox44,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox44);
  gtk_box_pack_start (GTK_BOX (hbox37), hbox44, FALSE, FALSE, 0);

  roi_mask_in_button = gtk_radio_button_new_with_label (roi_mask_group_group, "Inside");
  roi_mask_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (roi_mask_in_button));
  gtk_widget_ref (roi_mask_in_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_mask_in_button", roi_mask_in_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_mask_in_button);
  gtk_box_pack_start (GTK_BOX (hbox44), roi_mask_in_button, FALSE, FALSE, 0);

  roi_mask_out_button = gtk_radio_button_new_with_label (roi_mask_group_group, "Outside");
  roi_mask_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (roi_mask_out_button));
  gtk_widget_ref (roi_mask_out_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_mask_out_button", roi_mask_out_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_mask_out_button);
  gtk_box_pack_start (GTK_BOX (hbox44), roi_mask_out_button, FALSE, FALSE, 0);

  hbox38 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox38);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "hbox38", hbox38,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox38);
  gtk_table_attach (GTK_TABLE (table4), hbox38, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  label11 = gtk_label_new ("Src ROI No:");
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_box_pack_start (GTK_BOX (hbox38), label11, FALSE, FALSE, 0);

  roi_source_entry = gtk_entry_new_with_max_length (3);
  gtk_widget_ref (roi_source_entry);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_source_entry", roi_source_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_source_entry);
  gtk_box_pack_start (GTK_BOX (hbox38), roi_source_entry, FALSE, FALSE, 0);
  gtk_widget_set_usize (roi_source_entry, 50, -2);

  label17 = gtk_label_new ("Dest Img No From");
  gtk_widget_ref (label17);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "label17", label17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label17);
  gtk_box_pack_start (GTK_BOX (hbox38), label17, FALSE, FALSE, 0);

  roi_dest_img_from_entry = gtk_entry_new_with_max_length (3);
  gtk_widget_ref (roi_dest_img_from_entry);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_dest_img_from_entry", roi_dest_img_from_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_dest_img_from_entry);
  gtk_box_pack_start (GTK_BOX (hbox38), roi_dest_img_from_entry, FALSE, FALSE, 0);
  gtk_widget_set_usize (roi_dest_img_from_entry, 50, -2);

  label18 = gtk_label_new ("Dest Img No To");
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_box_pack_start (GTK_BOX (hbox38), label18, FALSE, FALSE, 0);

  roi_dest_img_to_entry = gtk_entry_new_with_max_length (3);
  gtk_widget_ref (roi_dest_img_to_entry);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_dest_img_to_entry", roi_dest_img_to_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_dest_img_to_entry);
  gtk_box_pack_start (GTK_BOX (hbox38), roi_dest_img_to_entry, FALSE, TRUE, 0);
  gtk_widget_set_usize (roi_dest_img_to_entry, 50, -2);

  label13 = gtk_label_new ("ROI File");
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_table_attach (GTK_TABLE (table4), label13, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  hbox39 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox39);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "hbox39", hbox39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox39);
  gtk_table_attach (GTK_TABLE (table4), hbox39, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  roi_file_entry = gtk_entry_new ();
  gtk_widget_ref (roi_file_entry);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_file_entry", roi_file_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_file_entry);
  gtk_box_pack_start (GTK_BOX (hbox39), roi_file_entry, FALSE, TRUE, 0);

  roi_save_button = gtk_button_new_with_label ("Save ROIs");
  gtk_widget_ref (roi_save_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_save_button", roi_save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_save_button);
  gtk_box_pack_start (GTK_BOX (hbox39), roi_save_button, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (roi_save_button), 5);

  roi_load_button = gtk_button_new_with_label ("Load ROIs");
  gtk_widget_ref (roi_load_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_load_button", roi_load_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_load_button);
  gtk_box_pack_start (GTK_BOX (hbox39), roi_load_button, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (roi_load_button), 5);

  label14 = gtk_label_new ("From:");
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_box_pack_start (GTK_BOX (hbox39), label14, FALSE, FALSE, 0);

  roi_no_from_entry = gtk_entry_new_with_max_length (3);
  gtk_widget_ref (roi_no_from_entry);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_no_from_entry", roi_no_from_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_no_from_entry);
  gtk_box_pack_start (GTK_BOX (hbox39), roi_no_from_entry, FALSE, TRUE, 0);
  gtk_widget_set_usize (roi_no_from_entry, 50, -2);

  label19 = gtk_label_new ("To:");
  gtk_widget_ref (label19);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "label19", label19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label19);
  gtk_box_pack_start (GTK_BOX (hbox39), label19, FALSE, FALSE, 0);

  roi_no_to_entry = gtk_entry_new_with_max_length (3);
  gtk_widget_ref (roi_no_to_entry);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_no_to_entry", roi_no_to_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_no_to_entry);
  gtk_box_pack_start (GTK_BOX (hbox39), roi_no_to_entry, FALSE, TRUE, 0);
  gtk_widget_set_usize (roi_no_to_entry, 50, -2);

  label32 = gtk_label_new ("Rad1");
  gtk_widget_ref (label32);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "label32", label32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label32);
  gtk_table_attach (GTK_TABLE (table4), label32, 0, 1, 5, 6,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  hbox41 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox41);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "hbox41", hbox41,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox41);
  gtk_table_attach (GTK_TABLE (table4), hbox41, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  roi_radius_entry = gtk_entry_new ();
  gtk_widget_ref (roi_radius_entry);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_radius_entry", roi_radius_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_radius_entry);
  gtk_box_pack_start (GTK_BOX (hbox41), roi_radius_entry, FALSE, TRUE, 0);
  gtk_widget_set_usize (roi_radius_entry, 50, -2);

  label33 = gtk_label_new ("Rad2");
  gtk_widget_ref (label33);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "label33", label33,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label33);
  gtk_box_pack_start (GTK_BOX (hbox41), label33, FALSE, FALSE, 0);

  roi_radius2_entry = gtk_entry_new ();
  gtk_widget_ref (roi_radius2_entry);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_radius2_entry", roi_radius2_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_radius2_entry);
  gtk_box_pack_start (GTK_BOX (hbox41), roi_radius2_entry, FALSE, TRUE, 0);
  gtk_widget_set_usize (roi_radius2_entry, 50, -2);

  label34 = gtk_label_new ("Deg");
  gtk_widget_ref (label34);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "label34", label34,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label34);
  gtk_box_pack_start (GTK_BOX (hbox41), label34, FALSE, FALSE, 0);

  roi_deg_entry = gtk_entry_new ();
  gtk_widget_ref (roi_deg_entry);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_deg_entry", roi_deg_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_deg_entry);
  gtk_box_pack_start (GTK_BOX (hbox41), roi_deg_entry, FALSE, TRUE, 0);
  gtk_widget_set_usize (roi_deg_entry, 50, -2);

  reset_roi_button = gtk_button_new_with_label ("Reset");
  gtk_widget_ref (reset_roi_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "reset_roi_button", reset_roi_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reset_roi_button);
  gtk_box_pack_start (GTK_BOX (hbox41), reset_roi_button, FALSE, FALSE, 0);

  roi_done_button = gtk_button_new_with_label ("Done");
  gtk_widget_ref (roi_done_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_done_button", roi_done_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_done_button);
  gtk_table_attach (GTK_TABLE (table4), roi_done_button, 1, 2, 6, 7,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  hbox45 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox45);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "hbox45", hbox45,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox45);
  gtk_table_attach (GTK_TABLE (table4), hbox45, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  roi_next_button = gtk_button_new_with_label ("F ->");
  gtk_widget_ref (roi_next_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_next_button", roi_next_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_next_button);
  gtk_box_pack_start (GTK_BOX (hbox45), roi_next_button, FALSE, FALSE, 0);
  gtk_widget_add_accelerator (roi_next_button, "clicked", accel_group,
                              GDK_F, 0,
                              GTK_ACCEL_VISIBLE);

  roi_back_button = gtk_button_new_with_label ("<-B");
  gtk_widget_ref (roi_back_button);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_back_button", roi_back_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_back_button);
  gtk_box_pack_start (GTK_BOX (hbox45), roi_back_button, FALSE, FALSE, 0);
  gtk_widget_add_accelerator (roi_back_button, "clicked", accel_group,
                              GDK_B, 0,
                              GTK_ACCEL_VISIBLE);

  roi_no_entry = gtk_entry_new ();
  gtk_widget_ref (roi_no_entry);
  gtk_object_set_data_full (GTK_OBJECT (roiwindow), "roi_no_entry", roi_no_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (roi_no_entry);
  gtk_table_attach (GTK_TABLE (table4), roi_no_entry, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (roi_no_entry, 50, -2);

  gtk_signal_connect (GTK_OBJECT (roiwindow), "delete_event",
                      GTK_SIGNAL_FUNC (on_roiwindow_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_circle_button), "toggled",
                      GTK_SIGNAL_FUNC (on_roi_circle_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_ellipse_button), "toggled",
                      GTK_SIGNAL_FUNC (on_roi_ellipse_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_rectangle_button), "toggled",
                      GTK_SIGNAL_FUNC (on_roi_rectangle_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_polygon_button), "toggled",
                      GTK_SIGNAL_FUNC (on_roi_polygon_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (find_edge_button), "toggled",
                      GTK_SIGNAL_FUNC (on_find_edge_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_distance_button), "toggled",
                      GTK_SIGNAL_FUNC (on_roi_distance_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_point_button), "toggled",
                      GTK_SIGNAL_FUNC (on_roi_point_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_non_button), "toggled",
                      GTK_SIGNAL_FUNC (on_roi_non_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_calc_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_calc_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_hist_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_hist_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_profile_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_profile_button_clicked),
                      roiwindow);
  gtk_signal_connect (GTK_OBJECT (roi_copy_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_copy_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_delete_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_delete_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_mask_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_mask_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_mask_in_button), "toggled",
                      GTK_SIGNAL_FUNC (on_roi_mask_in_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_mask_out_button), "toggled",
                      GTK_SIGNAL_FUNC (on_roi_mask_out_button_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_save_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_load_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_load_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (reset_roi_button), "clicked",
                      GTK_SIGNAL_FUNC (on_reset_roi_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_done_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_done_button_clicked),
                      roiwindow);
  gtk_signal_connect (GTK_OBJECT (roi_next_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_next_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_back_button), "clicked",
                      GTK_SIGNAL_FUNC (on_roi_back_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (roi_no_entry), "activate",
                      GTK_SIGNAL_FUNC (on_roi_no_entry_activate),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (roiwindow), accel_group);

  return roiwindow;
}

GtkWidget*
create_overwrite_dialog (void)
{
  GtkWidget *overwrite_dialog;
  GtkWidget *dialog_vbox5;
  GtkWidget *label37;
  GtkWidget *dialog_action_area5;
  GtkWidget *hbox47;
  GtkWidget *overwrite_yes_button;
  GtkWidget *overwrite_no_button;

  overwrite_dialog = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (overwrite_dialog), "overwrite_dialog", overwrite_dialog);
  gtk_window_set_title (GTK_WINDOW (overwrite_dialog), "Overwrite?");
  gtk_window_set_position (GTK_WINDOW (overwrite_dialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_policy (GTK_WINDOW (overwrite_dialog), TRUE, TRUE, FALSE);

  dialog_vbox5 = GTK_DIALOG (overwrite_dialog)->vbox;
  gtk_object_set_data (GTK_OBJECT (overwrite_dialog), "dialog_vbox5", dialog_vbox5);
  gtk_widget_show (dialog_vbox5);

  label37 = gtk_label_new ("File exists!!\nDo you want to overwrite?");
  gtk_widget_ref (label37);
  gtk_object_set_data_full (GTK_OBJECT (overwrite_dialog), "label37", label37,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label37);
  gtk_box_pack_start (GTK_BOX (dialog_vbox5), label37, FALSE, FALSE, 0);

  dialog_action_area5 = GTK_DIALOG (overwrite_dialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (overwrite_dialog), "dialog_action_area5", dialog_action_area5);
  gtk_widget_show (dialog_action_area5);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area5), 10);

  hbox47 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox47);
  gtk_object_set_data_full (GTK_OBJECT (overwrite_dialog), "hbox47", hbox47,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox47);
  gtk_box_pack_start (GTK_BOX (dialog_action_area5), hbox47, TRUE, TRUE, 0);

  overwrite_yes_button = gtk_button_new_with_label ("Yes");
  gtk_widget_ref (overwrite_yes_button);
  gtk_object_set_data_full (GTK_OBJECT (overwrite_dialog), "overwrite_yes_button", overwrite_yes_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (overwrite_yes_button);
  gtk_box_pack_start (GTK_BOX (hbox47), overwrite_yes_button, FALSE, FALSE, 0);

  overwrite_no_button = gtk_button_new_with_label ("No");
  gtk_widget_ref (overwrite_no_button);
  gtk_object_set_data_full (GTK_OBJECT (overwrite_dialog), "overwrite_no_button", overwrite_no_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (overwrite_no_button);
  gtk_box_pack_start (GTK_BOX (hbox47), overwrite_no_button, FALSE, FALSE, 0);
  GTK_WIDGET_SET_FLAGS (overwrite_no_button, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (overwrite_yes_button), "clicked",
                      GTK_SIGNAL_FUNC (on_overwrite_yes_button_clicked),
                      overwrite_dialog);
  gtk_signal_connect (GTK_OBJECT (overwrite_no_button), "clicked",
                      GTK_SIGNAL_FUNC (on_overwrite_no_button_clicked),
                      overwrite_dialog);

  gtk_widget_grab_default (overwrite_no_button);
  return overwrite_dialog;
}

