/* Copyright 2000,2001 Hiroshi Watabe*/
/* $Id: main.c,v 1.7 2001/11/07 13:43:35 watabe Exp $ */
#include "gpetview.h"
#include "interface.h"
#include "support.h"

GtkWidget *gpetview;
GdkVisual *gvisual;
GdkPixmap *canvas_pixmap;
GdkRgbCmap *pet_cmap;
GdkGC *canvasGC;
GdkGC *clearGC;
GdkGC *roiGC;
GdkFont *gfont;
GtkWidget *pet_canvas;
GtkWidget *pet_viewport;
GtkWidget *roi_info_window;
GtkWidget *roiwindow;
GtkWidget *hist_window;
GtkWidget *fileselection;
GtkWidget *import_window;
GtkWidget *profile_window;

short canvas_width,canvas_height;
short view_width,view_height;
guchar window_ready_flag;

int
main (int argc, char *argv[])
{
  int num_arg;
  gtk_set_locale ();
  gtk_init (&argc, &argv);

  window_ready_flag = 0; /* window is ready for display or not */
  gdk_rgb_init();
  gvisual = gdk_rgb_get_visual();
  gcolormap = gdk_rgb_get_cmap();
  gtk_widget_set_default_colormap (gcolormap);
  gtk_widget_set_default_visual (gvisual);

  gpetview = create_gpetview ();
  filewindow = create_filewindow ();
  fileselection = create_fileselection ();
  settingshell = create_settingshell();
  roi_info_window = create_roi_info_window();
  roiwindow = create_roiwindow ();
  hist_window = create_hist_window();
  import_window = create_import_window ();
  profile_window = create_profile_window ();
  pet_canvas = lookup_widget(gpetview,"canvas");
  pet_viewport = lookup_widget(gpetview,"viewport1");
  /* set window size and initiliazion*/
  canvas_width = 1000;
  canvas_height = 1000;
  view_width = 750;
  view_height = 550;
  /* read .gpetviewrc */
  init_gpetview();
  /* checking arguments */
  num_arg = checkarg(argc,argv);
  if(canvas_width<view_width){
    canvas_width = view_width;
  }
  if(canvas_height<view_height){
    canvas_height = view_height;
  }
  gtk_widget_set_usize (pet_canvas, canvas_width, canvas_height);
  gtk_widget_set_usize (pet_viewport, view_width, view_height);

  gtk_widget_show (gpetview);
  window_ready_flag = 1; /* window is ready for display or not */
  /* create pixmap for display PET image */
  canvasGC = gdk_gc_new(gpetview->window);
  clearGC = gdk_gc_new(gpetview->window);
  roiGC = gdk_gc_new(gpetview->window);
  gfont = gdk_font_load("6x10");
  pet_cmap = (GdkRgbCmap *)g_malloc(sizeof(GdkRgbCmap));

  canvas_pixmap = gdk_pixmap_new(gpetview->window,canvas_width,canvas_height,-1);
  if(canvas_pixmap==NULL){
    return 0;
  }
  if(argc>1){/* assume last argument is image file */
    if(pipe_flag==0&&num_arg!=0){
      fname = (char *)malloc(strlen(argv[argc - 1]) + 1);
      if(fname==NULL){
	fprintf(stderr,"Cannot alloc memory\n");
	exit(1);
      }
      strcpy(fname,argv[argc - 1]);
      set_filename();
    }
    draw_colorbar();
    view_proc();
  }
  gtk_main ();
  return 0;
}

