/*Copyright 2000,2001  Hiroshi Watabe */
/* $Id: mk_anahdr.c,v 1.3 2001/10/05 20:04:23 watabe Exp $ */
/* Make analyze header for import data*/
#include "gpetview.h"

struct dsr *mk_anahdr(short type,short xdim,short ydim,short zdim,float xsize,float ysize,float zsize,long offset)
{
  struct dsr *hdr;

  hdr = (struct dsr *)malloc(sizeof(struct dsr));
  if(hdr==NULL){
    fprintf(stderr,"cannot allocate memoery for hdr\n");
    return NULL;
  }
  memset(hdr,0,sizeof(struct dsr));
  hdr->dime.dim[0] = 4;
  hdr->dime.dim[1] = xdim;
  hdr->dime.dim[2] = ydim;
  hdr->dime.dim[3] = zdim;
  hdr->dime.dim[4] = 1;
  hdr->dime.pixdim[1] = xsize;
  hdr->dime.pixdim[2] = ysize;
  hdr->dime.pixdim[3] = zsize;
  hdr->hk.sizeof_hdr=sizeof(struct dsr);	/*standard=348*/
  hdr->hk.extents=16384;
  hdr->hk.regular='r';
  hdr->hk.hkey_un0 = '0';
  hdr->dime.funused1 = 1; /* scalefactor */
  if(offset!=0){/* offset */
    hdr->dime.vox_offset = (float)offset;
  }

  if(type==SPM_UNSIGNED_CHAR){
    hdr->dime.bitpix = 8;
    hdr->dime.glmin = 0;
    hdr->dime.glmax = 255;
    hdr->dime.datatype = SPM_UNSIGNED_CHAR;
  }
  else if(type==SPM_SIGNED_SHORT){
    hdr->dime.bitpix = 16;
    hdr->dime.glmin = -32767;
    hdr->dime.glmax = 32767;
    hdr->dime.datatype = SPM_SIGNED_SHORT;
  }
  else if(type==SPM_SIGNED_INT){
    hdr->dime.bitpix = 32;
    hdr->dime.glmin = -2147483647;
    hdr->dime.glmax = 2147483647;
    hdr->dime.datatype = SPM_SIGNED_INT;
  }
  else if(type==SPM_FLOAT){
    hdr->dime.bitpix = 32;
    hdr->dime.glmin = -1;
    hdr->dime.glmax = 1;
    hdr->dime.datatype = SPM_FLOAT;
  }
  else if(type==SPM_DOUBLE){
    hdr->dime.bitpix=64;
    hdr->dime.glmin = -1;
    hdr->dime.glmax = 1;
    hdr->dime.datatype = SPM_DOUBLE;
  }
  else{
    printf("file type %i not defined\n",type);
    return(NULL);
  }
  orig_bitpix = hdr->dime.bitpix;
  orig_datatype = hdr->dime.datatype;
  orig_glmax = hdr->dime.glmax;
  orig_glmin = hdr->dime.glmin;
  return hdr;
}
