/* Copyright 2000,2001 Hiroshi Watabe*/
/* calculate ROI area */
/* $Id: roi_calc.c,v 1.5 2001/05/19 23:56:42 watabe Exp $ */
#include "gpetview.h"

GdkPixmap *roi_pixmap;

void roi_calc()
{
  u_short x,y,w,h;
  char string[50];
  FILE *fp;
  ROIINFO roi_info;
  GdkImage *roi_image;

  if(roi_draw_flag==0){return;}
  if(roi_flag==POLYGON&&Close==0){
    return;
  }
  if(roi_flag==FINDEDGE&&Close==0){
    return;
  }
  x = image_cell[curr_img_roi]->r_left;
  y = image_cell[curr_img_roi]->r_top;
  w = image_cell[curr_img_roi]->r_width;
  h = image_cell[curr_img_roi]->r_height;

  roi_pixmap = gdk_pixmap_new(gpetview->window,image_cell[curr_img_roi]->r_width,image_cell[curr_img_roi]->r_height,-1);
  /* clear roi_pixmap */
  gdk_draw_rectangle(roi_pixmap,clearGC,TRUE,0,0,image_cell[curr_img_roi]->r_width,image_cell[curr_img_roi]->r_height);
  roi_draw(4,0,0);
  roi_image = gdk_image_get(roi_pixmap,0,0,image_cell[curr_img_roi]->r_width,image_cell[curr_img_roi]->r_height);
  if(calc_area(roi_image)==0){
    return; /* failed to calculate area */
  }
  roi_num++;
  sprintf(string,"%d",roi_num);
  if(roi_flag!=POLYGON&&roi_flag!=FINDEDGE){
    gdk_draw_text(canvas_pixmap,gfont,canvasGC,image_cell[curr_img_roi]->r_left + figure.center.x,image_cell[curr_img_roi]->r_top + figure.center.y,string,strlen(string));
  }
  else{
    gdk_draw_text(canvas_pixmap,gfont,canvasGC,image_cell[curr_img_roi]->r_left + figure.points[0].x,image_cell[curr_img_roi]->r_top + figure.points[0].y,string,strlen(string));
  }
  roi_draw(5,0,0);
  redraw_canvas();
  gdk_pixmap_unref(roi_pixmap);

/* save temporary roi in /tmp */
  sprintf(string,"/tmp/roi.%d",roi_num);
  fp = fopen(string,"wb");
  roi_info.img_no = image_cell[curr_img_roi]->img_no;
  roi_info.orient = seq_flag;
  roi_info.zoom = zoom_factor;
  roi_info.revy_flag = revy_flag;
  memcpy(&(roi_info.figure),&figure,sizeof(figure));
  if(figure.type == FINDEDGE){
    roi_info.figure.type = POLYGON;
  }
  fwrite(&roi_info,sizeof(roi_info),1,fp);
  fclose(fp);
}

int calc_area(GdkImage *image)
{
  gushort width,height;
  guint k,j,i,ix,iy;
  char str[100];
  int	Max,Min;
  float fsum,fsum2,fdiff;
  unsigned long ofset,ofset2;
  guchar *img_mat = NULL;
  gushort fukasa,haba;
  short bpl;
  guchar *buf = NULL;
  gshort *img_p16=NULL;
  guchar *img_p8=NULL;
  gint *img_p32=NULL;

  width = image->width;
  height = image->height;
  buf = (guchar *)g_realloc(buf,width*height);
  memset(buf,0,width*height);/* clear buffer */
  bpl = image->bpl/(image->bpp/8);
  if(image->bpp==32){
    img_p32 = (gint *)image->mem;
  }
  if(image->bpp==16){
    img_p16 = (gshort *)image->mem;
  }
  if(image->bpp==8){
    img_p8 = (guchar *)image->mem;
  }
  for(i=0;i<height;i++){
    for(j=0;j<image->width;j++){
      if(image->bpp==32){
	if(img_p32[j + i*bpl]){
	  buf[j + i*width] = 255;
	}
      }
      if(image->bpp==16){
	if(img_p16[j + i*bpl]){
	  buf[j + i*width] = 255;
	}
      }
      if(image->bpp==8){
	if(img_p8[j + i*bpl]){
	  buf[j + i*width] = 255;
	}
      }
    }
  }

  if(seq_flag==TRANS){
    fukasa = ydim;
    haba = xdim;
  }
  else{
    if(seq_flag==CORO){
      fukasa = zdim;
      haba = xdim;
    }
    else{
      fukasa = zdim;
      haba = ydim;
    }
  }

  img_mat = readplane(img,xdim,ydim,zdim,image_cell[curr_img_roi]->img_no);

  fsum = fsum2 = 0.0;
  Max = 0;
  Min = 255;
  for(i=0,k=0;i<height;i++){
    for(j=0;j<width;j++){
      ofset = j + i*width;
      if(buf[ofset]==0) continue;
      ix = (int)((float)j/zoom_factor);
      iy = (int)((float)i/zoom_factor);
      if(revy_flag ==1) ofset2 = ix + (fukasa - 1 - iy)*haba;
      else ofset2 = ix + iy*haba;
      /* meansd3 */
      k++;
      fdiff = img_mat[ofset2] - fsum; /* difference between pesudo-mean and data */
      fsum += fdiff/(float)k; /* mean */
      fsum2 += (k - 1)*fdiff*fdiff/(float)k; /* sum of squre */
      if(Min>img_mat[ofset2]) Min = img_mat[ofset2];
      if(Max<img_mat[ofset2]) Max = img_mat[ofset2];
    }
  }
  if(k==0){
    return(0);
  }
  fsum2 = (float)sqrt((double)fsum2/(double)(k - 1));
  (roi_head.roires).average = fsum;
  (roi_head.roires).area = k;
  (roi_head.roires).pmax = Max;
  (roi_head.roires).pmin = Min;
  (roi_head.roires).sd = fsum2;
  (roi_head.roires).factor = img->scalefactor;
  sprintf(str,"Area is %d average %g S.D. %g Max %g Min %g",k, (roi_head.roires).average*(roi_head.roires).factor, (roi_head.roires).sd*(roi_head.roires).factor,(roi_head.roires).pmax*(roi_head.roires).factor, (roi_head.roires).pmin*(roi_head.roires).factor);
  put_string(str,0);
  g_free(buf);
  return(1);
}
