/* Copyright 2000,2001 Hiroshi Watabe*/
/* masking ROI */
/* $Id: roi_mask.c,v 1.3 2001/03/10 00:07:53 watabe Exp $ */
#include "gpetview.h"
#include "support.h"

void ext_area(GdkImage*);

void roi_mask()
{
  u_short x,y,w,h;
  GdkImage *roi_image;
  char string[50];
  FILE *fp;
  ROIINFO roi_info;

  if(roi_draw_flag==0){return;}

  roi_num++;
  x = image_cell[curr_img_roi]->r_left;
  y = image_cell[curr_img_roi]->r_top;
  w = image_cell[curr_img_roi]->r_width;
  h = image_cell[curr_img_roi]->r_height;

  roi_pixmap = gdk_pixmap_new(gpetview->window,image_cell[curr_img_roi]->r_width,image_cell[curr_img_roi]->r_height,-1);
  /* clear roi_pixmap */
  gdk_draw_rectangle(roi_pixmap,clearGC,TRUE,0,0,image_cell[curr_img_roi]->r_width,image_cell[curr_img_roi]->r_height);
  roi_draw(4,0,0);
  roi_image = gdk_image_get(roi_pixmap,0,0,image_cell[curr_img_roi]->r_width,image_cell[curr_img_roi]->r_height);
  sprintf(string,"%d",roi_num);
  if(roi_flag!=POLYGON){
    gdk_draw_text(canvas_pixmap,gfont,canvasGC,image_cell[curr_img_roi]->r_left + figure.center.x,image_cell[curr_img_roi]->r_top + figure.center.y,string,strlen(string));
  }
  else{
    gdk_draw_text(canvas_pixmap,gfont,canvasGC,image_cell[curr_img_roi]->r_left + figure.points[0].x,image_cell[curr_img_roi]->r_top + figure.points[0].y,string,strlen(string));
  }

  ext_area(roi_image);
  roi_draw(5,0,0);
  redraw_canvas();
  gdk_pixmap_unref(roi_pixmap);

/* save temporary roi in /tmp */
  sprintf(string,"/tmp/roi.%d",roi_num);
  fp = fopen(string,"wb");
  roi_info.img_no = image_cell[curr_img_roi]->img_no;
  roi_info.orient = seq_flag;
  roi_info.zoom = zoom_factor;
  roi_info.revy_flag = revy_flag;
  memcpy(&(roi_info.figure),&figure,sizeof(figure));
  fwrite(&roi_info,sizeof(roi_info),1,fp);
  fclose(fp);
}

/* extract image from ROI */
void ext_area(GdkImage *image)
{
  u_short width,height;
  u_int j,i,ix,iy,iz;
  unsigned long ofset,ofset2;
  u_char *img_mat = NULL;
  u_short fukasa;
  short bpl;
  guchar *buf = NULL;
  gshort *img_p16=NULL;
  guchar *img_p8=NULL;
  gint *img_p32=NULL;

  width = image->width;
  height = image->height;
  buf = (guchar *)g_realloc(buf,width*height);
  bpl = image->bpl/(image->bpp/8);
  if(image->bpp==32){
    img_p32 = (gint *)image->mem;
  }
  if(image->bpp==16){
    img_p16 = (gshort *)image->mem;
  }
  if(image->bpp==8){
    img_p8 = (guchar *)image->mem;
  }
  for(i=0;i<height;i++){
    for(j=0;j<image->width;j++){
      if(image->bpp==32){
	buf[j + i*width] = img_p32[j + i*bpl];
      }
      if(image->bpp==16){
	buf[j + i*width] = img_p16[j + i*bpl];
      }
      if(image->bpp==8){
	buf[j + i*width] = img_p8[j + i*bpl];
      }
    }
  }

  if(seq_flag==TRANS){
    img_mat = (unsigned char *)realloc(img_mat,(unsigned)xdim*ydim);
    fukasa = ydim;
  }
  else{
    if(seq_flag==CORO){
      img_mat = (unsigned char *)realloc(img_mat,(unsigned)xdim*zdim);
      fukasa = zdim;
    }
    else{
      img_mat = (unsigned char *)realloc(img_mat,(unsigned)ydim*zdim);
      fukasa = zdim;
    }
  }

  img_mat = readplane(img,xdim,ydim,zdim,image_cell[curr_img_roi]->img_no);

  iz = (int)((float)width/zoom_factor);
  for(i=0;i<height;i++){
    for(j=0;j<width;j++){
      ofset = j + i*width;
      if(roi_mask_flag==ROI_MASK_IN){
	if(buf[ofset]!=0){
	  continue; /* don't do anything since this is inside the ROI */
	}
      }
      else{
	if(buf[ofset]==0){
	  continue; /* don't do anything since this is outside the ROI */
	}
      }
      ix = (int)((float)j/zoom_factor);
      iy = (int)((float)i/zoom_factor);
      if(revy_flag==1) ofset2 = ix + (fukasa - 1 - iy)*iz;
      else ofset2 = ix + iy*iz;
      img_mat[ofset2] = 0;
    }
  }
  writeplane(img,img_mat,xdim,ydim,zdim,image_cell[curr_img_roi]->img_no);
  g_free(buf);
}
