/* Copyright 2000,2001 Hiroshi Watabe*/
/* procedure to handle ROI */
/* $Id: roi_proc.c,v 1.8 2001/09/16 14:25:15 watabe Exp $ */
#include "gpetview.h"
#include "support.h"

guint roi_num = 0;
guchar roi_draw_flag;
guchar roi_flag;
ROIHEAD	roi_head;
extern ImageRectPointer *image_cell;
unsigned int canvas_origin_x, canvas_origin_y; /* canvas's cooridinate now */
extern void roi_calc();
extern float pixel_yoko,pixel_tate; /* pixel size */
extern unsigned int z_xdim, z_ydim, z_zdim; /* after zooming */

void roi_out();

u_short oldx=0,oldy=0;
gushort roi_step = 0;
guint button_now;

void roi_proc(GtkWidget *widget, GdkEventButton *event)
{
  u_short nowx,nowy;
  char str[100];
  double distance;
  int ret;

  if(img==NULL) return;
  if(roi_draw_flag==0) return;

  nowx = event->x + canvas_origin_x;
  nowy = event->y + canvas_origin_y;
  button_now = event->button;
  if((roi_step == 0)&&(button_now==Button1)){
    ret = get_img_no(nowx,nowy);
    if(ret==END_IMAGE){
      return;
    }
    curr_img_roi = ret;
    sprintf(str,"ROI at image no. %d",image_cell[curr_img_roi]->img_no);
    put_string(str,0);
    roi_step = 1;
    clear_rec();
    roi_draw(0,nowx,nowy);
  }
  oldx = nowx;
  oldy = nowy;
  if(roi_flag!=POLYGON&&roi_flag!=DISTANCE&&roi_flag!=PICKP&&roi_flag!=FINDEDGE){
    return;
  }
  if(button_now==Button1){
    figure.points[figure.pnum].x = oldx - image_cell[curr_img_roi]->r_left;
    figure.points[figure.pnum].y = oldy - image_cell[curr_img_roi]->r_top;
    figure.pnum++;
    clear_rec();
    roi_draw(button_now,0,0);
    if(roi_flag==DISTANCE&&figure.pnum==2){
      distance = (figure.points[0].x - figure.points[1].x)*(figure.points[0].x - figure.points[1].x)/zoom_factor/zoom_factor*pixel_yoko*pixel_yoko + (figure.points[0].y - figure.points[1].y)*(figure.points[0].y - figure.points[1].y)/zoom_factor/zoom_factor*pixel_tate*pixel_tate;
      distance = sqrt(distance);
      sprintf(str,"distance %g",distance);
      put_string(str,0);
      figure.pnum = 0;
    }
    if(roi_flag==PICKP&&figure.pnum==1){
      sprintf(str,"Point x = %f y = %f    %g",figure.points[0].x/zoom_factor,figure.points[0].y/zoom_factor,img->scalefactor*pick_point(figure.points[0].x,figure.points[0].y));
      put_string(str,0);
      figure.pnum = 0;
      roi_step = 0;
    }
    if(roi_flag==FINDEDGE){
      gushort x1,y1,xd,yd;
      x1 = nowx - image_cell[curr_img_roi]->r_left;
      y1 = nowy - image_cell[curr_img_roi]->r_top;
      xd = (short)image_cell[curr_img_roi]->r_width;
      yd = (short)image_cell[curr_img_roi]->r_height;
      figure.pnum = 0;
      ret = find_edge_loop(&x1,&y1,&xd,&yd);
    }
  }
  if(button_now==Button3){
    if(roi_flag==POLYGON){
      if(figure.pnum!=0){
	figure.pnum--;
      }
      if(Close == 1) Close = 0;
    }
    else{/* DISTANCE */
      sprintf(str,"X %d Y %d",oldx - image_cell[curr_img_roi]->r_left,z_ydim - (oldy - image_cell[curr_img_roi]->r_top));
      put_string(str,0);
    }
    clear_rec();
    roi_draw(button_now,0,0);
  }
  if(button_now==Button2){
    if(roi_flag==POLYGON){
      Close = 1;
      clear_rec();
      roi_draw(button_now,0,0);
    }
  }
  redraw_canvas();
}

void drag(GtkWidget *widget, GdkEventMotion *event)
{
  u_short nowx,nowy;

  if(event->state==0) return;/* no button is pressed */
  if(roi_draw_flag==0) return;
  nowx = event->x + canvas_origin_x;
  nowy = event->y + canvas_origin_y;

  if((roi_step == 1)&&(button_now==Button1)){
    clear_rec();
    roi_draw(button_now,nowx,nowy);
  }
  if((roi_step == 1)&&(button_now==Button2)){
    clear_rec();
    roi_draw(button_now,(oldx - nowx)/2,(oldy - nowy)/2);
  }
  if((roi_step == 1)&&(button_now==Button3)){
    if(roi_flag==POLYGON){
      figure.pnum--;
    }
    clear_rec();
    roi_draw(button_now,(oldx - nowx),(oldy - nowy));
  }
  redraw_canvas();
}
void clear_rec()
{
  gdk_window_copy_area(pet_canvas->window,canvasGC,image_cell[curr_img_roi]->r_left,image_cell[curr_img_roi]->r_top,canvas_pixmap,image_cell[curr_img_roi]->r_left,image_cell[curr_img_roi]->r_top,image_cell[curr_img_roi]->r_width, image_cell[curr_img_roi]->r_height);
}

void roi_set_proc()
{
  roi_calc();
  roi_out();
  roi_step = 0;
  pre_x = 0; /* we don't delete calculated ROI */
}

/* Roi extract from image 6/12/96 */
void roi_ext_set_proc()
{
  roi_ext();
  roi_step = 0;
}

void roi_next_proc()
{
  char str[25];

  roi_step = 0;
  if(pre_x!=0){/* delete previous ROI */
    delete_pre_roi(roi_flag);
  }
  pre_x = 0;
  clear_rec();
    
  curr_img_roi++;
  if(curr_img_roi>last_img_no){
    curr_img_roi = 0;
  }
  if(image_cell[curr_img_roi]->img_no==END_IMAGE){
    curr_img_roi = 0;
  }
  sprintf(str,"ROI at image no. %d",image_cell[curr_img_roi]->img_no);
  put_string(str,0);

/* if already user draw roi we use previous roi figure*/
  if(roi_num!=0){
    roi_step = 1;
    clear_rec();
    roi_draw(1,image_cell[curr_img_roi]->r_left + figure.center.x,image_cell[curr_img_roi]->r_top + figure.center.y);
    redraw_canvas();
  }

}
/* when you enter ROI no */
void roi_no_spec_proc(int roi_no)
{
  char str[25];

  roi_step = 0;
  if(pre_x!=0){/* delete previous ROI */
    delete_pre_roi(roi_flag);
  }
  pre_x = 0;
  clear_rec();
    
  /* search the plane */
  curr_img_roi = 0;
  while(image_cell[curr_img_roi]->img_no!=END_IMAGE){
    if(image_cell[curr_img_roi]->img_no==roi_no){
      break;
    }
    curr_img_roi++;
  }
  if(curr_img_roi>last_img_no){
    curr_img_roi = 0;
  }
  if(image_cell[curr_img_roi]->img_no==END_IMAGE){
    curr_img_roi = 0;
  }
  sprintf(str,"ROI at image no. %d",image_cell[curr_img_roi]->img_no);
  put_string(str,0);

/* if already user draw roi we use previous roi figure*/
  if(roi_num!=0){
    roi_step = 1;
    clear_rec();
    roi_draw(1,image_cell[curr_img_roi]->r_left + figure.center.x,image_cell[curr_img_roi]->r_top + figure.center.y);
    redraw_canvas();
  }
}

/* Procedure when click Backword button */
void roi_backword_proc()
{
  char str[25];

  roi_step = 0;
  if(pre_x!=0){/* delete previous ROI */
    delete_pre_roi(roi_flag);
  }
  pre_x = 0;
  clear_rec();
  if(curr_img_roi==0){
    curr_img_roi = last_img_no - 1;
  }
  else{
    curr_img_roi--;
  }
  sprintf(str,"ROI at image no. %d",image_cell[curr_img_roi]->img_no);
  put_string(str,0);

/* if already user draw roi we use previous roi figure*/
  if(roi_num!=0){
    roi_step = 1;
    clear_rec();
    roi_draw(1,image_cell[curr_img_roi]->r_left + figure.center.x,image_cell[curr_img_roi]->r_top + figure.center.y);
    redraw_canvas();
  }

}

/* output results of roi calculation */
void roi_out()
{
  char str[256];
  guint length;
  GtkWidget *roi_info_text;

  roi_info_text = lookup_widget(roi_info_window,"roi_info_text");
  sprintf(str,"ROI No. %d Area is %d average %g S.D. %g Max %g Min %g\n",roi_num,(roi_head.roires).area, (roi_head.roires).average*(roi_head.roires).factor, (roi_head.roires).sd*(roi_head.roires).factor,(roi_head.roires).pmax*(roi_head.roires).factor, (roi_head.roires).pmin*(roi_head.roires).factor);
  length = strlen(str);
  gtk_text_insert(GTK_TEXT(roi_info_text),NULL,NULL,NULL,str,length);
}

void save_roi_info()
{
  GtkWidget *roi_info;
  gchar *roitext;
  GtkWidget *entry;
  FILE *fp;

  roi_info = lookup_widget(roi_info_window,"roi_info_text");
  roitext = gtk_editable_get_chars(GTK_EDITABLE(roi_info),0,-1);
  entry = lookup_widget(roi_info_window,"roi_info_entry");
  fp = fopen(gtk_entry_get_text(GTK_ENTRY(entry)),"wt");
  fwrite(roitext,strlen(roitext),1,fp);
  fclose(fp);

}
