/* Copyright 2000,2001 Hiroshi Watabe*/
/* save image file*/
/* $Id: save_file.c,v 1.2 2001/05/08 02:22:28 watabe Exp $ */
#include "gpetview.h"
#include "support.h"

void save_file_proc()
{
  char *str = NULL;
  char *string;
  unsigned int n_from, n_to;
  u_int length;
  GtkWidget *file_from_entry,*file_to_entry,*file_entry;
  char tmp_char[255];

  n_from = n_to = 0;
  file_entry = lookup_widget(filewindow,"file_entry");
  string = gtk_entry_get_text(GTK_ENTRY(file_entry));
  length = strlen(string);
  if(length==0) return;
  str = (char *)realloc(str,length + 1);
  strcpy(str,string);
  file_from_entry = lookup_widget(filewindow,"file_from_entry");
  string = gtk_entry_get_text(GTK_ENTRY(file_from_entry));
  if(strlen(string)==0){
    sprintf(tmp_char,"Please give slice number");
    put_string(tmp_char,0);
    return;
  }
  n_from = (unsigned int)atoi(string);
  file_to_entry = lookup_widget(filewindow,"file_to_entry");
  string = gtk_entry_get_text(GTK_ENTRY(file_to_entry));
  if(strlen(string)==0){
    sprintf(tmp_char,"Please give slice number");
    put_string(tmp_char,0);
    return;
  }
  n_to = (unsigned int)atoi(string);

  if(n_from>n_to){
    sprintf(tmp_char,"Invalid image numbers");
    put_string(tmp_char,0);
    return;
  }
  if(n_to>zdim){
    sprintf(tmp_char,"Invalid image numbers");
    put_string(tmp_char,0);
    return;
  }
  if(n_to==0){
    n_to = zdim;
  }
  if(n_from==0) n_from = 1;

  if(write_image(img,n_from,n_to,str)==-1){
    sprintf(tmp_char,"image does not exist");
  }
}

int write_image(frame, from, to, filename)
FRSTR *frame;
int from, to;
char *filename;
{
  struct dsr hdr;
  FILE *fp;
  unsigned long base,size;
  char tmp_char[255];

  if (is_null_frame(frame, "writeframe"))
    return(-1);

  strcpy(tmp_char,(char *)header_name(filename));
  fp = fopen(tmp_char, "wb");
  bcopy((char *)frame->hdr, (char *)(&hdr), sizeof(hdr));

  hdr.dime.dim[3] = to - from + 1;
  if(need_swap_flag==1){
    exchange_hdr(&hdr);
  }
  fwrite(&hdr,1,sizeof(hdr),fp);
  fclose(fp);
  strcpy(tmp_char,(char *)image_name(filename));
  fp = fopen(tmp_char, "wb");
  base = (from - 1)*xdim*ydim;
  size = (to - from + 1)*xdim*ydim;
  fwrite((img->dat + base),1,size,fp);
  fclose(fp);
  return(0);
}
