/* Copyright 2000,2001 Hiroshi Watabe*/
/* Save and Load ROI data file */
/* $Id: save_roi.c,v 1.5 2001/08/06 23:04:33 watabe Exp $ */
#include "gpetview.h"
#include "support.h"

void save_roi_proc()
{
  char *str;
  char st[100],st2[100];
  u_short n_from,n_to,i;
  FILE *fp,*fp2;
  ROIINFO roi_info;
  GtkWidget *roi_file_entry;
  GtkWidget *roi_no_from_entry;
  GtkWidget *roi_no_to_entry;

  roi_file_entry = lookup_widget(roiwindow,"roi_file_entry");
  str =  gtk_entry_get_text(GTK_ENTRY(roi_file_entry));
  if(strlen(str)==0){return;}
  roi_no_from_entry = lookup_widget(roiwindow,"roi_no_from_entry");
  n_from = atoi(gtk_entry_get_text(GTK_ENTRY(roi_no_from_entry)));
  roi_no_to_entry = lookup_widget(roiwindow,"roi_no_to_entry");
  n_to = atoi(gtk_entry_get_text(GTK_ENTRY(roi_no_to_entry)));

  if(n_from==0) n_from = 1;
  if(n_to==0) n_to = roi_num;
  for(i=n_from;i<=n_to;i++){
    if(i>roi_num) break;
    sprintf(st,"/tmp/roi.%d",i);
    sprintf(st2,"%s.roi%d",str,i);
    fp = fopen(st,"rb");
    fp2 = fopen(st2,"wb");
    fread(&roi_info,sizeof(roi_info),1,fp);
    fwrite(&roi_info,sizeof(roi_info),1,fp2);
    fclose(fp);
    fclose(fp2);
  }
}

void load_roi_proc()
{
  char *str,*str2;
  char st[100],st2[100];
  u_short n_from,n_to,i,j;
  FILE *fp;
  ROIINFO roi_info;
  GtkWidget *roi_file_entry;
  GtkWidget *roi_no_from_entry;
  GtkWidget *roi_no_to_entry;

  roi_file_entry = lookup_widget(roiwindow,"roi_file_entry");
  str =  gtk_entry_get_text(GTK_ENTRY(roi_file_entry));
  if(strlen(str)==0){return;}
  roi_no_from_entry = lookup_widget(roiwindow,"roi_no_from_entry");
  str2 =  gtk_entry_get_text(GTK_ENTRY(roi_no_from_entry));
  n_from = atoi(str2);
  roi_no_to_entry = lookup_widget(roiwindow,"roi_no_to_entry");
  str2 =  gtk_entry_get_text(GTK_ENTRY(roi_no_to_entry));
  n_to = atoi(str2);

  if(n_from==0||n_to==0){
    sprintf(st2,"Please specify from and to region!!");
    put_string(st2,0);
    return;
    }
  for(i=n_from,j=roi_num+1;i<=n_to;i++,j++){
    sprintf(st2,"%s.roi%d",str,i);
    if((fp=fopen(st2,"rb"))==NULL){
      sprintf(st,"Cannot find file %s!!",st2);
      put_string(st,0);
      continue;
    }
    fread(&roi_info,sizeof(roi_info),1,fp);
    if(roi_info.figure.type>1000){/* we need swap */
      swap_roi_info(&roi_info);
    }
    if(roi_info.orient!=seq_flag){
      sprintf(st,"Orientation of Image is different in Roi %d!!",i);
      put_string(st,0);
      fclose(fp);
      continue;
    }
    if(roi_info.zoom!=zoom_factor){
      sprintf(st,"Please use Zooming factor %g!!",roi_info.zoom);
      put_string(st,0);
      fclose(fp);
      continue;
    }
    if(roi_info.revy_flag>1) roi_info.revy_flag=1; /* old ROI file doens't have revy_flag */
    if(roi_info.revy_flag!=revy_flag){
      sprintf(st,"Switch Reverse Y");
      put_string(st,0);
      fclose(fp);
      continue;
    }
    for(j=0;j<num_max_image;j++){
      if(image_cell[j]->img_no==END_IMAGE){
	sprintf(st,"Cannot find image number in Roi %d!!",i);
	put_string(st,0);
	//	fclose(fp);
	break;
      }
      if(roi_info.img_no == image_cell[j]->img_no){
	roi_flag = roi_info.figure.type;
	if(roi_flag==POLYGON) Close = 1;
	memcpy(&figure,&(roi_info.figure),sizeof(figure));
	curr_img_roi = j;
	roi_draw_flag = 1;
	roi_calc();
	roi_out();
	break;
      }
    }
    fclose(fp);
  }

}

void swap_roi_info(ROIINFO *roi_info)
{
  ROIINFO local_roi_info;
  int i;

  memcpy(&local_roi_info,roi_info,sizeof(ROIINFO));
  roi_info->img_no = swap_short(local_roi_info.img_no);
  roi_info->zoom = swap_float(local_roi_info.zoom);
  roi_info->figure.type = swap_int(local_roi_info.figure.type);
  roi_info->figure.center.x = swap_short(local_roi_info.figure.center.x);
  roi_info->figure.center.y = swap_short(local_roi_info.figure.center.y);
  roi_info->figure.la = swap_int(local_roi_info.figure.la);
  roi_info->figure.sa = swap_int(local_roi_info.figure.sa);
  roi_info->figure.degree = swap_float(local_roi_info.figure.degree);
  roi_info->figure.pnum = swap_int(local_roi_info.figure.pnum);
  for(i=0;i<roi_info->figure.pnum;i++){
    roi_info->figure.points[i].x = swap_short(local_roi_info.figure.points[i].x);
    roi_info->figure.points[i].y = swap_short(local_roi_info.figure.points[i].y);
  }
}
