/* Copyright 2000,2001 Hiroshi Watabe*/
/* define screen format */
/* $Id: sc_format.c,v 1.4 2001/09/16 14:25:15 watabe Exp $ */
#include "gpetview.h"

extern unsigned char seq_flag;
extern float zoom_factor;
extern float pxdim,pydim,pzdim; /* Pixel size 8/5/96 watabe instroduce for measureing distance */

/*	Define	Screen	Format	*/
ImageRectPointer *image_cell=NULL;
gint num_max_image; /* how many image will be displayed. */
unsigned int z_xdim, z_ydim, z_zdim; /* after zooming */
char *Image=NULL;
float pixel_yoko,pixel_tate; /* pixel size */

void sc_format(xdim,ydim,zdim)
unsigned int     xdim, ydim, zdim;
{
  int   i,j,k,now_x,now_y, now_z;

  if(Curr_imgno==0||new_img_flag==1){/* if not, format has been already defined */
    z_xdim = xdim*zoom_factor;
    z_ydim = ydim*zoom_factor;
    z_zdim = zdim*zoom_factor;

    if(seq_flag==TRANS){
      now_x = (short)(canvas_width/z_xdim);
      now_y = (short)(canvas_height/z_ydim);
      pixel_yoko = pxdim;
      pixel_tate = pydim;
      num_max_image = now_x*now_y;
      image_cell = (ImageRectPointer *)realloc(image_cell,(int)(sizeof(ImageRectPointer)*(num_max_image + 1)));
      memset(image_cell, 0, (int)(sizeof(ImageRectPointer)*(num_max_image + 1)));
      for(i=0;i<num_max_image + 1;i++){
	image_cell[i] = (ImageRect *)realloc(image_cell[i],sizeof(ImageRect));
      }
      for(j=0;j<now_y;j++){
	for(k=0;k<now_x;k++){
	  image_cell[k + j*now_x]->img_no = k + j*now_x;
	  image_cell[k + j*now_x]->r_left = k*z_xdim;
	  image_cell[k + j*now_x]->r_top = j*z_ydim;
	  image_cell[k + j*now_x]->r_width = z_xdim;
	  image_cell[k + j*now_x]->r_height = z_ydim;
	}
      }
    }
    else{
      if(seq_flag==CORO){
	now_x = (short)(canvas_width/z_xdim);
	now_z = (short)(canvas_height/z_zdim);
	pixel_yoko = pxdim;
	pixel_tate = pzdim;
	num_max_image = now_x*now_z;
	image_cell = (ImageRectPointer *)realloc(image_cell,(int)(sizeof(ImageRectPointer)*(num_max_image + 1)));
	memset(image_cell, 0, (int)(sizeof(ImageRectPointer)*(num_max_image + 1)));
	for(i=0;i<num_max_image + 1;i++){
	  image_cell[i] = (ImageRect *)realloc(image_cell[i],sizeof(ImageRect));
	}
	for(j=0;j<now_z;j++){
	  for(k=0;k<now_x;k++){
	    image_cell[k + j*now_x]->img_no = k + j*now_x;
	    image_cell[k + j*now_x]->r_left = k*z_xdim;
	    image_cell[k + j*now_x]->r_top = j*z_zdim;
	    image_cell[k + j*now_x]->r_width = z_xdim;
	    image_cell[k + j*now_x]->r_height = z_zdim;
	  }
	}
      }
      else{
	if(seq_flag==SAGI){
	  now_y = (short)(canvas_width/z_ydim);
	  now_z = (short)(canvas_height/z_zdim);
	  pixel_yoko = pzdim;
	  pixel_tate = pydim;
	  num_max_image = now_y*now_z;
	  image_cell = (ImageRectPointer *)realloc(image_cell,(int)(sizeof(ImageRectPointer)*(num_max_image + 1)));
	  memset(image_cell, 0, (int)(sizeof(ImageRectPointer)*(num_max_image + 1)));
	  for(i=0;i<num_max_image + 1;i++){
	    image_cell[i] = (ImageRect *)realloc(image_cell[i],sizeof(ImageRect));
	  }
	  for(j=0;j<now_z;j++){
	    for(k=0;k<now_y;k++){
	      image_cell[k + j*now_y]->img_no = k + j*now_y;
	      image_cell[k + j*now_y]->r_left = k*z_ydim;
	      image_cell[k + j*now_y]->r_top = j*z_zdim;
	      image_cell[k + j*now_y]->r_width = z_ydim;
	      image_cell[k + j*now_y]->r_height = z_zdim;
	    }
	  }
	}
      }
    }
  }

  if(seq_flag==TRANS)  get_imgno(zdim);
  else{
    if(seq_flag==CORO)  get_imgno(ydim);
    else{
      if(seq_flag==SAGI)  get_imgno(xdim);
    }
  }
  /* allocate memory for image */
  Image = (char *)realloc(Image,z_xdim*z_ydim);
}

int get_img_no(gushort nowx,gushort nowy)
{
  int i;

  for(i=0;i<num_max_image;i++){
    if(image_cell[i]->img_no== END_IMAGE){
      return END_IMAGE;
    }
    if(image_cell[i]->r_left<nowx&&image_cell[i]->r_top<nowy&&(image_cell[i]->r_left+image_cell[i]->r_width)>nowx&&(image_cell[i]->r_top + image_cell[i]->r_height)>nowy){
      return i;
    }
  }
  return END_IMAGE;
}
