/* Copyright 2000,2001 Hiroshi Watabe */
/* $Id: view.c,v 1.8 2001/09/16 06:05:08 watabe Exp $ */
#include "gpetview.h"
#include "support.h"

gint Curr_imgno = 0; /* current image no */
gint Pre_imgno = 0; /* current image no */
float pre_zoom_factor = 1.0;
unsigned char pre_seq_flag = TRANS;
gushort curr_img_roi = 0;
gushort img_page = 0; /* Page number for image */
guchar pipe_flag = 0;

char pre_fname[1024];
FRSTR *img = NULL;
guchar view_flag = 0; /* are there images on screen */
gushort xdim, ydim, zdim;
float pxdim,pydim,pzdim; /* Pixel size 8/5/96 watabe instroduce for measureing distance */
guchar new_img_flag = 0;  /* is this image is new image or not? */

void put_string(char *str,int flag)
{
  GtkWidget *message_entry;
  char *tmpc;
  char *message;

  message_entry = lookup_widget(gpetview,"message_entry");
  if(flag==0){
    gtk_entry_set_text(GTK_ENTRY(message_entry),str);
  }
  else{
    tmpc = gtk_entry_get_text(GTK_ENTRY(message_entry));
    gtk_entry_set_text(GTK_ENTRY(message_entry),str);
    message =(char *)g_malloc(256);
    sprintf(message,"%s %s",tmpc,str);
    gtk_entry_set_text(GTK_ENTRY(message_entry),message);
    g_free(message);
  }
}

/* assign file name and create img structure */
void set_filename(void)
{
  char message[256];

  if(!streq(pre_fname,fname)){
    now_seq = 1; /* reset now_seq */
    new_img_flag = 1;
    if(import_flag==0){
      if((img = (FRSTR *)tobyte(setmaxmin(getframe(fname, 1)))) == (FRSTR *)0){
	sprintf(message,"unable to open file %s",fname);
	put_string(message, 0);
	return;
      }
    }
  }
  strcpy(pre_fname,fname);
}

void view_proc()
{
  char str[255];
  guint i;

  if(pipe_flag!=0){/* input from pipe */
    if((img = (FRSTR *)tobyte(setmaxmin(getpipe()))) == (FRSTR *)0){
      sprintf(str,"unable to open pipe");
      put_string(str, 0);
      return;
    }
    pipe_flag = 0;
  }
  else{
    if(img==NULL){
      return;
    }
  }
  /* make title */
  if(fname==NULL){
    gtk_window_set_title(GTK_WINDOW(gpetview),"Image from Pipe");
  }
  else{
    gtk_window_set_title(GTK_WINDOW(gpetview),fname);
  }
  xdim = img->hdr->dime.dim[1];
  ydim = img->hdr->dime.dim[2];
  zdim = img->hdr->dime.dim[3];
  pxdim = img->hdr->dime.pixdim[1];
  pydim = img->hdr->dime.pixdim[2];
  pzdim = img->hdr->dime.pixdim[3];

  get_parameters();
  if(color_flag == LKUP_COLOR){
    draw_colorbar();
  }
  if((pre_zoom_factor!=zoom_factor)||(pre_seq_flag!=seq_flag)){
    Curr_imgno = 0; /* If user change parameter, initialize current img no */
    curr_img_roi = 0;
    now_seq = 1;
  }
  pre_zoom_factor = zoom_factor;
  pre_seq_flag = seq_flag;

  Pre_imgno = Curr_imgno;
  sc_format(xdim, ydim, zdim);

  for(i=Pre_imgno;i<Curr_imgno;i++){
    draw_image(readplane(img,xdim,ydim,zdim, image_cell[i]->img_no), xdim, ydim, zdim, i);
  }
  if(Curr_imgno == num_max_image){
    Curr_imgno = 0;
  }
  view_flag = 1;

}
